
/*
 * THIS FILE WAS GENERATED BY PDL::PP! Do not modify!
 */

#define PDL_COMMENT(comment)
PDL_COMMENT("This preprocessor symbol is used to add commentary in the PDL  ")
PDL_COMMENT("autogenerated code. Normally, one would use typical C-style    ")
PDL_COMMENT("multiline comments (i.e. /* comment */). However, because such ")
PDL_COMMENT("comments do not nest, it's not possible for PDL::PP users to   ")
PDL_COMMENT("comment-out sections of code using multiline comments, as is   ")
PDL_COMMENT("often the practice when debugging, for example. So, when you   ")
PDL_COMMENT("see something like this:                                       ")
PDL_COMMENT("                                                               ")
                PDL_COMMENT("Memory access")
PDL_COMMENT("                                                               ")
PDL_COMMENT("just think of it as a C multiline comment like:                ")
PDL_COMMENT("                                                               ")
PDL_COMMENT("   /* Memory access */                                         ")

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "pdl.h"
#include "pdlcore.h"
static Core* PDL; PDL_COMMENT("Structure hold core C functions")
static int __pdl_debugging = 0;
static int __pdl_boundscheck = 0;
static SV* CoreSV;       PDL_COMMENT("Gets pointer to perl var holding core structure")

#if ! 1
# define PP_INDTERM(max, at) at
#else
# define PP_INDTERM(max, at) (__pdl_boundscheck? PDL->safe_indterm(max,at, __FILE__, __LINE__) : at)
#endif


#include <math.h>

/*#define DEBUG_ALPHA*/
/*#define DEBUG_BETA*/
/*#define DEBUG_VITERBI*/


/* logadd(x,y) = log(exp(x)+exp(y))
 *   + Code from Manning & Schtze (1997), Sec. 9.4, page 337
 *
 * LOG_BIG = log(1E31)
 */
#define LOG_BIG    71.3801378828154
#define LOG_ZERO  -1E+38
#define LOG_ONE    0
#define LOG_NONE   1
double logadd1(double x, double y) {
  if      (y-x > LOG_BIG) return y;
  else if (x-y > LOG_BIG) return x;
  /*else        return min(x,y) + log(exp(x-min(x,y)) + exp(y-min(x,y))); */
  else if (x<y) return x        + log( 1              + exp(y-x));
  else          return y        + log(exp(x-y)        + 1);
}
double logadd0(double x, double y) {
  return log(exp(x)+exp(y));
}

/* logdiff(x,y) = log(exp(x)-exp(y))
 *   + adapted from above
 *   + always returns positive (i.e. symmetric difference)
 */
double logdiff1(double x, double y) {
  if      (y-x > LOG_BIG) { return y; }
  else if (x-y > LOG_BIG) { return x; }
  /*else        { return max(x,y) + log(exp(max(x,y)-max(x,y)) - exp(min(x,y)-max(x,y))); } */
  /*                   = max(x,y) + log( 1 - exp(min(x,y)-max(x,y))); } */
  else if (x>y) { return x        + log( 1 - exp(y-x)); }
  else          { return y        + log( 1 - exp(x-y)); }
}
double logdiff0(double x, double y) {
  return log(x>y ? (exp(x)-exp(y)) : (exp(y)-exp(x)));
}

/*
#define logadd(x,y) logadd0(x,y)
#define logdiff(x,y) logdiff0(x,y)
*/

#define logadd(x,y) logadd1(x,y)
#define logdiff(x,y) logdiff1(x,y)

typedef struct pdl_logzero_struct {
		PDL_TRANS_START(1);
		pdl_thread  __pdlthread;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_logzero_struct;

void pdl_logzero_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_logzero_struct *__privtrans = (pdl_logzero_struct *) __tr;
	
	{
	    PDL_Indx __creating[1];
__creating[0] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[0]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);

{
PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);

{
PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);

{
PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);

{
PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);

{
PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);

{
PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);

{
PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));
	PDL_Double   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Double, a_anyval_badval);

{
PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a"};
		static PDL_Indx __realdims[] = {0};
		static char __funcname[] = "PDL::HMM::logzero";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 1
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,1,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
if(!__creating[0]) {
} else {
 PDL_Indx dims[1]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")
 PDL->thread_create_parameter(&__privtrans->__pdlthread,0,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	 !__creating[0] && 
     __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[0]->hdrsv != hdrp ){
	 if( __privtrans->pdls[0]->hdrsv && __privtrans->pdls[0]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[0]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[0]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[0]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
 __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_logzero_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_logzero_struct *__privtrans = (pdl_logzero_struct *) __tr;
	
	{
	    pdl_logzero_struct *__copy = malloc(sizeof(pdl_logzero_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_logzero_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_logzero_struct *__privtrans = (pdl_logzero_struct *) __tr;
	
	{
	    {PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	a_datap += __offsp[0];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(a_datap)[0] PDL_COMMENT("ACCESS()")  = LOG_ZERO;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	a_datap += __offsp[0];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(a_datap)[0] PDL_COMMENT("ACCESS()")  = LOG_ZERO;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	a_datap += __offsp[0];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(a_datap)[0] PDL_COMMENT("ACCESS()")  = LOG_ZERO;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	a_datap += __offsp[0];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(a_datap)[0] PDL_COMMENT("ACCESS()")  = LOG_ZERO;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	a_datap += __offsp[0];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(a_datap)[0] PDL_COMMENT("ACCESS()")  = LOG_ZERO;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	a_datap += __offsp[0];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(a_datap)[0] PDL_COMMENT("ACCESS()")  = LOG_ZERO;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));
	PDL_Float   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Float, a_anyval_badval);


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	a_datap += __offsp[0];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(a_datap)[0] PDL_COMMENT("ACCESS()")  = LOG_ZERO;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));
	PDL_Double   a_badval = 0;
	PDL_Anyval  a_anyval_badval = PDL->get_pdl_badvalue((__privtrans->pdls[0]));
	ANYVAL_TO_CTYPE(a_badval, PDL_Double, a_anyval_badval);


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	a_datap += __offsp[0];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(a_datap)[0] PDL_COMMENT("ACCESS()")  = LOG_ZERO;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_logzero_free(pdl_trans *__tr ) {
	int __dim;
	pdl_logzero_struct *__privtrans = (pdl_logzero_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;
			}
			
	}
    }
    



static char pdl_logzero_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_logzero_vtable = {
		0,0, 0, 1, pdl_logzero_vtable_flags,
		pdl_logzero_redodims, pdl_logzero_readdata, NULL,
		pdl_logzero_free,NULL,NULL,pdl_logzero_copy,
		sizeof(pdl_logzero_struct),"pdl_logzero_vtable"
	 };

typedef struct pdl_logadd_struct {
		PDL_TRANS_START(3);
		pdl_thread  __pdlthread;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_logadd_struct;

void pdl_logadd_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_logadd_struct *__privtrans = (pdl_logadd_struct *) __tr;
	
	{
	    PDL_Indx __creating[3];
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[2]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * c_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * c_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * c_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * c_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * c_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * c_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * c_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * c_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * c_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * c_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * c_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * c_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * c_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * c_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * c_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * c_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b","c"};
		static PDL_Indx __realdims[] = {0,0,0};
		static char __funcname[] = "PDL::HMM::logadd";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 3
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,3,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
if(!__creating[2]) {
} else {
 PDL_Indx dims[1]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")
 PDL->thread_create_parameter(&__privtrans->__pdlthread,2,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[2] && 
     __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[2]->hdrsv != hdrp ){
	 if( __privtrans->pdls[2]->hdrsv && __privtrans->pdls[2]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[2]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[2]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[2]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
 __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_logadd_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_logadd_struct *__privtrans = (pdl_logadd_struct *) __tr;
	
	{
	    pdl_logadd_struct *__copy = malloc(sizeof(pdl_logadd_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_logadd_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_logadd_struct *__privtrans = (pdl_logadd_struct *) __tr;
	
	{
	    {PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * c_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * c_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logadd((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * c_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * c_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logadd((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * c_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * c_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logadd((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * c_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * c_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logadd((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * c_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * c_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logadd((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * c_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * c_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logadd((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * c_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * c_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logadd((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * c_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * c_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logadd((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_logadd_free(pdl_trans *__tr ) {
	int __dim;
	pdl_logadd_struct *__privtrans = (pdl_logadd_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;
			}
			
	}
    }
    



static char pdl_logadd_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_logadd_vtable = {
		0,0, 2, 3, pdl_logadd_vtable_flags,
		pdl_logadd_redodims, pdl_logadd_readdata, NULL,
		pdl_logadd_free,NULL,NULL,pdl_logadd_copy,
		sizeof(pdl_logadd_struct),"pdl_logadd_vtable"
	 };

typedef struct pdl_logdiff_struct {
		PDL_TRANS_START(3);
		pdl_thread  __pdlthread;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_logdiff_struct;

void pdl_logdiff_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_logdiff_struct *__privtrans = (pdl_logdiff_struct *) __tr;
	
	{
	    PDL_Indx __creating[3];
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[2]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * c_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * c_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * c_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * c_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * c_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * c_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * c_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * c_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * c_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * c_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * c_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * c_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * c_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * c_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * c_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * c_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

{
PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b","c"};
		static PDL_Indx __realdims[] = {0,0,0};
		static char __funcname[] = "PDL::HMM::logdiff";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 3
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,3,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
if(!__creating[2]) {
} else {
 PDL_Indx dims[1]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")
 PDL->thread_create_parameter(&__privtrans->__pdlthread,2,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[2] && 
     __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[2]->hdrsv != hdrp ){
	 if( __privtrans->pdls[2]->hdrsv && __privtrans->pdls[2]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[2]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[2]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[2]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
 __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_logdiff_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_logdiff_struct *__privtrans = (pdl_logdiff_struct *) __tr;
	
	{
	    pdl_logdiff_struct *__copy = malloc(sizeof(pdl_logdiff_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_logdiff_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_logdiff_struct *__privtrans = (pdl_logdiff_struct *) __tr;
	
	{
	    {PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * c_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * c_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logdiff((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * c_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * c_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logdiff((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * c_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * c_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logdiff((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * c_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * c_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logdiff((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * c_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * c_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logdiff((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * c_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * c_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logdiff((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * c_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * c_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logdiff((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * c_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * c_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	c_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,c_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,c_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){
(c_datap)[0] PDL_COMMENT("ACCESS()")  = logdiff((a_datap)[0] PDL_COMMENT("ACCESS()") ,(b_datap)[0] PDL_COMMENT("ACCESS()") );
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	c_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_logdiff_free(pdl_trans *__tr ) {
	int __dim;
	pdl_logdiff_struct *__privtrans = (pdl_logdiff_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;
			}
			
	}
    }
    



static char pdl_logdiff_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_logdiff_vtable = {
		0,0, 2, 3, pdl_logdiff_vtable_flags,
		pdl_logdiff_redodims, pdl_logdiff_readdata, NULL,
		pdl_logdiff_free,NULL,NULL,pdl_logdiff_copy,
		sizeof(pdl_logdiff_struct),"pdl_logdiff_vtable"
	 };

typedef struct pdl_logsumover_struct {
		PDL_TRANS_START(2);
		pdl_thread  __pdlthread;PDL_Indx  __inc_a_n;PDL_Indx  __n_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_logsumover_struct;

void pdl_logsumover_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_logsumover_struct *__privtrans = (pdl_logsumover_struct *) __tr;
	
	{
	    PDL_Indx __creating[2];
__privtrans->__n_size = -1;
__creating[0] = 0;
__creating[1] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[1]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

{register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

{register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

{register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

{register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

{register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

{register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

{register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

{register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b"};
		static PDL_Indx __realdims[] = {1,0};
		static char __funcname[] = "PDL::HMM::logsumover";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 2
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,2,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 1) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__n_size <= 1) __privtrans->__n_size = 1;
   }
   if(__privtrans->__n_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__n_size == 1)) {
      __privtrans->__n_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__n_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in logsumover:" "Wrong dims\n");
      }
   }
if(!__creating[1]) {
} else {
 PDL_Indx dims[1]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")
 PDL->thread_create_parameter(&__privtrans->__pdlthread,1,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[1] && 
     __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[1]->hdrsv != hdrp ){
	 if( __privtrans->pdls[1]->hdrsv && __privtrans->pdls[1]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[1]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[1]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[1]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_a_n = 0; else
		 __privtrans->__inc_a_n = PDL_REPRINC(__privtrans->pdls[0],0); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_logsumover_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_logsumover_struct *__privtrans = (pdl_logsumover_struct *) __tr;
	
	{
	    pdl_logsumover_struct *__copy = malloc(sizeof(pdl_logsumover_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_a_n=__copy->__inc_a_n;__copy->__n_size=__privtrans->__n_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_logsumover_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_logsumover_struct *__privtrans = (pdl_logsumover_struct *) __tr;
	
	{
	    {register PDL_Indx __n_size = __privtrans->__n_size;
PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

double sum=LOG_ZERO; {PDL_COMMENT("Open n") register PDL_Indx n;
			for(n=0; n<(__n_size); n++) { sum = logadd((a_datap)[0+(__inc_a_n*PP_INDTERM(__privtrans->__n_size, n))] PDL_COMMENT("ACCESS()") ,sum); }} PDL_COMMENT("Close n") (b_datap)[0] PDL_COMMENT("ACCESS()")  = sum;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

double sum=LOG_ZERO; {PDL_COMMENT("Open n") register PDL_Indx n;
			for(n=0; n<(__n_size); n++) { sum = logadd((a_datap)[0+(__inc_a_n*PP_INDTERM(__privtrans->__n_size, n))] PDL_COMMENT("ACCESS()") ,sum); }} PDL_COMMENT("Close n") (b_datap)[0] PDL_COMMENT("ACCESS()")  = sum;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

double sum=LOG_ZERO; {PDL_COMMENT("Open n") register PDL_Indx n;
			for(n=0; n<(__n_size); n++) { sum = logadd((a_datap)[0+(__inc_a_n*PP_INDTERM(__privtrans->__n_size, n))] PDL_COMMENT("ACCESS()") ,sum); }} PDL_COMMENT("Close n") (b_datap)[0] PDL_COMMENT("ACCESS()")  = sum;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

double sum=LOG_ZERO; {PDL_COMMENT("Open n") register PDL_Indx n;
			for(n=0; n<(__n_size); n++) { sum = logadd((a_datap)[0+(__inc_a_n*PP_INDTERM(__privtrans->__n_size, n))] PDL_COMMENT("ACCESS()") ,sum); }} PDL_COMMENT("Close n") (b_datap)[0] PDL_COMMENT("ACCESS()")  = sum;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

double sum=LOG_ZERO; {PDL_COMMENT("Open n") register PDL_Indx n;
			for(n=0; n<(__n_size); n++) { sum = logadd((a_datap)[0+(__inc_a_n*PP_INDTERM(__privtrans->__n_size, n))] PDL_COMMENT("ACCESS()") ,sum); }} PDL_COMMENT("Close n") (b_datap)[0] PDL_COMMENT("ACCESS()")  = sum;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

double sum=LOG_ZERO; {PDL_COMMENT("Open n") register PDL_Indx n;
			for(n=0; n<(__n_size); n++) { sum = logadd((a_datap)[0+(__inc_a_n*PP_INDTERM(__privtrans->__n_size, n))] PDL_COMMENT("ACCESS()") ,sum); }} PDL_COMMENT("Close n") (b_datap)[0] PDL_COMMENT("ACCESS()")  = sum;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

double sum=LOG_ZERO; {PDL_COMMENT("Open n") register PDL_Indx n;
			for(n=0; n<(__n_size); n++) { sum = logadd((a_datap)[0+(__inc_a_n*PP_INDTERM(__privtrans->__n_size, n))] PDL_COMMENT("ACCESS()") ,sum); }} PDL_COMMENT("Close n") (b_datap)[0] PDL_COMMENT("ACCESS()")  = sum;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_n = __privtrans->__inc_a_n;

double sum=LOG_ZERO; {PDL_COMMENT("Open n") register PDL_Indx n;
			for(n=0; n<(__n_size); n++) { sum = logadd((a_datap)[0+(__inc_a_n*PP_INDTERM(__privtrans->__n_size, n))] PDL_COMMENT("ACCESS()") ,sum); }} PDL_COMMENT("Close n") (b_datap)[0] PDL_COMMENT("ACCESS()")  = sum;
}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_logsumover_free(pdl_trans *__tr ) {
	int __dim;
	pdl_logsumover_struct *__privtrans = (pdl_logsumover_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;
			}
			
	}
    }
    



static char pdl_logsumover_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_logsumover_vtable = {
		0,0, 1, 2, pdl_logsumover_vtable_flags,
		pdl_logsumover_redodims, pdl_logsumover_readdata, NULL,
		pdl_logsumover_free,NULL,NULL,pdl_logsumover_copy,
		sizeof(pdl_logsumover_struct),"pdl_logsumover_vtable"
	 };

typedef struct pdl_hmmfw_struct {
		PDL_TRANS_START(5);
		pdl_thread  __pdlthread;PDL_Indx  __inc_a_N0;PDL_Indx  __inc_a_N1;PDL_Indx  __inc_b_N;PDL_Indx  __inc_b_M;PDL_Indx  __inc_pi_N;PDL_Indx  __inc_o_T;PDL_Indx  __inc_alpha_N;PDL_Indx  __inc_alpha_T;PDL_Indx  __T_size;PDL_Indx  __M_size;PDL_Indx  __N_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_hmmfw_struct;

void pdl_hmmfw_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmfw_struct *__privtrans = (pdl_hmmfw_struct *) __tr;
	
	{
	    PDL_Indx __creating[5];
__privtrans->__T_size = -1;
__privtrans->__M_size = -1;
__privtrans->__N_size = -1;
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = 0;
__creating[3] = 0;
__creating[4] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[4]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * alpha_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * alpha_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * alpha_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * alpha_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * alpha_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * alpha_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * alpha_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * alpha_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * alpha_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * alpha_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * alpha_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * alpha_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * alpha_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * alpha_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * alpha_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * alpha_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b","pi","o","alpha"};
		static PDL_Indx __realdims[] = {2,2,1,1,2};
		static char __funcname[] = "PDL::HMM::hmmfw";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 5
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,5,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 2) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[0]))->ndims < 2 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfw:" "Wrong dims\n");
      }
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[1];
   } else if(((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[1]) {
      if(((__privtrans->pdls[0]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmfw:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[1]))->ndims < 2) {
      if (((__privtrans->pdls[1]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[1]))->ndims < 2 && __privtrans->__M_size <= 1) __privtrans->__M_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[1]))->dims[0];
   } else if(((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[1]))->dims[0]) {
      if(((__privtrans->pdls[1]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfw:" "Wrong dims\n");
      }
   }
   if(__privtrans->__M_size == -1 || (((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size == 1)) {
      __privtrans->__M_size = ((__privtrans->pdls[1]))->dims[1];
   } else if(((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size != ((__privtrans->pdls[1]))->dims[1]) {
      if(((__privtrans->pdls[1]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmfw:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[2]))->ndims < 1) {
      if (((__privtrans->pdls[2]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[2]))->dims[0];
   } else if(((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[2]))->dims[0]) {
      if(((__privtrans->pdls[2]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfw:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[3]))->ndims < 1) {
      if (((__privtrans->pdls[3]))->ndims < 1 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[3]))->dims[0];
   } else if(((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size != ((__privtrans->pdls[3]))->dims[0]) {
      if(((__privtrans->pdls[3]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfw:" "Wrong dims\n");
      }
   }
if(!__creating[4]) {
   if(((__privtrans->pdls[4]))->ndims < 2) {
      if (((__privtrans->pdls[4]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[4]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[4]))->dims[0];
   } else if(((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[4]))->dims[0]) {
      if(((__privtrans->pdls[4]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfw:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[4]))->dims[1];
   } else if(((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[4]))->dims[1]) {
      if(((__privtrans->pdls[4]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmfw:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;dims[1] = __privtrans->__T_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,4,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[3]->hdrsv &&
	 (__privtrans->pdls[3]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[3]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[3]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[4] && 
     __privtrans->pdls[4]->hdrsv &&
	 (__privtrans->pdls[4]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[4]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[4]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[4]->hdrsv != hdrp ){
	 if( __privtrans->pdls[4]->hdrsv && __privtrans->pdls[4]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[4]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[4]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[4]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_a_N0 = 0; else
		 __privtrans->__inc_a_N0 = PDL_REPRINC(__privtrans->pdls[0],0);if(__privtrans->pdls[0]->ndims <= 1 || __privtrans->pdls[0]->dims[1] <= 1)
		  __privtrans->__inc_a_N1 = 0; else
		 __privtrans->__inc_a_N1 = PDL_REPRINC(__privtrans->pdls[0],1);if(__privtrans->pdls[1]->ndims <= 0 || __privtrans->pdls[1]->dims[0] <= 1)
		  __privtrans->__inc_b_N = 0; else
		 __privtrans->__inc_b_N = PDL_REPRINC(__privtrans->pdls[1],0);if(__privtrans->pdls[1]->ndims <= 1 || __privtrans->pdls[1]->dims[1] <= 1)
		  __privtrans->__inc_b_M = 0; else
		 __privtrans->__inc_b_M = PDL_REPRINC(__privtrans->pdls[1],1);if(__privtrans->pdls[2]->ndims <= 0 || __privtrans->pdls[2]->dims[0] <= 1)
		  __privtrans->__inc_pi_N = 0; else
		 __privtrans->__inc_pi_N = PDL_REPRINC(__privtrans->pdls[2],0);if(__privtrans->pdls[3]->ndims <= 0 || __privtrans->pdls[3]->dims[0] <= 1)
		  __privtrans->__inc_o_T = 0; else
		 __privtrans->__inc_o_T = PDL_REPRINC(__privtrans->pdls[3],0);if(__privtrans->pdls[4]->ndims <= 0 || __privtrans->pdls[4]->dims[0] <= 1)
		  __privtrans->__inc_alpha_N = 0; else
		 __privtrans->__inc_alpha_N = PDL_REPRINC(__privtrans->pdls[4],0);if(__privtrans->pdls[4]->ndims <= 1 || __privtrans->pdls[4]->dims[1] <= 1)
		  __privtrans->__inc_alpha_T = 0; else
		 __privtrans->__inc_alpha_T = PDL_REPRINC(__privtrans->pdls[4],1); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_hmmfw_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmfw_struct *__privtrans = (pdl_hmmfw_struct *) __tr;
	
	{
	    pdl_hmmfw_struct *__copy = malloc(sizeof(pdl_hmmfw_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_a_N0=__copy->__inc_a_N0;__privtrans->__inc_a_N1=__copy->__inc_a_N1;__privtrans->__inc_b_N=__copy->__inc_b_N;__privtrans->__inc_b_M=__copy->__inc_b_M;__privtrans->__inc_pi_N=__copy->__inc_pi_N;__privtrans->__inc_o_T=__copy->__inc_o_T;__privtrans->__inc_alpha_N=__copy->__inc_alpha_N;__privtrans->__inc_alpha_T=__copy->__inc_alpha_T;__copy->__T_size=__privtrans->__T_size;__copy->__M_size=__privtrans->__M_size;__copy->__N_size=__privtrans->__N_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_hmmfw_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmfw_struct *__privtrans = (pdl_hmmfw_struct *) __tr;
	
	{
	    {register PDL_Indx __N_size = __privtrans->__N_size;
PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * alpha_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * alpha_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	alpha_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,alpha_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,alpha_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

   #ifdef DEBUG_ALPHA
   printf("INIT: j=%u,t=0,o=%d:  pi(j=%u)=%.2e  b(j=%u,o=%d)=%.2e  alpha(j=%u,t=0)=%.2e\n",
	  n,o_tp1,
	  n,      exp((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ),
	  n,o_tp1 exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	  n,      exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") )
	 );
   #endif
 }} PDL_COMMENT("Close N")

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: state_(t+1)==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     PDL_Byte alpha_j_tp1 = (PDL_Byte)LOG_ZERO;


     /*-- Loop: state_t==i --*/
     for (i=0; i<__privtrans->__N_size; i++) {
       alpha_j_tp1 = logadd( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("i=%u,j=%u,t=%u,o=%d:  alpha(i=%u,t=%u)=%.2e  a(i=%u,j=%u)=%.2e  b(j=%u,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       i,j,t,o_tp1,
	       i,t,     exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	       j,o_tp1, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	       exp( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ), exp(alpha_j_tp1));
       #endif
     }

     /*-- Storage: alpha(time=t+1, state=j) --*/
     (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

     #ifdef DEBUG_ALPHA
      printf("----> alpha(j=%u,t=%u)=%.2E\n", j,t+1, exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	alpha_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * alpha_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * alpha_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	alpha_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,alpha_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,alpha_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

   #ifdef DEBUG_ALPHA
   printf("INIT: j=%u,t=0,o=%d:  pi(j=%u)=%.2e  b(j=%u,o=%d)=%.2e  alpha(j=%u,t=0)=%.2e\n",
	  n,o_tp1,
	  n,      exp((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ),
	  n,o_tp1 exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	  n,      exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") )
	 );
   #endif
 }} PDL_COMMENT("Close N")

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: state_(t+1)==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     PDL_Short alpha_j_tp1 = (PDL_Short)LOG_ZERO;


     /*-- Loop: state_t==i --*/
     for (i=0; i<__privtrans->__N_size; i++) {
       alpha_j_tp1 = logadd( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("i=%u,j=%u,t=%u,o=%d:  alpha(i=%u,t=%u)=%.2e  a(i=%u,j=%u)=%.2e  b(j=%u,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       i,j,t,o_tp1,
	       i,t,     exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	       j,o_tp1, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	       exp( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ), exp(alpha_j_tp1));
       #endif
     }

     /*-- Storage: alpha(time=t+1, state=j) --*/
     (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

     #ifdef DEBUG_ALPHA
      printf("----> alpha(j=%u,t=%u)=%.2E\n", j,t+1, exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	alpha_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * alpha_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * alpha_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	alpha_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,alpha_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,alpha_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

   #ifdef DEBUG_ALPHA
   printf("INIT: j=%u,t=0,o=%d:  pi(j=%u)=%.2e  b(j=%u,o=%d)=%.2e  alpha(j=%u,t=0)=%.2e\n",
	  n,o_tp1,
	  n,      exp((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ),
	  n,o_tp1 exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	  n,      exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") )
	 );
   #endif
 }} PDL_COMMENT("Close N")

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: state_(t+1)==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     PDL_Ushort alpha_j_tp1 = (PDL_Ushort)LOG_ZERO;


     /*-- Loop: state_t==i --*/
     for (i=0; i<__privtrans->__N_size; i++) {
       alpha_j_tp1 = logadd( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("i=%u,j=%u,t=%u,o=%d:  alpha(i=%u,t=%u)=%.2e  a(i=%u,j=%u)=%.2e  b(j=%u,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       i,j,t,o_tp1,
	       i,t,     exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	       j,o_tp1, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	       exp( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ), exp(alpha_j_tp1));
       #endif
     }

     /*-- Storage: alpha(time=t+1, state=j) --*/
     (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

     #ifdef DEBUG_ALPHA
      printf("----> alpha(j=%u,t=%u)=%.2E\n", j,t+1, exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	alpha_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * alpha_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * alpha_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	alpha_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,alpha_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,alpha_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

   #ifdef DEBUG_ALPHA
   printf("INIT: j=%u,t=0,o=%d:  pi(j=%u)=%.2e  b(j=%u,o=%d)=%.2e  alpha(j=%u,t=0)=%.2e\n",
	  n,o_tp1,
	  n,      exp((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ),
	  n,o_tp1 exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	  n,      exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") )
	 );
   #endif
 }} PDL_COMMENT("Close N")

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: state_(t+1)==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     PDL_Long alpha_j_tp1 = (PDL_Long)LOG_ZERO;


     /*-- Loop: state_t==i --*/
     for (i=0; i<__privtrans->__N_size; i++) {
       alpha_j_tp1 = logadd( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("i=%u,j=%u,t=%u,o=%d:  alpha(i=%u,t=%u)=%.2e  a(i=%u,j=%u)=%.2e  b(j=%u,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       i,j,t,o_tp1,
	       i,t,     exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	       j,o_tp1, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	       exp( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ), exp(alpha_j_tp1));
       #endif
     }

     /*-- Storage: alpha(time=t+1, state=j) --*/
     (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

     #ifdef DEBUG_ALPHA
      printf("----> alpha(j=%u,t=%u)=%.2E\n", j,t+1, exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	alpha_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * alpha_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * alpha_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	alpha_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,alpha_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,alpha_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

   #ifdef DEBUG_ALPHA
   printf("INIT: j=%u,t=0,o=%d:  pi(j=%u)=%.2e  b(j=%u,o=%d)=%.2e  alpha(j=%u,t=0)=%.2e\n",
	  n,o_tp1,
	  n,      exp((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ),
	  n,o_tp1 exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	  n,      exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") )
	 );
   #endif
 }} PDL_COMMENT("Close N")

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: state_(t+1)==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     PDL_Indx alpha_j_tp1 = (PDL_Indx)LOG_ZERO;


     /*-- Loop: state_t==i --*/
     for (i=0; i<__privtrans->__N_size; i++) {
       alpha_j_tp1 = logadd( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("i=%u,j=%u,t=%u,o=%d:  alpha(i=%u,t=%u)=%.2e  a(i=%u,j=%u)=%.2e  b(j=%u,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       i,j,t,o_tp1,
	       i,t,     exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	       j,o_tp1, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	       exp( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ), exp(alpha_j_tp1));
       #endif
     }

     /*-- Storage: alpha(time=t+1, state=j) --*/
     (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

     #ifdef DEBUG_ALPHA
      printf("----> alpha(j=%u,t=%u)=%.2E\n", j,t+1, exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	alpha_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * alpha_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * alpha_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	alpha_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,alpha_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,alpha_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

   #ifdef DEBUG_ALPHA
   printf("INIT: j=%u,t=0,o=%d:  pi(j=%u)=%.2e  b(j=%u,o=%d)=%.2e  alpha(j=%u,t=0)=%.2e\n",
	  n,o_tp1,
	  n,      exp((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ),
	  n,o_tp1 exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	  n,      exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") )
	 );
   #endif
 }} PDL_COMMENT("Close N")

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: state_(t+1)==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     PDL_LongLong alpha_j_tp1 = (PDL_LongLong)LOG_ZERO;


     /*-- Loop: state_t==i --*/
     for (i=0; i<__privtrans->__N_size; i++) {
       alpha_j_tp1 = logadd( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("i=%u,j=%u,t=%u,o=%d:  alpha(i=%u,t=%u)=%.2e  a(i=%u,j=%u)=%.2e  b(j=%u,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       i,j,t,o_tp1,
	       i,t,     exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	       j,o_tp1, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	       exp( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ), exp(alpha_j_tp1));
       #endif
     }

     /*-- Storage: alpha(time=t+1, state=j) --*/
     (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

     #ifdef DEBUG_ALPHA
      printf("----> alpha(j=%u,t=%u)=%.2E\n", j,t+1, exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	alpha_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * alpha_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * alpha_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	alpha_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,alpha_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,alpha_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

   #ifdef DEBUG_ALPHA
   printf("INIT: j=%u,t=0,o=%d:  pi(j=%u)=%.2e  b(j=%u,o=%d)=%.2e  alpha(j=%u,t=0)=%.2e\n",
	  n,o_tp1,
	  n,      exp((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ),
	  n,o_tp1 exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	  n,      exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") )
	 );
   #endif
 }} PDL_COMMENT("Close N")

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: state_(t+1)==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     PDL_Float alpha_j_tp1 = (PDL_Float)LOG_ZERO;


     /*-- Loop: state_t==i --*/
     for (i=0; i<__privtrans->__N_size; i++) {
       alpha_j_tp1 = logadd( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("i=%u,j=%u,t=%u,o=%d:  alpha(i=%u,t=%u)=%.2e  a(i=%u,j=%u)=%.2e  b(j=%u,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       i,j,t,o_tp1,
	       i,t,     exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	       j,o_tp1, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	       exp( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ), exp(alpha_j_tp1));
       #endif
     }

     /*-- Storage: alpha(time=t+1, state=j) --*/
     (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

     #ifdef DEBUG_ALPHA
      printf("----> alpha(j=%u,t=%u)=%.2E\n", j,t+1, exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	alpha_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * alpha_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * alpha_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	alpha_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,alpha_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,alpha_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

   #ifdef DEBUG_ALPHA
   printf("INIT: j=%u,t=0,o=%d:  pi(j=%u)=%.2e  b(j=%u,o=%d)=%.2e  alpha(j=%u,t=0)=%.2e\n",
	  n,o_tp1,
	  n,      exp((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ),
	  n,o_tp1 exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	  n,      exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") )
	 );
   #endif
 }} PDL_COMMENT("Close N")

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: state_(t+1)==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     PDL_Double alpha_j_tp1 = (PDL_Double)LOG_ZERO;


     /*-- Loop: state_t==i --*/
     for (i=0; i<__privtrans->__N_size; i++) {
       alpha_j_tp1 = logadd( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("i=%u,j=%u,t=%u,o=%d:  alpha(i=%u,t=%u)=%.2e  a(i=%u,j=%u)=%.2e  b(j=%u,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       i,j,t,o_tp1,
	       i,t,     exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	       j,o_tp1, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ),
	       exp( (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ), exp(alpha_j_tp1));
       #endif
     }

     /*-- Storage: alpha(time=t+1, state=j) --*/
     (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;

     #ifdef DEBUG_ALPHA
      printf("----> alpha(j=%u,t=%u)=%.2E\n", j,t+1, exp((alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	alpha_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_hmmfw_free(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmfw_struct *__privtrans = (pdl_hmmfw_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;;;;;;;;;;
			}
			
	}
    }
    



static char pdl_hmmfw_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_hmmfw_vtable = {
		0,0, 4, 5, pdl_hmmfw_vtable_flags,
		pdl_hmmfw_redodims, pdl_hmmfw_readdata, NULL,
		pdl_hmmfw_free,NULL,NULL,pdl_hmmfw_copy,
		sizeof(pdl_hmmfw_struct),"pdl_hmmfw_vtable"
	 };

typedef struct pdl_hmmfwq_struct {
		PDL_TRANS_START(6);
		pdl_thread  __pdlthread;PDL_Indx  __inc_a_N0;PDL_Indx  __inc_a_N1;PDL_Indx  __inc_b_N;PDL_Indx  __inc_b_M;PDL_Indx  __inc_pi_N;PDL_Indx  __inc_o_T;PDL_Indx  __inc_oq_Q;PDL_Indx  __inc_oq_T;PDL_Indx  __inc_alphaq_Q;PDL_Indx  __inc_alphaq_T;PDL_Indx  __N_size;PDL_Indx  __M_size;PDL_Indx  __Q_size;PDL_Indx  __T_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_hmmfwq_struct;

void pdl_hmmfwq_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmfwq_struct *__privtrans = (pdl_hmmfwq_struct *) __tr;
	
	{
	    PDL_Indx __creating[6];
__privtrans->__N_size = -1;
__privtrans->__M_size = -1;
__privtrans->__Q_size = -1;
__privtrans->__T_size = -1;
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = 0;
__creating[3] = 0;
__creating[4] = 0;
__creating[5] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[5]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * oq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * oq_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Byte * alphaq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Byte * alphaq_physdatap = ((PDL_Byte *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * oq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * oq_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Short * alphaq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Short * alphaq_physdatap = ((PDL_Short *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * oq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * oq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Ushort * alphaq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Ushort * alphaq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * oq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * oq_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * alphaq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * alphaq_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * oq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * oq_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Indx * alphaq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Indx * alphaq_physdatap = ((PDL_Indx *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * oq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * oq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_LongLong * alphaq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_LongLong * alphaq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * oq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * oq_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Float * alphaq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Float * alphaq_physdatap = ((PDL_Float *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * oq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * oq_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Double * alphaq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Double * alphaq_physdatap = ((PDL_Double *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b","pi","o","oq","alphaq"};
		static PDL_Indx __realdims[] = {2,2,1,1,2,2};
		static char __funcname[] = "PDL::HMM::hmmfwq";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 6
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,6,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 2) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[0]))->ndims < 2 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfwq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[1];
   } else if(((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[1]) {
      if(((__privtrans->pdls[0]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmfwq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[1]))->ndims < 2) {
      if (((__privtrans->pdls[1]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[1]))->ndims < 2 && __privtrans->__M_size <= 1) __privtrans->__M_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[1]))->dims[0];
   } else if(((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[1]))->dims[0]) {
      if(((__privtrans->pdls[1]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfwq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__M_size == -1 || (((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size == 1)) {
      __privtrans->__M_size = ((__privtrans->pdls[1]))->dims[1];
   } else if(((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size != ((__privtrans->pdls[1]))->dims[1]) {
      if(((__privtrans->pdls[1]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmfwq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[2]))->ndims < 1) {
      if (((__privtrans->pdls[2]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[2]))->dims[0];
   } else if(((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[2]))->dims[0]) {
      if(((__privtrans->pdls[2]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfwq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[3]))->ndims < 1) {
      if (((__privtrans->pdls[3]))->ndims < 1 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[3]))->dims[0];
   } else if(((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size != ((__privtrans->pdls[3]))->dims[0]) {
      if(((__privtrans->pdls[3]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfwq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[4]))->ndims < 2) {
      if (((__privtrans->pdls[4]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[4]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[4]))->dims[0];
   } else if(((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[4]))->dims[0]) {
      if(((__privtrans->pdls[4]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfwq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[4]))->dims[1];
   } else if(((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[4]))->dims[1]) {
      if(((__privtrans->pdls[4]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmfwq:" "Wrong dims\n");
      }
   }
if(!__creating[5]) {
   if(((__privtrans->pdls[5]))->ndims < 2) {
      if (((__privtrans->pdls[5]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[5]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[5]))->dims[0];
   } else if(((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[5]))->dims[0]) {
      if(((__privtrans->pdls[5]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmfwq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[5]))->dims[1];
   } else if(((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[5]))->dims[1]) {
      if(((__privtrans->pdls[5]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmfwq:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__Q_size;dims[1] = __privtrans->__T_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,5,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[3]->hdrsv &&
	 (__privtrans->pdls[3]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[3]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[3]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[4]->hdrsv &&
	 (__privtrans->pdls[4]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[4]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[4]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[5] && 
     __privtrans->pdls[5]->hdrsv &&
	 (__privtrans->pdls[5]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[5]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[5]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[5]->hdrsv != hdrp ){
	 if( __privtrans->pdls[5]->hdrsv && __privtrans->pdls[5]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[5]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[5]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[5]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_a_N0 = 0; else
		 __privtrans->__inc_a_N0 = PDL_REPRINC(__privtrans->pdls[0],0);if(__privtrans->pdls[0]->ndims <= 1 || __privtrans->pdls[0]->dims[1] <= 1)
		  __privtrans->__inc_a_N1 = 0; else
		 __privtrans->__inc_a_N1 = PDL_REPRINC(__privtrans->pdls[0],1);if(__privtrans->pdls[1]->ndims <= 0 || __privtrans->pdls[1]->dims[0] <= 1)
		  __privtrans->__inc_b_N = 0; else
		 __privtrans->__inc_b_N = PDL_REPRINC(__privtrans->pdls[1],0);if(__privtrans->pdls[1]->ndims <= 1 || __privtrans->pdls[1]->dims[1] <= 1)
		  __privtrans->__inc_b_M = 0; else
		 __privtrans->__inc_b_M = PDL_REPRINC(__privtrans->pdls[1],1);if(__privtrans->pdls[2]->ndims <= 0 || __privtrans->pdls[2]->dims[0] <= 1)
		  __privtrans->__inc_pi_N = 0; else
		 __privtrans->__inc_pi_N = PDL_REPRINC(__privtrans->pdls[2],0);if(__privtrans->pdls[3]->ndims <= 0 || __privtrans->pdls[3]->dims[0] <= 1)
		  __privtrans->__inc_o_T = 0; else
		 __privtrans->__inc_o_T = PDL_REPRINC(__privtrans->pdls[3],0);if(__privtrans->pdls[4]->ndims <= 0 || __privtrans->pdls[4]->dims[0] <= 1)
		  __privtrans->__inc_oq_Q = 0; else
		 __privtrans->__inc_oq_Q = PDL_REPRINC(__privtrans->pdls[4],0);if(__privtrans->pdls[4]->ndims <= 1 || __privtrans->pdls[4]->dims[1] <= 1)
		  __privtrans->__inc_oq_T = 0; else
		 __privtrans->__inc_oq_T = PDL_REPRINC(__privtrans->pdls[4],1);if(__privtrans->pdls[5]->ndims <= 0 || __privtrans->pdls[5]->dims[0] <= 1)
		  __privtrans->__inc_alphaq_Q = 0; else
		 __privtrans->__inc_alphaq_Q = PDL_REPRINC(__privtrans->pdls[5],0);if(__privtrans->pdls[5]->ndims <= 1 || __privtrans->pdls[5]->dims[1] <= 1)
		  __privtrans->__inc_alphaq_T = 0; else
		 __privtrans->__inc_alphaq_T = PDL_REPRINC(__privtrans->pdls[5],1); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_hmmfwq_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmfwq_struct *__privtrans = (pdl_hmmfwq_struct *) __tr;
	
	{
	    pdl_hmmfwq_struct *__copy = malloc(sizeof(pdl_hmmfwq_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_a_N0=__copy->__inc_a_N0;__privtrans->__inc_a_N1=__copy->__inc_a_N1;__privtrans->__inc_b_N=__copy->__inc_b_N;__privtrans->__inc_b_M=__copy->__inc_b_M;__privtrans->__inc_pi_N=__copy->__inc_pi_N;__privtrans->__inc_o_T=__copy->__inc_o_T;__privtrans->__inc_oq_Q=__copy->__inc_oq_Q;__privtrans->__inc_oq_T=__copy->__inc_oq_T;__privtrans->__inc_alphaq_Q=__copy->__inc_alphaq_Q;__privtrans->__inc_alphaq_T=__copy->__inc_alphaq_T;__copy->__N_size=__privtrans->__N_size;__copy->__M_size=__privtrans->__M_size;__copy->__Q_size=__privtrans->__Q_size;__copy->__T_size=__privtrans->__T_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_hmmfwq_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmfwq_struct *__privtrans = (pdl_hmmfwq_struct *) __tr;
	
	{
	    {PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * oq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * oq_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Byte * alphaq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Byte * alphaq_physdatap = ((PDL_Byte *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	alphaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alphaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,alphaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 int qi,qj;

 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (j>=0 ? (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  : (PDL_Byte)LOG_ZERO);
 }

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/
   for (qj=0; qj < __privtrans->__Q_size; qj++) {
     PDL_Byte alpha_j_tp1 = (PDL_Byte)LOG_ZERO;
     j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/
     for (qi=0; j>=0 && qi < __privtrans->__Q_size; qi++) {
       i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
       if (i < 0) break;

       alpha_j_tp1 = logadd( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("qi=%u,i=%d,qj=%u,j=%d,t=%u,o=%d:  alphaq(qi=%u,t=%u)=%.2e  a(i=%d,j=%d)=%.2e  b(j=%d,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       qi,i, qj,j, t,o_tp1,
	       i,t,     exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     ((i>=0 && j>=0) ? exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ) : 0),
	       j,o_tp1, ((i>=0 && j>=0) ? exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ) : 0),
               ((i>=0 && j>=0) ? exp( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ) : 0),
               exp(alpha_j_tp1));
       #endif
     }
     /*-- End Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/

     /*-- Storage: alphaq(time=t+1, stateIndex=qj) --*/
     if (j>=0) {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;
     } else {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = (PDL_Byte)LOG_ZERO;
     }

     #ifdef DEBUG_ALPHA
      printf("----> alphaq(qj=%u [j=%d], t=%u)=%.2E\n", qj,j,t+1, exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   /*-- End Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/

   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }
 /*-- End Loop: time t>0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alphaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * oq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * oq_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Short * alphaq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Short * alphaq_physdatap = ((PDL_Short *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	alphaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alphaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,alphaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 int qi,qj;

 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (j>=0 ? (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  : (PDL_Short)LOG_ZERO);
 }

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/
   for (qj=0; qj < __privtrans->__Q_size; qj++) {
     PDL_Short alpha_j_tp1 = (PDL_Short)LOG_ZERO;
     j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/
     for (qi=0; j>=0 && qi < __privtrans->__Q_size; qi++) {
       i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
       if (i < 0) break;

       alpha_j_tp1 = logadd( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("qi=%u,i=%d,qj=%u,j=%d,t=%u,o=%d:  alphaq(qi=%u,t=%u)=%.2e  a(i=%d,j=%d)=%.2e  b(j=%d,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       qi,i, qj,j, t,o_tp1,
	       i,t,     exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     ((i>=0 && j>=0) ? exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ) : 0),
	       j,o_tp1, ((i>=0 && j>=0) ? exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ) : 0),
               ((i>=0 && j>=0) ? exp( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ) : 0),
               exp(alpha_j_tp1));
       #endif
     }
     /*-- End Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/

     /*-- Storage: alphaq(time=t+1, stateIndex=qj) --*/
     if (j>=0) {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;
     } else {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = (PDL_Short)LOG_ZERO;
     }

     #ifdef DEBUG_ALPHA
      printf("----> alphaq(qj=%u [j=%d], t=%u)=%.2E\n", qj,j,t+1, exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   /*-- End Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/

   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }
 /*-- End Loop: time t>0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alphaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * oq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * oq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Ushort * alphaq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Ushort * alphaq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	alphaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alphaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,alphaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 int qi,qj;

 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (j>=0 ? (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  : (PDL_Ushort)LOG_ZERO);
 }

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/
   for (qj=0; qj < __privtrans->__Q_size; qj++) {
     PDL_Ushort alpha_j_tp1 = (PDL_Ushort)LOG_ZERO;
     j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/
     for (qi=0; j>=0 && qi < __privtrans->__Q_size; qi++) {
       i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
       if (i < 0) break;

       alpha_j_tp1 = logadd( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("qi=%u,i=%d,qj=%u,j=%d,t=%u,o=%d:  alphaq(qi=%u,t=%u)=%.2e  a(i=%d,j=%d)=%.2e  b(j=%d,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       qi,i, qj,j, t,o_tp1,
	       i,t,     exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     ((i>=0 && j>=0) ? exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ) : 0),
	       j,o_tp1, ((i>=0 && j>=0) ? exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ) : 0),
               ((i>=0 && j>=0) ? exp( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ) : 0),
               exp(alpha_j_tp1));
       #endif
     }
     /*-- End Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/

     /*-- Storage: alphaq(time=t+1, stateIndex=qj) --*/
     if (j>=0) {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;
     } else {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = (PDL_Ushort)LOG_ZERO;
     }

     #ifdef DEBUG_ALPHA
      printf("----> alphaq(qj=%u [j=%d], t=%u)=%.2E\n", qj,j,t+1, exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   /*-- End Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/

   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }
 /*-- End Loop: time t>0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alphaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * oq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * oq_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * alphaq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * alphaq_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	alphaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alphaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,alphaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 int qi,qj;

 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (j>=0 ? (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  : (PDL_Long)LOG_ZERO);
 }

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/
   for (qj=0; qj < __privtrans->__Q_size; qj++) {
     PDL_Long alpha_j_tp1 = (PDL_Long)LOG_ZERO;
     j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/
     for (qi=0; j>=0 && qi < __privtrans->__Q_size; qi++) {
       i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
       if (i < 0) break;

       alpha_j_tp1 = logadd( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("qi=%u,i=%d,qj=%u,j=%d,t=%u,o=%d:  alphaq(qi=%u,t=%u)=%.2e  a(i=%d,j=%d)=%.2e  b(j=%d,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       qi,i, qj,j, t,o_tp1,
	       i,t,     exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     ((i>=0 && j>=0) ? exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ) : 0),
	       j,o_tp1, ((i>=0 && j>=0) ? exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ) : 0),
               ((i>=0 && j>=0) ? exp( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ) : 0),
               exp(alpha_j_tp1));
       #endif
     }
     /*-- End Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/

     /*-- Storage: alphaq(time=t+1, stateIndex=qj) --*/
     if (j>=0) {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;
     } else {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = (PDL_Long)LOG_ZERO;
     }

     #ifdef DEBUG_ALPHA
      printf("----> alphaq(qj=%u [j=%d], t=%u)=%.2E\n", qj,j,t+1, exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   /*-- End Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/

   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }
 /*-- End Loop: time t>0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alphaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * oq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * oq_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Indx * alphaq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Indx * alphaq_physdatap = ((PDL_Indx *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	alphaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alphaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,alphaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 int qi,qj;

 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (j>=0 ? (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  : (PDL_Indx)LOG_ZERO);
 }

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/
   for (qj=0; qj < __privtrans->__Q_size; qj++) {
     PDL_Indx alpha_j_tp1 = (PDL_Indx)LOG_ZERO;
     j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/
     for (qi=0; j>=0 && qi < __privtrans->__Q_size; qi++) {
       i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
       if (i < 0) break;

       alpha_j_tp1 = logadd( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("qi=%u,i=%d,qj=%u,j=%d,t=%u,o=%d:  alphaq(qi=%u,t=%u)=%.2e  a(i=%d,j=%d)=%.2e  b(j=%d,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       qi,i, qj,j, t,o_tp1,
	       i,t,     exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     ((i>=0 && j>=0) ? exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ) : 0),
	       j,o_tp1, ((i>=0 && j>=0) ? exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ) : 0),
               ((i>=0 && j>=0) ? exp( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ) : 0),
               exp(alpha_j_tp1));
       #endif
     }
     /*-- End Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/

     /*-- Storage: alphaq(time=t+1, stateIndex=qj) --*/
     if (j>=0) {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;
     } else {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = (PDL_Indx)LOG_ZERO;
     }

     #ifdef DEBUG_ALPHA
      printf("----> alphaq(qj=%u [j=%d], t=%u)=%.2E\n", qj,j,t+1, exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   /*-- End Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/

   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }
 /*-- End Loop: time t>0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alphaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * oq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * oq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_LongLong * alphaq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_LongLong * alphaq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	alphaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alphaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,alphaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 int qi,qj;

 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (j>=0 ? (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  : (PDL_LongLong)LOG_ZERO);
 }

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/
   for (qj=0; qj < __privtrans->__Q_size; qj++) {
     PDL_LongLong alpha_j_tp1 = (PDL_LongLong)LOG_ZERO;
     j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/
     for (qi=0; j>=0 && qi < __privtrans->__Q_size; qi++) {
       i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
       if (i < 0) break;

       alpha_j_tp1 = logadd( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("qi=%u,i=%d,qj=%u,j=%d,t=%u,o=%d:  alphaq(qi=%u,t=%u)=%.2e  a(i=%d,j=%d)=%.2e  b(j=%d,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       qi,i, qj,j, t,o_tp1,
	       i,t,     exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     ((i>=0 && j>=0) ? exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ) : 0),
	       j,o_tp1, ((i>=0 && j>=0) ? exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ) : 0),
               ((i>=0 && j>=0) ? exp( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ) : 0),
               exp(alpha_j_tp1));
       #endif
     }
     /*-- End Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/

     /*-- Storage: alphaq(time=t+1, stateIndex=qj) --*/
     if (j>=0) {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;
     } else {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = (PDL_LongLong)LOG_ZERO;
     }

     #ifdef DEBUG_ALPHA
      printf("----> alphaq(qj=%u [j=%d], t=%u)=%.2E\n", qj,j,t+1, exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   /*-- End Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/

   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }
 /*-- End Loop: time t>0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alphaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * oq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * oq_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Float * alphaq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Float * alphaq_physdatap = ((PDL_Float *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	alphaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alphaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,alphaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 int qi,qj;

 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (j>=0 ? (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  : (PDL_Float)LOG_ZERO);
 }

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/
   for (qj=0; qj < __privtrans->__Q_size; qj++) {
     PDL_Float alpha_j_tp1 = (PDL_Float)LOG_ZERO;
     j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/
     for (qi=0; j>=0 && qi < __privtrans->__Q_size; qi++) {
       i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
       if (i < 0) break;

       alpha_j_tp1 = logadd( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("qi=%u,i=%d,qj=%u,j=%d,t=%u,o=%d:  alphaq(qi=%u,t=%u)=%.2e  a(i=%d,j=%d)=%.2e  b(j=%d,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       qi,i, qj,j, t,o_tp1,
	       i,t,     exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     ((i>=0 && j>=0) ? exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ) : 0),
	       j,o_tp1, ((i>=0 && j>=0) ? exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ) : 0),
               ((i>=0 && j>=0) ? exp( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ) : 0),
               exp(alpha_j_tp1));
       #endif
     }
     /*-- End Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/

     /*-- Storage: alphaq(time=t+1, stateIndex=qj) --*/
     if (j>=0) {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;
     } else {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = (PDL_Float)LOG_ZERO;
     }

     #ifdef DEBUG_ALPHA
      printf("----> alphaq(qj=%u [j=%d], t=%u)=%.2E\n", qj,j,t+1, exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   /*-- End Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/

   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }
 /*-- End Loop: time t>0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alphaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * oq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * oq_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Double * alphaq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Double * alphaq_physdatap = ((PDL_Double *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	alphaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alphaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,alphaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;


 /*-- Initialize: t==0 --*/
 int i,j,t, o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 int qi,qj;

 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (j>=0 ? (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  : (PDL_Double)LOG_ZERO);
 }

 #ifdef DEBUG_ALPHA
 printf("\n\n");
 #endif

 /*-- Loop: time t>0 --*/
 for (t=0; t < __privtrans->__T_size-1; t++) {
   o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/
   for (qj=0; qj < __privtrans->__Q_size; qj++) {
     PDL_Double alpha_j_tp1 = (PDL_Double)LOG_ZERO;
     j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/
     for (qi=0; j>=0 && qi < __privtrans->__Q_size; qi++) {
       i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
       if (i < 0) break;

       alpha_j_tp1 = logadd( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ,  alpha_j_tp1 );

       #ifdef DEBUG_ALPHA
        printf("qi=%u,i=%d,qj=%u,j=%d,t=%u,o=%d:  alphaq(qi=%u,t=%u)=%.2e  a(i=%d,j=%d)=%.2e  b(j=%d,o=%d)=%.2e  prod=%.2e  sum=%.2e\n",
	       qi,i, qj,j, t,o_tp1,
	       i,t,     exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
	       i,j,     ((i>=0 && j>=0) ? exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ) : 0),
	       j,o_tp1, ((i>=0 && j>=0) ? exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ) : 0),
               ((i>=0 && j>=0) ? exp( (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  ) : 0),
               exp(alpha_j_tp1));
       #endif
     }
     /*-- End Loop: q_(t)=qi : state_(t)=oq(qi,t)=i --*/

     /*-- Storage: alphaq(time=t+1, stateIndex=qj) --*/
     if (j>=0) {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = alpha_j_tp1 + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()") ;
     } else {
       (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  = (PDL_Double)LOG_ZERO;
     }

     #ifdef DEBUG_ALPHA
      printf("----> alphaq(qj=%u [j=%d], t=%u)=%.2E\n", qj,j,t+1, exp((alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ));
     #endif
   }
   /*-- End Loop: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j --*/

   #ifdef DEBUG_ALPHA
    printf("\n\n");
   #endif
 }
 /*-- End Loop: time t>0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alphaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_hmmfwq_free(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmfwq_struct *__privtrans = (pdl_hmmfwq_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;;;;;;;;;;;;;
			}
			
	}
    }
    



static char pdl_hmmfwq_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_hmmfwq_vtable = {
		0,0, 5, 6, pdl_hmmfwq_vtable_flags,
		pdl_hmmfwq_redodims, pdl_hmmfwq_readdata, NULL,
		pdl_hmmfwq_free,NULL,NULL,pdl_hmmfwq_copy,
		sizeof(pdl_hmmfwq_struct),"pdl_hmmfwq_vtable"
	 };

typedef struct pdl_hmmbw_struct {
		PDL_TRANS_START(5);
		pdl_thread  __pdlthread;PDL_Indx  __inc_a_N0;PDL_Indx  __inc_a_N1;PDL_Indx  __inc_b_N;PDL_Indx  __inc_b_M;PDL_Indx  __inc_omega_N;PDL_Indx  __inc_o_T;PDL_Indx  __inc_beta_N;PDL_Indx  __inc_beta_T;PDL_Indx  __M_size;PDL_Indx  __N_size;PDL_Indx  __T_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_hmmbw_struct;

void pdl_hmmbw_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmbw_struct *__privtrans = (pdl_hmmbw_struct *) __tr;
	
	{
	    PDL_Indx __creating[5];
__privtrans->__M_size = -1;
__privtrans->__N_size = -1;
__privtrans->__T_size = -1;
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = 0;
__creating[3] = 0;
__creating[4] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[4]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * omega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * omega_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * beta_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * beta_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * omega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * omega_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * beta_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * beta_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * omega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * omega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * beta_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * beta_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * omega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * omega_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * beta_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * beta_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * omega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * omega_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * beta_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * beta_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * omega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * omega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * beta_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * beta_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * omega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * omega_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * beta_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * beta_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * omega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * omega_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * beta_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * beta_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b","omega","o","beta"};
		static PDL_Indx __realdims[] = {2,2,1,1,2};
		static char __funcname[] = "PDL::HMM::hmmbw";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 5
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,5,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 2) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[0]))->ndims < 2 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbw:" "Wrong dims\n");
      }
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[1];
   } else if(((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[1]) {
      if(((__privtrans->pdls[0]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmbw:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[1]))->ndims < 2) {
      if (((__privtrans->pdls[1]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[1]))->ndims < 2 && __privtrans->__M_size <= 1) __privtrans->__M_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[1]))->dims[0];
   } else if(((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[1]))->dims[0]) {
      if(((__privtrans->pdls[1]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbw:" "Wrong dims\n");
      }
   }
   if(__privtrans->__M_size == -1 || (((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size == 1)) {
      __privtrans->__M_size = ((__privtrans->pdls[1]))->dims[1];
   } else if(((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size != ((__privtrans->pdls[1]))->dims[1]) {
      if(((__privtrans->pdls[1]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmbw:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[2]))->ndims < 1) {
      if (((__privtrans->pdls[2]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[2]))->dims[0];
   } else if(((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[2]))->dims[0]) {
      if(((__privtrans->pdls[2]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbw:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[3]))->ndims < 1) {
      if (((__privtrans->pdls[3]))->ndims < 1 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[3]))->dims[0];
   } else if(((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size != ((__privtrans->pdls[3]))->dims[0]) {
      if(((__privtrans->pdls[3]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbw:" "Wrong dims\n");
      }
   }
if(!__creating[4]) {
   if(((__privtrans->pdls[4]))->ndims < 2) {
      if (((__privtrans->pdls[4]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[4]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[4]))->dims[0];
   } else if(((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[4]))->dims[0]) {
      if(((__privtrans->pdls[4]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbw:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[4]))->dims[1];
   } else if(((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[4]))->dims[1]) {
      if(((__privtrans->pdls[4]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmbw:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;dims[1] = __privtrans->__T_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,4,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[3]->hdrsv &&
	 (__privtrans->pdls[3]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[3]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[3]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[4] && 
     __privtrans->pdls[4]->hdrsv &&
	 (__privtrans->pdls[4]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[4]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[4]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[4]->hdrsv != hdrp ){
	 if( __privtrans->pdls[4]->hdrsv && __privtrans->pdls[4]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[4]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[4]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[4]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_a_N0 = 0; else
		 __privtrans->__inc_a_N0 = PDL_REPRINC(__privtrans->pdls[0],0);if(__privtrans->pdls[0]->ndims <= 1 || __privtrans->pdls[0]->dims[1] <= 1)
		  __privtrans->__inc_a_N1 = 0; else
		 __privtrans->__inc_a_N1 = PDL_REPRINC(__privtrans->pdls[0],1);if(__privtrans->pdls[1]->ndims <= 0 || __privtrans->pdls[1]->dims[0] <= 1)
		  __privtrans->__inc_b_N = 0; else
		 __privtrans->__inc_b_N = PDL_REPRINC(__privtrans->pdls[1],0);if(__privtrans->pdls[1]->ndims <= 1 || __privtrans->pdls[1]->dims[1] <= 1)
		  __privtrans->__inc_b_M = 0; else
		 __privtrans->__inc_b_M = PDL_REPRINC(__privtrans->pdls[1],1);if(__privtrans->pdls[2]->ndims <= 0 || __privtrans->pdls[2]->dims[0] <= 1)
		  __privtrans->__inc_omega_N = 0; else
		 __privtrans->__inc_omega_N = PDL_REPRINC(__privtrans->pdls[2],0);if(__privtrans->pdls[3]->ndims <= 0 || __privtrans->pdls[3]->dims[0] <= 1)
		  __privtrans->__inc_o_T = 0; else
		 __privtrans->__inc_o_T = PDL_REPRINC(__privtrans->pdls[3],0);if(__privtrans->pdls[4]->ndims <= 0 || __privtrans->pdls[4]->dims[0] <= 1)
		  __privtrans->__inc_beta_N = 0; else
		 __privtrans->__inc_beta_N = PDL_REPRINC(__privtrans->pdls[4],0);if(__privtrans->pdls[4]->ndims <= 1 || __privtrans->pdls[4]->dims[1] <= 1)
		  __privtrans->__inc_beta_T = 0; else
		 __privtrans->__inc_beta_T = PDL_REPRINC(__privtrans->pdls[4],1); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_hmmbw_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmbw_struct *__privtrans = (pdl_hmmbw_struct *) __tr;
	
	{
	    pdl_hmmbw_struct *__copy = malloc(sizeof(pdl_hmmbw_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_a_N0=__copy->__inc_a_N0;__privtrans->__inc_a_N1=__copy->__inc_a_N1;__privtrans->__inc_b_N=__copy->__inc_b_N;__privtrans->__inc_b_M=__copy->__inc_b_M;__privtrans->__inc_omega_N=__copy->__inc_omega_N;__privtrans->__inc_o_T=__copy->__inc_o_T;__privtrans->__inc_beta_N=__copy->__inc_beta_N;__privtrans->__inc_beta_T=__copy->__inc_beta_T;__copy->__M_size=__privtrans->__M_size;__copy->__N_size=__privtrans->__N_size;__copy->__T_size=__privtrans->__T_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_hmmbw_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmbw_struct *__privtrans = (pdl_hmmbw_struct *) __tr;
	
	{
	    {register PDL_Indx __N_size = __privtrans->__N_size;
PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * omega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * omega_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * beta_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * beta_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	beta_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,beta_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,beta_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;


 int i,j,t = __privtrans->__T_size-1;

 /*-- Initialize: time t==T --*/
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ; }} PDL_COMMENT("Close N")

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: state_t == i  --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     PDL_Byte beta_i_t = (PDL_Byte)LOG_ZERO;

     /*-- Loop: t<T: state_(t+1) == i  --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );

       #ifdef DEBUG_BETA
       printf("i=%u,j=%u,t=%u,o=%d:  a(i=%u,j=%u)=%.2e  b(j=%u,o=%u)=%.2e  beta(j=%u,t+1=%u)=%.2e   prod=%.2e  sum=%.2e\n",
	      i,j,t,o_tp1,
	      i,j,    exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	      j,o_t,  exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
	      j,t+1,  exp((beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),
	      exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") +(beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),  exp(beta_i_t));
       #endif
     }

     /*-- t<T: state_t == i: update  --*/
     (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;

     #ifdef DEBUG_BETA
     printf("\n");
     #endif
   }
   #ifdef DEBUG_BETA
   printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	beta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * omega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * omega_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * beta_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * beta_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	beta_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,beta_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,beta_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;


 int i,j,t = __privtrans->__T_size-1;

 /*-- Initialize: time t==T --*/
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ; }} PDL_COMMENT("Close N")

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: state_t == i  --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     PDL_Short beta_i_t = (PDL_Short)LOG_ZERO;

     /*-- Loop: t<T: state_(t+1) == i  --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );

       #ifdef DEBUG_BETA
       printf("i=%u,j=%u,t=%u,o=%d:  a(i=%u,j=%u)=%.2e  b(j=%u,o=%u)=%.2e  beta(j=%u,t+1=%u)=%.2e   prod=%.2e  sum=%.2e\n",
	      i,j,t,o_tp1,
	      i,j,    exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	      j,o_t,  exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
	      j,t+1,  exp((beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),
	      exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") +(beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),  exp(beta_i_t));
       #endif
     }

     /*-- t<T: state_t == i: update  --*/
     (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;

     #ifdef DEBUG_BETA
     printf("\n");
     #endif
   }
   #ifdef DEBUG_BETA
   printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	beta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * omega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * omega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * beta_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * beta_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	beta_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,beta_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,beta_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;


 int i,j,t = __privtrans->__T_size-1;

 /*-- Initialize: time t==T --*/
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ; }} PDL_COMMENT("Close N")

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: state_t == i  --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     PDL_Ushort beta_i_t = (PDL_Ushort)LOG_ZERO;

     /*-- Loop: t<T: state_(t+1) == i  --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );

       #ifdef DEBUG_BETA
       printf("i=%u,j=%u,t=%u,o=%d:  a(i=%u,j=%u)=%.2e  b(j=%u,o=%u)=%.2e  beta(j=%u,t+1=%u)=%.2e   prod=%.2e  sum=%.2e\n",
	      i,j,t,o_tp1,
	      i,j,    exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	      j,o_t,  exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
	      j,t+1,  exp((beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),
	      exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") +(beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),  exp(beta_i_t));
       #endif
     }

     /*-- t<T: state_t == i: update  --*/
     (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;

     #ifdef DEBUG_BETA
     printf("\n");
     #endif
   }
   #ifdef DEBUG_BETA
   printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	beta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * omega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * omega_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * beta_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * beta_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	beta_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,beta_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,beta_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;


 int i,j,t = __privtrans->__T_size-1;

 /*-- Initialize: time t==T --*/
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ; }} PDL_COMMENT("Close N")

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: state_t == i  --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     PDL_Long beta_i_t = (PDL_Long)LOG_ZERO;

     /*-- Loop: t<T: state_(t+1) == i  --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );

       #ifdef DEBUG_BETA
       printf("i=%u,j=%u,t=%u,o=%d:  a(i=%u,j=%u)=%.2e  b(j=%u,o=%u)=%.2e  beta(j=%u,t+1=%u)=%.2e   prod=%.2e  sum=%.2e\n",
	      i,j,t,o_tp1,
	      i,j,    exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	      j,o_t,  exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
	      j,t+1,  exp((beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),
	      exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") +(beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),  exp(beta_i_t));
       #endif
     }

     /*-- t<T: state_t == i: update  --*/
     (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;

     #ifdef DEBUG_BETA
     printf("\n");
     #endif
   }
   #ifdef DEBUG_BETA
   printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	beta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * omega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * omega_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * beta_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * beta_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	beta_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,beta_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,beta_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;


 int i,j,t = __privtrans->__T_size-1;

 /*-- Initialize: time t==T --*/
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ; }} PDL_COMMENT("Close N")

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: state_t == i  --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     PDL_Indx beta_i_t = (PDL_Indx)LOG_ZERO;

     /*-- Loop: t<T: state_(t+1) == i  --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );

       #ifdef DEBUG_BETA
       printf("i=%u,j=%u,t=%u,o=%d:  a(i=%u,j=%u)=%.2e  b(j=%u,o=%u)=%.2e  beta(j=%u,t+1=%u)=%.2e   prod=%.2e  sum=%.2e\n",
	      i,j,t,o_tp1,
	      i,j,    exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	      j,o_t,  exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
	      j,t+1,  exp((beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),
	      exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") +(beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),  exp(beta_i_t));
       #endif
     }

     /*-- t<T: state_t == i: update  --*/
     (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;

     #ifdef DEBUG_BETA
     printf("\n");
     #endif
   }
   #ifdef DEBUG_BETA
   printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	beta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * omega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * omega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * beta_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * beta_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	beta_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,beta_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,beta_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;


 int i,j,t = __privtrans->__T_size-1;

 /*-- Initialize: time t==T --*/
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ; }} PDL_COMMENT("Close N")

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: state_t == i  --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     PDL_LongLong beta_i_t = (PDL_LongLong)LOG_ZERO;

     /*-- Loop: t<T: state_(t+1) == i  --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );

       #ifdef DEBUG_BETA
       printf("i=%u,j=%u,t=%u,o=%d:  a(i=%u,j=%u)=%.2e  b(j=%u,o=%u)=%.2e  beta(j=%u,t+1=%u)=%.2e   prod=%.2e  sum=%.2e\n",
	      i,j,t,o_tp1,
	      i,j,    exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	      j,o_t,  exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
	      j,t+1,  exp((beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),
	      exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") +(beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),  exp(beta_i_t));
       #endif
     }

     /*-- t<T: state_t == i: update  --*/
     (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;

     #ifdef DEBUG_BETA
     printf("\n");
     #endif
   }
   #ifdef DEBUG_BETA
   printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	beta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * omega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * omega_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * beta_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * beta_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	beta_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,beta_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,beta_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;


 int i,j,t = __privtrans->__T_size-1;

 /*-- Initialize: time t==T --*/
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ; }} PDL_COMMENT("Close N")

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: state_t == i  --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     PDL_Float beta_i_t = (PDL_Float)LOG_ZERO;

     /*-- Loop: t<T: state_(t+1) == i  --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );

       #ifdef DEBUG_BETA
       printf("i=%u,j=%u,t=%u,o=%d:  a(i=%u,j=%u)=%.2e  b(j=%u,o=%u)=%.2e  beta(j=%u,t+1=%u)=%.2e   prod=%.2e  sum=%.2e\n",
	      i,j,t,o_tp1,
	      i,j,    exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	      j,o_t,  exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
	      j,t+1,  exp((beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),
	      exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") +(beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),  exp(beta_i_t));
       #endif
     }

     /*-- t<T: state_t == i: update  --*/
     (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;

     #ifdef DEBUG_BETA
     printf("\n");
     #endif
   }
   #ifdef DEBUG_BETA
   printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	beta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * omega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * omega_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * beta_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * beta_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	beta_datap += __offsp[4];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,beta_datap += __tinc1_4 - __tinc0_4 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,beta_datap += __tinc0_4
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;


 int i,j,t = __privtrans->__T_size-1;

 /*-- Initialize: time t==T --*/
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()") ; }} PDL_COMMENT("Close N")

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: state_t == i  --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     PDL_Double beta_i_t = (PDL_Double)LOG_ZERO;

     /*-- Loop: t<T: state_(t+1) == i  --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );

       #ifdef DEBUG_BETA
       printf("i=%u,j=%u,t=%u,o=%d:  a(i=%u,j=%u)=%.2e  b(j=%u,o=%u)=%.2e  beta(j=%u,t+1=%u)=%.2e   prod=%.2e  sum=%.2e\n",
	      i,j,t,o_tp1,
	      i,j,    exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ),
	      j,o_t,  exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
	      j,t+1,  exp((beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),
	      exp((a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") +(beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ),  exp(beta_i_t));
       #endif
     }

     /*-- t<T: state_t == i: update  --*/
     (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;

     #ifdef DEBUG_BETA
     printf("\n");
     #endif
   }
   #ifdef DEBUG_BETA
   printf("\n\n");
   #endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	beta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_hmmbw_free(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmbw_struct *__privtrans = (pdl_hmmbw_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;;;;;;;;;;
			}
			
	}
    }
    



static char pdl_hmmbw_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_hmmbw_vtable = {
		0,0, 4, 5, pdl_hmmbw_vtable_flags,
		pdl_hmmbw_redodims, pdl_hmmbw_readdata, NULL,
		pdl_hmmbw_free,NULL,NULL,pdl_hmmbw_copy,
		sizeof(pdl_hmmbw_struct),"pdl_hmmbw_vtable"
	 };

typedef struct pdl_hmmbwq_struct {
		PDL_TRANS_START(6);
		pdl_thread  __pdlthread;PDL_Indx  __inc_a_N0;PDL_Indx  __inc_a_N1;PDL_Indx  __inc_b_N;PDL_Indx  __inc_b_M;PDL_Indx  __inc_omega_N;PDL_Indx  __inc_o_T;PDL_Indx  __inc_oq_Q;PDL_Indx  __inc_oq_T;PDL_Indx  __inc_betaq_Q;PDL_Indx  __inc_betaq_T;PDL_Indx  __M_size;PDL_Indx  __N_size;PDL_Indx  __T_size;PDL_Indx  __Q_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_hmmbwq_struct;

void pdl_hmmbwq_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmbwq_struct *__privtrans = (pdl_hmmbwq_struct *) __tr;
	
	{
	    PDL_Indx __creating[6];
__privtrans->__M_size = -1;
__privtrans->__N_size = -1;
__privtrans->__T_size = -1;
__privtrans->__Q_size = -1;
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = 0;
__creating[3] = 0;
__creating[4] = 0;
__creating[5] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[5]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * omega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * omega_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * oq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * oq_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Byte * betaq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Byte * betaq_physdatap = ((PDL_Byte *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * omega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * omega_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * oq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * oq_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Short * betaq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Short * betaq_physdatap = ((PDL_Short *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * omega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * omega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * oq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * oq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Ushort * betaq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Ushort * betaq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * omega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * omega_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * oq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * oq_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * betaq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * betaq_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * omega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * omega_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * oq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * oq_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Indx * betaq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Indx * betaq_physdatap = ((PDL_Indx *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * omega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * omega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * oq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * oq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_LongLong * betaq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_LongLong * betaq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * omega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * omega_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * oq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * oq_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Float * betaq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Float * betaq_physdatap = ((PDL_Float *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * omega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * omega_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * oq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * oq_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Double * betaq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Double * betaq_physdatap = ((PDL_Double *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b","omega","o","oq","betaq"};
		static PDL_Indx __realdims[] = {2,2,1,1,2,2};
		static char __funcname[] = "PDL::HMM::hmmbwq";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 6
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,6,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 2) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[0]))->ndims < 2 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbwq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[1];
   } else if(((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[1]) {
      if(((__privtrans->pdls[0]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmbwq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[1]))->ndims < 2) {
      if (((__privtrans->pdls[1]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[1]))->ndims < 2 && __privtrans->__M_size <= 1) __privtrans->__M_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[1]))->dims[0];
   } else if(((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[1]))->dims[0]) {
      if(((__privtrans->pdls[1]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbwq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__M_size == -1 || (((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size == 1)) {
      __privtrans->__M_size = ((__privtrans->pdls[1]))->dims[1];
   } else if(((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size != ((__privtrans->pdls[1]))->dims[1]) {
      if(((__privtrans->pdls[1]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmbwq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[2]))->ndims < 1) {
      if (((__privtrans->pdls[2]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[2]))->dims[0];
   } else if(((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[2]))->dims[0]) {
      if(((__privtrans->pdls[2]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbwq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[3]))->ndims < 1) {
      if (((__privtrans->pdls[3]))->ndims < 1 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[3]))->dims[0];
   } else if(((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size != ((__privtrans->pdls[3]))->dims[0]) {
      if(((__privtrans->pdls[3]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbwq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[4]))->ndims < 2) {
      if (((__privtrans->pdls[4]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[4]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[4]))->dims[0];
   } else if(((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[4]))->dims[0]) {
      if(((__privtrans->pdls[4]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbwq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[4]))->dims[1];
   } else if(((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[4]))->dims[1]) {
      if(((__privtrans->pdls[4]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmbwq:" "Wrong dims\n");
      }
   }
if(!__creating[5]) {
   if(((__privtrans->pdls[5]))->ndims < 2) {
      if (((__privtrans->pdls[5]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[5]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[5]))->dims[0];
   } else if(((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[5]))->dims[0]) {
      if(((__privtrans->pdls[5]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmbwq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[5]))->dims[1];
   } else if(((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[5]))->dims[1]) {
      if(((__privtrans->pdls[5]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmbwq:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__Q_size;dims[1] = __privtrans->__T_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,5,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[3]->hdrsv &&
	 (__privtrans->pdls[3]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[3]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[3]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[4]->hdrsv &&
	 (__privtrans->pdls[4]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[4]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[4]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[5] && 
     __privtrans->pdls[5]->hdrsv &&
	 (__privtrans->pdls[5]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[5]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[5]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[5]->hdrsv != hdrp ){
	 if( __privtrans->pdls[5]->hdrsv && __privtrans->pdls[5]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[5]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[5]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[5]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_a_N0 = 0; else
		 __privtrans->__inc_a_N0 = PDL_REPRINC(__privtrans->pdls[0],0);if(__privtrans->pdls[0]->ndims <= 1 || __privtrans->pdls[0]->dims[1] <= 1)
		  __privtrans->__inc_a_N1 = 0; else
		 __privtrans->__inc_a_N1 = PDL_REPRINC(__privtrans->pdls[0],1);if(__privtrans->pdls[1]->ndims <= 0 || __privtrans->pdls[1]->dims[0] <= 1)
		  __privtrans->__inc_b_N = 0; else
		 __privtrans->__inc_b_N = PDL_REPRINC(__privtrans->pdls[1],0);if(__privtrans->pdls[1]->ndims <= 1 || __privtrans->pdls[1]->dims[1] <= 1)
		  __privtrans->__inc_b_M = 0; else
		 __privtrans->__inc_b_M = PDL_REPRINC(__privtrans->pdls[1],1);if(__privtrans->pdls[2]->ndims <= 0 || __privtrans->pdls[2]->dims[0] <= 1)
		  __privtrans->__inc_omega_N = 0; else
		 __privtrans->__inc_omega_N = PDL_REPRINC(__privtrans->pdls[2],0);if(__privtrans->pdls[3]->ndims <= 0 || __privtrans->pdls[3]->dims[0] <= 1)
		  __privtrans->__inc_o_T = 0; else
		 __privtrans->__inc_o_T = PDL_REPRINC(__privtrans->pdls[3],0);if(__privtrans->pdls[4]->ndims <= 0 || __privtrans->pdls[4]->dims[0] <= 1)
		  __privtrans->__inc_oq_Q = 0; else
		 __privtrans->__inc_oq_Q = PDL_REPRINC(__privtrans->pdls[4],0);if(__privtrans->pdls[4]->ndims <= 1 || __privtrans->pdls[4]->dims[1] <= 1)
		  __privtrans->__inc_oq_T = 0; else
		 __privtrans->__inc_oq_T = PDL_REPRINC(__privtrans->pdls[4],1);if(__privtrans->pdls[5]->ndims <= 0 || __privtrans->pdls[5]->dims[0] <= 1)
		  __privtrans->__inc_betaq_Q = 0; else
		 __privtrans->__inc_betaq_Q = PDL_REPRINC(__privtrans->pdls[5],0);if(__privtrans->pdls[5]->ndims <= 1 || __privtrans->pdls[5]->dims[1] <= 1)
		  __privtrans->__inc_betaq_T = 0; else
		 __privtrans->__inc_betaq_T = PDL_REPRINC(__privtrans->pdls[5],1); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_hmmbwq_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmbwq_struct *__privtrans = (pdl_hmmbwq_struct *) __tr;
	
	{
	    pdl_hmmbwq_struct *__copy = malloc(sizeof(pdl_hmmbwq_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_a_N0=__copy->__inc_a_N0;__privtrans->__inc_a_N1=__copy->__inc_a_N1;__privtrans->__inc_b_N=__copy->__inc_b_N;__privtrans->__inc_b_M=__copy->__inc_b_M;__privtrans->__inc_omega_N=__copy->__inc_omega_N;__privtrans->__inc_o_T=__copy->__inc_o_T;__privtrans->__inc_oq_Q=__copy->__inc_oq_Q;__privtrans->__inc_oq_T=__copy->__inc_oq_T;__privtrans->__inc_betaq_Q=__copy->__inc_betaq_Q;__privtrans->__inc_betaq_T=__copy->__inc_betaq_T;__copy->__M_size=__privtrans->__M_size;__copy->__N_size=__privtrans->__N_size;__copy->__T_size=__privtrans->__T_size;__copy->__Q_size=__privtrans->__Q_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_hmmbwq_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmbwq_struct *__privtrans = (pdl_hmmbwq_struct *) __tr;
	
	{
	    {PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * omega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * omega_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * oq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * oq_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Byte * betaq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Byte * betaq_physdatap = ((PDL_Byte *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	betaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,betaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,betaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int i,j,t = __privtrans->__T_size-1;
 int qi, qj;

 /*-- Initialize: time t==T --*/
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (i>=0 ? (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  : (PDL_Byte)LOG_ZERO);
 }

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     PDL_Byte beta_i_t = (PDL_Byte)LOG_ZERO;
     i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: t<T: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j  --*/
     for (qj=0; i>=0 && qj<__privtrans->__Q_size; qj++) {
       j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );
     }

     /*-- t<T: betaq(time=t, stateIndex=qi) --*/
     (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;
   }
   /*-- End Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
 }
 /*-- End Loop: time t < T --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	betaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * omega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * omega_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * oq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * oq_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Short * betaq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Short * betaq_physdatap = ((PDL_Short *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	betaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,betaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,betaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int i,j,t = __privtrans->__T_size-1;
 int qi, qj;

 /*-- Initialize: time t==T --*/
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (i>=0 ? (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  : (PDL_Short)LOG_ZERO);
 }

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     PDL_Short beta_i_t = (PDL_Short)LOG_ZERO;
     i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: t<T: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j  --*/
     for (qj=0; i>=0 && qj<__privtrans->__Q_size; qj++) {
       j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );
     }

     /*-- t<T: betaq(time=t, stateIndex=qi) --*/
     (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;
   }
   /*-- End Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
 }
 /*-- End Loop: time t < T --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	betaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * omega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * omega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * oq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * oq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Ushort * betaq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Ushort * betaq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	betaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,betaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,betaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int i,j,t = __privtrans->__T_size-1;
 int qi, qj;

 /*-- Initialize: time t==T --*/
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (i>=0 ? (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  : (PDL_Ushort)LOG_ZERO);
 }

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     PDL_Ushort beta_i_t = (PDL_Ushort)LOG_ZERO;
     i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: t<T: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j  --*/
     for (qj=0; i>=0 && qj<__privtrans->__Q_size; qj++) {
       j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );
     }

     /*-- t<T: betaq(time=t, stateIndex=qi) --*/
     (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;
   }
   /*-- End Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
 }
 /*-- End Loop: time t < T --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	betaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * omega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * omega_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * oq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * oq_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * betaq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * betaq_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	betaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,betaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,betaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int i,j,t = __privtrans->__T_size-1;
 int qi, qj;

 /*-- Initialize: time t==T --*/
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (i>=0 ? (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  : (PDL_Long)LOG_ZERO);
 }

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     PDL_Long beta_i_t = (PDL_Long)LOG_ZERO;
     i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: t<T: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j  --*/
     for (qj=0; i>=0 && qj<__privtrans->__Q_size; qj++) {
       j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );
     }

     /*-- t<T: betaq(time=t, stateIndex=qi) --*/
     (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;
   }
   /*-- End Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
 }
 /*-- End Loop: time t < T --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	betaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * omega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * omega_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * oq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * oq_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Indx * betaq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Indx * betaq_physdatap = ((PDL_Indx *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	betaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,betaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,betaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int i,j,t = __privtrans->__T_size-1;
 int qi, qj;

 /*-- Initialize: time t==T --*/
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (i>=0 ? (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  : (PDL_Indx)LOG_ZERO);
 }

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     PDL_Indx beta_i_t = (PDL_Indx)LOG_ZERO;
     i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: t<T: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j  --*/
     for (qj=0; i>=0 && qj<__privtrans->__Q_size; qj++) {
       j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );
     }

     /*-- t<T: betaq(time=t, stateIndex=qi) --*/
     (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;
   }
   /*-- End Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
 }
 /*-- End Loop: time t < T --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	betaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * omega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * omega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * oq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * oq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_LongLong * betaq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_LongLong * betaq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	betaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,betaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,betaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int i,j,t = __privtrans->__T_size-1;
 int qi, qj;

 /*-- Initialize: time t==T --*/
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (i>=0 ? (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  : (PDL_LongLong)LOG_ZERO);
 }

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     PDL_LongLong beta_i_t = (PDL_LongLong)LOG_ZERO;
     i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: t<T: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j  --*/
     for (qj=0; i>=0 && qj<__privtrans->__Q_size; qj++) {
       j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );
     }

     /*-- t<T: betaq(time=t, stateIndex=qi) --*/
     (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;
   }
   /*-- End Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
 }
 /*-- End Loop: time t < T --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	betaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * omega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * omega_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * oq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * oq_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Float * betaq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Float * betaq_physdatap = ((PDL_Float *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	betaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,betaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,betaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int i,j,t = __privtrans->__T_size-1;
 int qi, qj;

 /*-- Initialize: time t==T --*/
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (i>=0 ? (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  : (PDL_Float)LOG_ZERO);
 }

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     PDL_Float beta_i_t = (PDL_Float)LOG_ZERO;
     i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: t<T: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j  --*/
     for (qj=0; i>=0 && qj<__privtrans->__Q_size; qj++) {
       j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );
     }

     /*-- t<T: betaq(time=t, stateIndex=qi) --*/
     (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;
   }
   /*-- End Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
 }
 /*-- End Loop: time t < T --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	betaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * omega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * omega_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * oq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * oq_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Double * betaq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Double * betaq_physdatap = ((PDL_Double *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	omega_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	betaq_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,omega_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,betaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,omega_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,betaq_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int i,j,t = __privtrans->__T_size-1;
 int qi, qj;

 /*-- Initialize: time t==T --*/
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (i>=0 ? (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  : (PDL_Double)LOG_ZERO);
 }

 /*-- Loop: time t < T --*/
 for (t--; t >= 0; t--) {
   int o_tp1 = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     PDL_Double beta_i_t = (PDL_Double)LOG_ZERO;
     i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

     /*-- Loop: t<T: q_(t+1)=qj : state_(t+1)=oq(qj,t+1)=j  --*/
     for (qj=0; i>=0 && qj<__privtrans->__Q_size; qj++) {
       j = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       beta_i_t = logadd( (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  ,  beta_i_t );
     }

     /*-- t<T: betaq(time=t, stateIndex=qi) --*/
     (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = beta_i_t;
   }
   /*-- End Loop: t<T: q_(t)=qi : state_(t)=oq(qi,t)=i  --*/
 }
 /*-- End Loop: time t < T --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	omega_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	betaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_hmmbwq_free(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmbwq_struct *__privtrans = (pdl_hmmbwq_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;;;;;;;;;;;;;
			}
			
	}
    }
    



static char pdl_hmmbwq_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_hmmbwq_vtable = {
		0,0, 5, 6, pdl_hmmbwq_vtable_flags,
		pdl_hmmbwq_redodims, pdl_hmmbwq_readdata, NULL,
		pdl_hmmbwq_free,NULL,NULL,pdl_hmmbwq_copy,
		sizeof(pdl_hmmbwq_struct),"pdl_hmmbwq_vtable"
	 };

typedef struct pdl_hmmexpect_struct {
		PDL_TRANS_START(11);
		pdl_thread  __pdlthread;PDL_Indx  __inc_a_N0;PDL_Indx  __inc_a_N1;PDL_Indx  __inc_b_N;PDL_Indx  __inc_b_M;PDL_Indx  __inc_pi_N;PDL_Indx  __inc_omega_N;PDL_Indx  __inc_o_T;PDL_Indx  __inc_alpha_N;PDL_Indx  __inc_alpha_T;PDL_Indx  __inc_beta_N;PDL_Indx  __inc_beta_T;PDL_Indx  __inc_ea_N0;PDL_Indx  __inc_ea_N1;PDL_Indx  __inc_eb_N;PDL_Indx  __inc_eb_M;PDL_Indx  __inc_epi_N;PDL_Indx  __inc_eomega_N;PDL_Indx  __T_size;PDL_Indx  __M_size;PDL_Indx  __N_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_hmmexpect_struct;

void pdl_hmmexpect_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmexpect_struct *__privtrans = (pdl_hmmexpect_struct *) __tr;
	
	{
	    PDL_Indx __creating[11];
__privtrans->__T_size = -1;
__privtrans->__M_size = -1;
__privtrans->__N_size = -1;
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = 0;
__creating[3] = 0;
__creating[4] = 0;
__creating[5] = 0;
__creating[6] = 0;
__creating[7] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[7]);
__creating[8] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[8]);
__creating[9] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[9]);
__creating[10] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[10]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * omega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * omega_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Byte * alpha_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Byte * alpha_physdatap = ((PDL_Byte *)((__privtrans->pdls[5])->data));

	PDL_Byte * beta_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Byte * beta_physdatap = ((PDL_Byte *)((__privtrans->pdls[6])->data));

	PDL_Byte * ea_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Byte * ea_physdatap = ((PDL_Byte *)((__privtrans->pdls[7])->data));

	PDL_Byte * eb_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Byte * eb_physdatap = ((PDL_Byte *)((__privtrans->pdls[8])->data));

	PDL_Byte * epi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Byte * epi_physdatap = ((PDL_Byte *)((__privtrans->pdls[9])->data));

	PDL_Byte * eomega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Byte * eomega_physdatap = ((PDL_Byte *)((__privtrans->pdls[10])->data));

{register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * omega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * omega_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Short * alpha_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Short * alpha_physdatap = ((PDL_Short *)((__privtrans->pdls[5])->data));

	PDL_Short * beta_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Short * beta_physdatap = ((PDL_Short *)((__privtrans->pdls[6])->data));

	PDL_Short * ea_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Short * ea_physdatap = ((PDL_Short *)((__privtrans->pdls[7])->data));

	PDL_Short * eb_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Short * eb_physdatap = ((PDL_Short *)((__privtrans->pdls[8])->data));

	PDL_Short * epi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Short * epi_physdatap = ((PDL_Short *)((__privtrans->pdls[9])->data));

	PDL_Short * eomega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Short * eomega_physdatap = ((PDL_Short *)((__privtrans->pdls[10])->data));

{register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * omega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * omega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Ushort * alpha_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Ushort * alpha_physdatap = ((PDL_Ushort *)((__privtrans->pdls[5])->data));

	PDL_Ushort * beta_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Ushort * beta_physdatap = ((PDL_Ushort *)((__privtrans->pdls[6])->data));

	PDL_Ushort * ea_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Ushort * ea_physdatap = ((PDL_Ushort *)((__privtrans->pdls[7])->data));

	PDL_Ushort * eb_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Ushort * eb_physdatap = ((PDL_Ushort *)((__privtrans->pdls[8])->data));

	PDL_Ushort * epi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Ushort * epi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[9])->data));

	PDL_Ushort * eomega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Ushort * eomega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[10])->data));

{register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * omega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * omega_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * alpha_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * alpha_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

	PDL_Long * beta_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * beta_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

	PDL_Long * ea_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Long * ea_physdatap = ((PDL_Long *)((__privtrans->pdls[7])->data));

	PDL_Long * eb_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Long * eb_physdatap = ((PDL_Long *)((__privtrans->pdls[8])->data));

	PDL_Long * epi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Long * epi_physdatap = ((PDL_Long *)((__privtrans->pdls[9])->data));

	PDL_Long * eomega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Long * eomega_physdatap = ((PDL_Long *)((__privtrans->pdls[10])->data));

{register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * omega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * omega_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Indx * alpha_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Indx * alpha_physdatap = ((PDL_Indx *)((__privtrans->pdls[5])->data));

	PDL_Indx * beta_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Indx * beta_physdatap = ((PDL_Indx *)((__privtrans->pdls[6])->data));

	PDL_Indx * ea_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Indx * ea_physdatap = ((PDL_Indx *)((__privtrans->pdls[7])->data));

	PDL_Indx * eb_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Indx * eb_physdatap = ((PDL_Indx *)((__privtrans->pdls[8])->data));

	PDL_Indx * epi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Indx * epi_physdatap = ((PDL_Indx *)((__privtrans->pdls[9])->data));

	PDL_Indx * eomega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Indx * eomega_physdatap = ((PDL_Indx *)((__privtrans->pdls[10])->data));

{register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * omega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * omega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_LongLong * alpha_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_LongLong * alpha_physdatap = ((PDL_LongLong *)((__privtrans->pdls[5])->data));

	PDL_LongLong * beta_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_LongLong * beta_physdatap = ((PDL_LongLong *)((__privtrans->pdls[6])->data));

	PDL_LongLong * ea_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_LongLong * ea_physdatap = ((PDL_LongLong *)((__privtrans->pdls[7])->data));

	PDL_LongLong * eb_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_LongLong * eb_physdatap = ((PDL_LongLong *)((__privtrans->pdls[8])->data));

	PDL_LongLong * epi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_LongLong * epi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[9])->data));

	PDL_LongLong * eomega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_LongLong * eomega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[10])->data));

{register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * omega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * omega_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Float * alpha_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Float * alpha_physdatap = ((PDL_Float *)((__privtrans->pdls[5])->data));

	PDL_Float * beta_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Float * beta_physdatap = ((PDL_Float *)((__privtrans->pdls[6])->data));

	PDL_Float * ea_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Float * ea_physdatap = ((PDL_Float *)((__privtrans->pdls[7])->data));

	PDL_Float * eb_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Float * eb_physdatap = ((PDL_Float *)((__privtrans->pdls[8])->data));

	PDL_Float * epi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Float * epi_physdatap = ((PDL_Float *)((__privtrans->pdls[9])->data));

	PDL_Float * eomega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Float * eomega_physdatap = ((PDL_Float *)((__privtrans->pdls[10])->data));

{register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * omega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * omega_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Double * alpha_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Double * alpha_physdatap = ((PDL_Double *)((__privtrans->pdls[5])->data));

	PDL_Double * beta_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Double * beta_physdatap = ((PDL_Double *)((__privtrans->pdls[6])->data));

	PDL_Double * ea_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Double * ea_physdatap = ((PDL_Double *)((__privtrans->pdls[7])->data));

	PDL_Double * eb_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Double * eb_physdatap = ((PDL_Double *)((__privtrans->pdls[8])->data));

	PDL_Double * epi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Double * epi_physdatap = ((PDL_Double *)((__privtrans->pdls[9])->data));

	PDL_Double * eomega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Double * eomega_physdatap = ((PDL_Double *)((__privtrans->pdls[10])->data));

{register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b","pi","omega","o","alpha","beta","ea","eb","epi","eomega"};
		static PDL_Indx __realdims[] = {2,2,1,1,1,2,2,2,2,1,1};
		static char __funcname[] = "PDL::HMM::hmmexpect";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 11
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,11,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 2) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[0]))->ndims < 2 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[1];
   } else if(((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[1]) {
      if(((__privtrans->pdls[0]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[1]))->ndims < 2) {
      if (((__privtrans->pdls[1]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[1]))->ndims < 2 && __privtrans->__M_size <= 1) __privtrans->__M_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[1]))->dims[0];
   } else if(((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[1]))->dims[0]) {
      if(((__privtrans->pdls[1]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(__privtrans->__M_size == -1 || (((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size == 1)) {
      __privtrans->__M_size = ((__privtrans->pdls[1]))->dims[1];
   } else if(((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size != ((__privtrans->pdls[1]))->dims[1]) {
      if(((__privtrans->pdls[1]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[2]))->ndims < 1) {
      if (((__privtrans->pdls[2]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[2]))->dims[0];
   } else if(((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[2]))->dims[0]) {
      if(((__privtrans->pdls[2]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[3]))->ndims < 1) {
      if (((__privtrans->pdls[3]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[3]))->dims[0];
   } else if(((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[3]))->dims[0]) {
      if(((__privtrans->pdls[3]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[4]))->ndims < 1) {
      if (((__privtrans->pdls[4]))->ndims < 1 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[4]))->dims[0];
   } else if(((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__T_size != ((__privtrans->pdls[4]))->dims[0]) {
      if(((__privtrans->pdls[4]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[5]))->ndims < 2) {
      if (((__privtrans->pdls[5]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[5]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[5]))->dims[0];
   } else if(((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[5]))->dims[0]) {
      if(((__privtrans->pdls[5]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[5]))->dims[1];
   } else if(((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[5]))->dims[1]) {
      if(((__privtrans->pdls[5]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[6]))->ndims < 2) {
      if (((__privtrans->pdls[6]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[6]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[6]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[6]))->dims[0];
   } else if(((__privtrans->pdls[6]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[6]))->dims[0]) {
      if(((__privtrans->pdls[6]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[6]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[6]))->dims[1];
   } else if(((__privtrans->pdls[6]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[6]))->dims[1]) {
      if(((__privtrans->pdls[6]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
if(!__creating[7]) {
   if(((__privtrans->pdls[7]))->ndims < 2) {
      if (((__privtrans->pdls[7]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[7]))->ndims < 2 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[7]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[7]))->dims[0];
   } else if(((__privtrans->pdls[7]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[7]))->dims[0]) {
      if(((__privtrans->pdls[7]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[7]))->ndims > 1 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[7]))->dims[1];
   } else if(((__privtrans->pdls[7]))->ndims > 1 && __privtrans->__N_size != ((__privtrans->pdls[7]))->dims[1]) {
      if(((__privtrans->pdls[7]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;dims[1] = __privtrans->__N_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,7,dims,0);
}if(!__creating[8]) {
   if(((__privtrans->pdls[8]))->ndims < 2) {
      if (((__privtrans->pdls[8]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[8]))->ndims < 2 && __privtrans->__M_size <= 1) __privtrans->__M_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[8]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[8]))->dims[0];
   } else if(((__privtrans->pdls[8]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[8]))->dims[0]) {
      if(((__privtrans->pdls[8]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
   if(__privtrans->__M_size == -1 || (((__privtrans->pdls[8]))->ndims > 1 && __privtrans->__M_size == 1)) {
      __privtrans->__M_size = ((__privtrans->pdls[8]))->dims[1];
   } else if(((__privtrans->pdls[8]))->ndims > 1 && __privtrans->__M_size != ((__privtrans->pdls[8]))->dims[1]) {
      if(((__privtrans->pdls[8]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;dims[1] = __privtrans->__M_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,8,dims,0);
}if(!__creating[9]) {
   if(((__privtrans->pdls[9]))->ndims < 1) {
      if (((__privtrans->pdls[9]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[9]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[9]))->dims[0];
   } else if(((__privtrans->pdls[9]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[9]))->dims[0]) {
      if(((__privtrans->pdls[9]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[2]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,9,dims,0);
}if(!__creating[10]) {
   if(((__privtrans->pdls[10]))->ndims < 1) {
      if (((__privtrans->pdls[10]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[10]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[10]))->dims[0];
   } else if(((__privtrans->pdls[10]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[10]))->dims[0]) {
      if(((__privtrans->pdls[10]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpect:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[2]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,10,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[3]->hdrsv &&
	 (__privtrans->pdls[3]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[3]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[3]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[4]->hdrsv &&
	 (__privtrans->pdls[4]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[4]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[4]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[5]->hdrsv &&
	 (__privtrans->pdls[5]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[5]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[5]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[6]->hdrsv &&
	 (__privtrans->pdls[6]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[6]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[6]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[7] && 
     __privtrans->pdls[7]->hdrsv &&
	 (__privtrans->pdls[7]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[7]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[7]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[8] && 
     __privtrans->pdls[8]->hdrsv &&
	 (__privtrans->pdls[8]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[8]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[8]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[9] && 
     __privtrans->pdls[9]->hdrsv &&
	 (__privtrans->pdls[9]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[9]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[9]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[10] && 
     __privtrans->pdls[10]->hdrsv &&
	 (__privtrans->pdls[10]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[10]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[10]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[7]->hdrsv != hdrp ){
	 if( __privtrans->pdls[7]->hdrsv && __privtrans->pdls[7]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[7]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[7]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[7]->state |= PDL_HDRCPY;
       if ( __privtrans->pdls[8]->hdrsv != hdrp ){
	 if( __privtrans->pdls[8]->hdrsv && __privtrans->pdls[8]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[8]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[8]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[8]->state |= PDL_HDRCPY;
       if ( __privtrans->pdls[9]->hdrsv != hdrp ){
	 if( __privtrans->pdls[9]->hdrsv && __privtrans->pdls[9]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[9]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[9]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[9]->state |= PDL_HDRCPY;
       if ( __privtrans->pdls[10]->hdrsv != hdrp ){
	 if( __privtrans->pdls[10]->hdrsv && __privtrans->pdls[10]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[10]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[10]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[10]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_a_N0 = 0; else
		 __privtrans->__inc_a_N0 = PDL_REPRINC(__privtrans->pdls[0],0);if(__privtrans->pdls[0]->ndims <= 1 || __privtrans->pdls[0]->dims[1] <= 1)
		  __privtrans->__inc_a_N1 = 0; else
		 __privtrans->__inc_a_N1 = PDL_REPRINC(__privtrans->pdls[0],1);if(__privtrans->pdls[1]->ndims <= 0 || __privtrans->pdls[1]->dims[0] <= 1)
		  __privtrans->__inc_b_N = 0; else
		 __privtrans->__inc_b_N = PDL_REPRINC(__privtrans->pdls[1],0);if(__privtrans->pdls[1]->ndims <= 1 || __privtrans->pdls[1]->dims[1] <= 1)
		  __privtrans->__inc_b_M = 0; else
		 __privtrans->__inc_b_M = PDL_REPRINC(__privtrans->pdls[1],1);if(__privtrans->pdls[2]->ndims <= 0 || __privtrans->pdls[2]->dims[0] <= 1)
		  __privtrans->__inc_pi_N = 0; else
		 __privtrans->__inc_pi_N = PDL_REPRINC(__privtrans->pdls[2],0);if(__privtrans->pdls[3]->ndims <= 0 || __privtrans->pdls[3]->dims[0] <= 1)
		  __privtrans->__inc_omega_N = 0; else
		 __privtrans->__inc_omega_N = PDL_REPRINC(__privtrans->pdls[3],0);if(__privtrans->pdls[4]->ndims <= 0 || __privtrans->pdls[4]->dims[0] <= 1)
		  __privtrans->__inc_o_T = 0; else
		 __privtrans->__inc_o_T = PDL_REPRINC(__privtrans->pdls[4],0);if(__privtrans->pdls[5]->ndims <= 0 || __privtrans->pdls[5]->dims[0] <= 1)
		  __privtrans->__inc_alpha_N = 0; else
		 __privtrans->__inc_alpha_N = PDL_REPRINC(__privtrans->pdls[5],0);if(__privtrans->pdls[5]->ndims <= 1 || __privtrans->pdls[5]->dims[1] <= 1)
		  __privtrans->__inc_alpha_T = 0; else
		 __privtrans->__inc_alpha_T = PDL_REPRINC(__privtrans->pdls[5],1);if(__privtrans->pdls[6]->ndims <= 0 || __privtrans->pdls[6]->dims[0] <= 1)
		  __privtrans->__inc_beta_N = 0; else
		 __privtrans->__inc_beta_N = PDL_REPRINC(__privtrans->pdls[6],0);if(__privtrans->pdls[6]->ndims <= 1 || __privtrans->pdls[6]->dims[1] <= 1)
		  __privtrans->__inc_beta_T = 0; else
		 __privtrans->__inc_beta_T = PDL_REPRINC(__privtrans->pdls[6],1);if(__privtrans->pdls[7]->ndims <= 0 || __privtrans->pdls[7]->dims[0] <= 1)
		  __privtrans->__inc_ea_N0 = 0; else
		 __privtrans->__inc_ea_N0 = PDL_REPRINC(__privtrans->pdls[7],0);if(__privtrans->pdls[7]->ndims <= 1 || __privtrans->pdls[7]->dims[1] <= 1)
		  __privtrans->__inc_ea_N1 = 0; else
		 __privtrans->__inc_ea_N1 = PDL_REPRINC(__privtrans->pdls[7],1);if(__privtrans->pdls[8]->ndims <= 0 || __privtrans->pdls[8]->dims[0] <= 1)
		  __privtrans->__inc_eb_N = 0; else
		 __privtrans->__inc_eb_N = PDL_REPRINC(__privtrans->pdls[8],0);if(__privtrans->pdls[8]->ndims <= 1 || __privtrans->pdls[8]->dims[1] <= 1)
		  __privtrans->__inc_eb_M = 0; else
		 __privtrans->__inc_eb_M = PDL_REPRINC(__privtrans->pdls[8],1);if(__privtrans->pdls[9]->ndims <= 0 || __privtrans->pdls[9]->dims[0] <= 1)
		  __privtrans->__inc_epi_N = 0; else
		 __privtrans->__inc_epi_N = PDL_REPRINC(__privtrans->pdls[9],0);if(__privtrans->pdls[10]->ndims <= 0 || __privtrans->pdls[10]->dims[0] <= 1)
		  __privtrans->__inc_eomega_N = 0; else
		 __privtrans->__inc_eomega_N = PDL_REPRINC(__privtrans->pdls[10],0); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_hmmexpect_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmexpect_struct *__privtrans = (pdl_hmmexpect_struct *) __tr;
	
	{
	    pdl_hmmexpect_struct *__copy = malloc(sizeof(pdl_hmmexpect_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_a_N0=__copy->__inc_a_N0;__privtrans->__inc_a_N1=__copy->__inc_a_N1;__privtrans->__inc_b_N=__copy->__inc_b_N;__privtrans->__inc_b_M=__copy->__inc_b_M;__privtrans->__inc_pi_N=__copy->__inc_pi_N;__privtrans->__inc_omega_N=__copy->__inc_omega_N;__privtrans->__inc_o_T=__copy->__inc_o_T;__privtrans->__inc_alpha_N=__copy->__inc_alpha_N;__privtrans->__inc_alpha_T=__copy->__inc_alpha_T;__privtrans->__inc_beta_N=__copy->__inc_beta_N;__privtrans->__inc_beta_T=__copy->__inc_beta_T;__privtrans->__inc_ea_N0=__copy->__inc_ea_N0;__privtrans->__inc_ea_N1=__copy->__inc_ea_N1;__privtrans->__inc_eb_N=__copy->__inc_eb_N;__privtrans->__inc_eb_M=__copy->__inc_eb_M;__privtrans->__inc_epi_N=__copy->__inc_epi_N;__privtrans->__inc_eomega_N=__copy->__inc_eomega_N;__copy->__T_size=__privtrans->__T_size;__copy->__M_size=__privtrans->__M_size;__copy->__N_size=__privtrans->__N_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_hmmexpect_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmexpect_struct *__privtrans = (pdl_hmmexpect_struct *) __tr;
	
	{
	    {register PDL_Indx __N_size = __privtrans->__N_size;
PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * omega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * omega_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Byte * alpha_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Byte * alpha_physdatap = ((PDL_Byte *)((__privtrans->pdls[5])->data));

	PDL_Byte * beta_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Byte * beta_physdatap = ((PDL_Byte *)((__privtrans->pdls[6])->data));

	PDL_Byte * ea_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Byte * ea_physdatap = ((PDL_Byte *)((__privtrans->pdls[7])->data));

	PDL_Byte * eb_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Byte * eb_physdatap = ((PDL_Byte *)((__privtrans->pdls[8])->data));

	PDL_Byte * epi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Byte * epi_physdatap = ((PDL_Byte *)((__privtrans->pdls[9])->data));

	PDL_Byte * eomega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Byte * eomega_physdatap = ((PDL_Byte *)((__privtrans->pdls[10])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	alpha_datap += __offsp[5];
	beta_datap += __offsp[6];
	ea_datap += __offsp[7];
	eb_datap += __offsp[8];
	epi_datap += __offsp[9];
	eomega_datap += __offsp[10];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alpha_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,beta_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,ea_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,eb_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,epi_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,eomega_datap += __tinc1_10 - __tinc0_10 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,alpha_datap += __tinc0_5
			,beta_datap += __tinc0_6
			,ea_datap += __tinc0_7
			,eb_datap += __tinc0_8
			,epi_datap += __tinc0_9
			,eomega_datap += __tinc0_10
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 int i,j,t;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ); }} PDL_COMMENT("Close N")


 /*-- Initialize: t==(T-1): Iterate: state_t==i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (i=0; i<__privtrans->__N_size; i++) {
   gamma_it         = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Main: Iterate: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: Iterate: state_t == i --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     gamma_it = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Main: Iterate: state_(t+1) == j --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       xi_ijt = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Main: Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Main: Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alpha_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	beta_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	ea_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	eb_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	epi_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	eomega_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * omega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * omega_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Short * alpha_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Short * alpha_physdatap = ((PDL_Short *)((__privtrans->pdls[5])->data));

	PDL_Short * beta_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Short * beta_physdatap = ((PDL_Short *)((__privtrans->pdls[6])->data));

	PDL_Short * ea_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Short * ea_physdatap = ((PDL_Short *)((__privtrans->pdls[7])->data));

	PDL_Short * eb_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Short * eb_physdatap = ((PDL_Short *)((__privtrans->pdls[8])->data));

	PDL_Short * epi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Short * epi_physdatap = ((PDL_Short *)((__privtrans->pdls[9])->data));

	PDL_Short * eomega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Short * eomega_physdatap = ((PDL_Short *)((__privtrans->pdls[10])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	alpha_datap += __offsp[5];
	beta_datap += __offsp[6];
	ea_datap += __offsp[7];
	eb_datap += __offsp[8];
	epi_datap += __offsp[9];
	eomega_datap += __offsp[10];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alpha_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,beta_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,ea_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,eb_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,epi_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,eomega_datap += __tinc1_10 - __tinc0_10 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,alpha_datap += __tinc0_5
			,beta_datap += __tinc0_6
			,ea_datap += __tinc0_7
			,eb_datap += __tinc0_8
			,epi_datap += __tinc0_9
			,eomega_datap += __tinc0_10
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 int i,j,t;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ); }} PDL_COMMENT("Close N")


 /*-- Initialize: t==(T-1): Iterate: state_t==i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (i=0; i<__privtrans->__N_size; i++) {
   gamma_it         = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Main: Iterate: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: Iterate: state_t == i --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     gamma_it = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Main: Iterate: state_(t+1) == j --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       xi_ijt = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Main: Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Main: Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alpha_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	beta_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	ea_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	eb_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	epi_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	eomega_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * omega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * omega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Ushort * alpha_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Ushort * alpha_physdatap = ((PDL_Ushort *)((__privtrans->pdls[5])->data));

	PDL_Ushort * beta_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Ushort * beta_physdatap = ((PDL_Ushort *)((__privtrans->pdls[6])->data));

	PDL_Ushort * ea_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Ushort * ea_physdatap = ((PDL_Ushort *)((__privtrans->pdls[7])->data));

	PDL_Ushort * eb_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Ushort * eb_physdatap = ((PDL_Ushort *)((__privtrans->pdls[8])->data));

	PDL_Ushort * epi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Ushort * epi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[9])->data));

	PDL_Ushort * eomega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Ushort * eomega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[10])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	alpha_datap += __offsp[5];
	beta_datap += __offsp[6];
	ea_datap += __offsp[7];
	eb_datap += __offsp[8];
	epi_datap += __offsp[9];
	eomega_datap += __offsp[10];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alpha_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,beta_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,ea_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,eb_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,epi_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,eomega_datap += __tinc1_10 - __tinc0_10 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,alpha_datap += __tinc0_5
			,beta_datap += __tinc0_6
			,ea_datap += __tinc0_7
			,eb_datap += __tinc0_8
			,epi_datap += __tinc0_9
			,eomega_datap += __tinc0_10
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 int i,j,t;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ); }} PDL_COMMENT("Close N")


 /*-- Initialize: t==(T-1): Iterate: state_t==i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (i=0; i<__privtrans->__N_size; i++) {
   gamma_it         = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Main: Iterate: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: Iterate: state_t == i --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     gamma_it = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Main: Iterate: state_(t+1) == j --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       xi_ijt = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Main: Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Main: Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alpha_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	beta_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	ea_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	eb_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	epi_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	eomega_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * omega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * omega_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * alpha_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * alpha_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

	PDL_Long * beta_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * beta_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

	PDL_Long * ea_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Long * ea_physdatap = ((PDL_Long *)((__privtrans->pdls[7])->data));

	PDL_Long * eb_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Long * eb_physdatap = ((PDL_Long *)((__privtrans->pdls[8])->data));

	PDL_Long * epi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Long * epi_physdatap = ((PDL_Long *)((__privtrans->pdls[9])->data));

	PDL_Long * eomega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Long * eomega_physdatap = ((PDL_Long *)((__privtrans->pdls[10])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	alpha_datap += __offsp[5];
	beta_datap += __offsp[6];
	ea_datap += __offsp[7];
	eb_datap += __offsp[8];
	epi_datap += __offsp[9];
	eomega_datap += __offsp[10];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alpha_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,beta_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,ea_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,eb_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,epi_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,eomega_datap += __tinc1_10 - __tinc0_10 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,alpha_datap += __tinc0_5
			,beta_datap += __tinc0_6
			,ea_datap += __tinc0_7
			,eb_datap += __tinc0_8
			,epi_datap += __tinc0_9
			,eomega_datap += __tinc0_10
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 int i,j,t;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ); }} PDL_COMMENT("Close N")


 /*-- Initialize: t==(T-1): Iterate: state_t==i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (i=0; i<__privtrans->__N_size; i++) {
   gamma_it         = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Main: Iterate: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: Iterate: state_t == i --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     gamma_it = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Main: Iterate: state_(t+1) == j --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       xi_ijt = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Main: Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Main: Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alpha_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	beta_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	ea_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	eb_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	epi_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	eomega_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * omega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * omega_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Indx * alpha_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Indx * alpha_physdatap = ((PDL_Indx *)((__privtrans->pdls[5])->data));

	PDL_Indx * beta_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Indx * beta_physdatap = ((PDL_Indx *)((__privtrans->pdls[6])->data));

	PDL_Indx * ea_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Indx * ea_physdatap = ((PDL_Indx *)((__privtrans->pdls[7])->data));

	PDL_Indx * eb_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Indx * eb_physdatap = ((PDL_Indx *)((__privtrans->pdls[8])->data));

	PDL_Indx * epi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Indx * epi_physdatap = ((PDL_Indx *)((__privtrans->pdls[9])->data));

	PDL_Indx * eomega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Indx * eomega_physdatap = ((PDL_Indx *)((__privtrans->pdls[10])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	alpha_datap += __offsp[5];
	beta_datap += __offsp[6];
	ea_datap += __offsp[7];
	eb_datap += __offsp[8];
	epi_datap += __offsp[9];
	eomega_datap += __offsp[10];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alpha_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,beta_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,ea_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,eb_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,epi_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,eomega_datap += __tinc1_10 - __tinc0_10 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,alpha_datap += __tinc0_5
			,beta_datap += __tinc0_6
			,ea_datap += __tinc0_7
			,eb_datap += __tinc0_8
			,epi_datap += __tinc0_9
			,eomega_datap += __tinc0_10
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 int i,j,t;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ); }} PDL_COMMENT("Close N")


 /*-- Initialize: t==(T-1): Iterate: state_t==i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (i=0; i<__privtrans->__N_size; i++) {
   gamma_it         = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Main: Iterate: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: Iterate: state_t == i --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     gamma_it = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Main: Iterate: state_(t+1) == j --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       xi_ijt = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Main: Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Main: Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alpha_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	beta_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	ea_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	eb_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	epi_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	eomega_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * omega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * omega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_LongLong * alpha_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_LongLong * alpha_physdatap = ((PDL_LongLong *)((__privtrans->pdls[5])->data));

	PDL_LongLong * beta_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_LongLong * beta_physdatap = ((PDL_LongLong *)((__privtrans->pdls[6])->data));

	PDL_LongLong * ea_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_LongLong * ea_physdatap = ((PDL_LongLong *)((__privtrans->pdls[7])->data));

	PDL_LongLong * eb_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_LongLong * eb_physdatap = ((PDL_LongLong *)((__privtrans->pdls[8])->data));

	PDL_LongLong * epi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_LongLong * epi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[9])->data));

	PDL_LongLong * eomega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_LongLong * eomega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[10])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	alpha_datap += __offsp[5];
	beta_datap += __offsp[6];
	ea_datap += __offsp[7];
	eb_datap += __offsp[8];
	epi_datap += __offsp[9];
	eomega_datap += __offsp[10];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alpha_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,beta_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,ea_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,eb_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,epi_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,eomega_datap += __tinc1_10 - __tinc0_10 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,alpha_datap += __tinc0_5
			,beta_datap += __tinc0_6
			,ea_datap += __tinc0_7
			,eb_datap += __tinc0_8
			,epi_datap += __tinc0_9
			,eomega_datap += __tinc0_10
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 int i,j,t;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ); }} PDL_COMMENT("Close N")


 /*-- Initialize: t==(T-1): Iterate: state_t==i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (i=0; i<__privtrans->__N_size; i++) {
   gamma_it         = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Main: Iterate: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: Iterate: state_t == i --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     gamma_it = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Main: Iterate: state_(t+1) == j --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       xi_ijt = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Main: Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Main: Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alpha_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	beta_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	ea_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	eb_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	epi_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	eomega_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * omega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * omega_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Float * alpha_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Float * alpha_physdatap = ((PDL_Float *)((__privtrans->pdls[5])->data));

	PDL_Float * beta_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Float * beta_physdatap = ((PDL_Float *)((__privtrans->pdls[6])->data));

	PDL_Float * ea_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Float * ea_physdatap = ((PDL_Float *)((__privtrans->pdls[7])->data));

	PDL_Float * eb_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Float * eb_physdatap = ((PDL_Float *)((__privtrans->pdls[8])->data));

	PDL_Float * epi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Float * epi_physdatap = ((PDL_Float *)((__privtrans->pdls[9])->data));

	PDL_Float * eomega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Float * eomega_physdatap = ((PDL_Float *)((__privtrans->pdls[10])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	alpha_datap += __offsp[5];
	beta_datap += __offsp[6];
	ea_datap += __offsp[7];
	eb_datap += __offsp[8];
	epi_datap += __offsp[9];
	eomega_datap += __offsp[10];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alpha_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,beta_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,ea_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,eb_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,epi_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,eomega_datap += __tinc1_10 - __tinc0_10 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,alpha_datap += __tinc0_5
			,beta_datap += __tinc0_6
			,ea_datap += __tinc0_7
			,eb_datap += __tinc0_8
			,epi_datap += __tinc0_9
			,eomega_datap += __tinc0_10
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 int i,j,t;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ); }} PDL_COMMENT("Close N")


 /*-- Initialize: t==(T-1): Iterate: state_t==i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (i=0; i<__privtrans->__N_size; i++) {
   gamma_it         = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Main: Iterate: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: Iterate: state_t == i --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     gamma_it = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Main: Iterate: state_(t+1) == j --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       xi_ijt = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Main: Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Main: Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alpha_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	beta_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	ea_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	eb_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	epi_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	eomega_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * omega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * omega_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Double * alpha_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Double * alpha_physdatap = ((PDL_Double *)((__privtrans->pdls[5])->data));

	PDL_Double * beta_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Double * beta_physdatap = ((PDL_Double *)((__privtrans->pdls[6])->data));

	PDL_Double * ea_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Double * ea_physdatap = ((PDL_Double *)((__privtrans->pdls[7])->data));

	PDL_Double * eb_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Double * eb_physdatap = ((PDL_Double *)((__privtrans->pdls[8])->data));

	PDL_Double * epi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Double * epi_physdatap = ((PDL_Double *)((__privtrans->pdls[9])->data));

	PDL_Double * eomega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Double * eomega_physdatap = ((PDL_Double *)((__privtrans->pdls[10])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	alpha_datap += __offsp[5];
	beta_datap += __offsp[6];
	ea_datap += __offsp[7];
	eb_datap += __offsp[8];
	epi_datap += __offsp[9];
	eomega_datap += __offsp[10];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,alpha_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,beta_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,ea_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,eb_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,epi_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,eomega_datap += __tinc1_10 - __tinc0_10 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,alpha_datap += __tinc0_5
			,beta_datap += __tinc0_6
			,ea_datap += __tinc0_7
			,eb_datap += __tinc0_8
			,epi_datap += __tinc0_9
			,eomega_datap += __tinc0_10
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_beta_N = __privtrans->__inc_beta_N;
register PDL_Indx __inc_beta_T = __privtrans->__inc_beta_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_alpha_N = __privtrans->__inc_alpha_N;
register PDL_Indx __inc_alpha_T = __privtrans->__inc_alpha_T;


 int i,j,t;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) { p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ); }} PDL_COMMENT("Close N")


 /*-- Initialize: t==(T-1): Iterate: state_t==i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (i=0; i<__privtrans->__N_size; i++) {
   gamma_it         = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Main: Iterate: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: Iterate: state_t == i --*/
   for (i=0; i<__privtrans->__N_size; i++) {
     gamma_it = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Main: Iterate: state_(t+1) == j --*/
     for (j=0; j<__privtrans->__N_size; j++) {
       xi_ijt = (alpha_datap)[0+(__inc_alpha_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_alpha_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (beta_datap)[0+(__inc_beta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_beta_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Main: Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Main: Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	alpha_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	beta_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	ea_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	eb_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	epi_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	eomega_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_hmmexpect_free(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmexpect_struct *__privtrans = (pdl_hmmexpect_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;;;;;;;;;;;;;;;;;;;
			}
			
	}
    }
    



static char pdl_hmmexpect_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_hmmexpect_vtable = {
		0,0, 7, 11, pdl_hmmexpect_vtable_flags,
		pdl_hmmexpect_redodims, pdl_hmmexpect_readdata, NULL,
		pdl_hmmexpect_free,NULL,NULL,pdl_hmmexpect_copy,
		sizeof(pdl_hmmexpect_struct),"pdl_hmmexpect_vtable"
	 };

typedef struct pdl_hmmexpectq_struct {
		PDL_TRANS_START(12);
		pdl_thread  __pdlthread;PDL_Indx  __inc_a_N0;PDL_Indx  __inc_a_N1;PDL_Indx  __inc_b_N;PDL_Indx  __inc_b_M;PDL_Indx  __inc_pi_N;PDL_Indx  __inc_omega_N;PDL_Indx  __inc_o_T;PDL_Indx  __inc_oq_Q;PDL_Indx  __inc_oq_T;PDL_Indx  __inc_alphaq_Q;PDL_Indx  __inc_alphaq_T;PDL_Indx  __inc_betaq_Q;PDL_Indx  __inc_betaq_T;PDL_Indx  __inc_ea_N0;PDL_Indx  __inc_ea_N1;PDL_Indx  __inc_eb_N;PDL_Indx  __inc_eb_M;PDL_Indx  __inc_epi_N;PDL_Indx  __inc_eomega_N;PDL_Indx  __N_size;PDL_Indx  __T_size;PDL_Indx  __Q_size;PDL_Indx  __M_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_hmmexpectq_struct;

void pdl_hmmexpectq_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmexpectq_struct *__privtrans = (pdl_hmmexpectq_struct *) __tr;
	
	{
	    PDL_Indx __creating[12];
__privtrans->__N_size = -1;
__privtrans->__T_size = -1;
__privtrans->__Q_size = -1;
__privtrans->__M_size = -1;
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = 0;
__creating[3] = 0;
__creating[4] = 0;
__creating[5] = 0;
__creating[6] = 0;
__creating[7] = 0;
__creating[8] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[8]);
__creating[9] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[9]);
__creating[10] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[10]);
__creating[11] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[11]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * omega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * omega_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Byte * oq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Byte * oq_physdatap = ((PDL_Byte *)((__privtrans->pdls[5])->data));

	PDL_Byte * alphaq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Byte * alphaq_physdatap = ((PDL_Byte *)((__privtrans->pdls[6])->data));

	PDL_Byte * betaq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Byte * betaq_physdatap = ((PDL_Byte *)((__privtrans->pdls[7])->data));

	PDL_Byte * ea_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Byte * ea_physdatap = ((PDL_Byte *)((__privtrans->pdls[8])->data));

	PDL_Byte * eb_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Byte * eb_physdatap = ((PDL_Byte *)((__privtrans->pdls[9])->data));

	PDL_Byte * epi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Byte * epi_physdatap = ((PDL_Byte *)((__privtrans->pdls[10])->data));

	PDL_Byte * eomega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Byte * eomega_physdatap = ((PDL_Byte *)((__privtrans->pdls[11])->data));

{register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * omega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * omega_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Short * oq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Short * oq_physdatap = ((PDL_Short *)((__privtrans->pdls[5])->data));

	PDL_Short * alphaq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Short * alphaq_physdatap = ((PDL_Short *)((__privtrans->pdls[6])->data));

	PDL_Short * betaq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Short * betaq_physdatap = ((PDL_Short *)((__privtrans->pdls[7])->data));

	PDL_Short * ea_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Short * ea_physdatap = ((PDL_Short *)((__privtrans->pdls[8])->data));

	PDL_Short * eb_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Short * eb_physdatap = ((PDL_Short *)((__privtrans->pdls[9])->data));

	PDL_Short * epi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Short * epi_physdatap = ((PDL_Short *)((__privtrans->pdls[10])->data));

	PDL_Short * eomega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Short * eomega_physdatap = ((PDL_Short *)((__privtrans->pdls[11])->data));

{register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * omega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * omega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Ushort * oq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Ushort * oq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[5])->data));

	PDL_Ushort * alphaq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Ushort * alphaq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[6])->data));

	PDL_Ushort * betaq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Ushort * betaq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[7])->data));

	PDL_Ushort * ea_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Ushort * ea_physdatap = ((PDL_Ushort *)((__privtrans->pdls[8])->data));

	PDL_Ushort * eb_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Ushort * eb_physdatap = ((PDL_Ushort *)((__privtrans->pdls[9])->data));

	PDL_Ushort * epi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Ushort * epi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[10])->data));

	PDL_Ushort * eomega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Ushort * eomega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[11])->data));

{register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * omega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * omega_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * oq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * oq_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

	PDL_Long * alphaq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * alphaq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

	PDL_Long * betaq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Long * betaq_physdatap = ((PDL_Long *)((__privtrans->pdls[7])->data));

	PDL_Long * ea_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Long * ea_physdatap = ((PDL_Long *)((__privtrans->pdls[8])->data));

	PDL_Long * eb_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Long * eb_physdatap = ((PDL_Long *)((__privtrans->pdls[9])->data));

	PDL_Long * epi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Long * epi_physdatap = ((PDL_Long *)((__privtrans->pdls[10])->data));

	PDL_Long * eomega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Long * eomega_physdatap = ((PDL_Long *)((__privtrans->pdls[11])->data));

{register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * omega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * omega_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Indx * oq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Indx * oq_physdatap = ((PDL_Indx *)((__privtrans->pdls[5])->data));

	PDL_Indx * alphaq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Indx * alphaq_physdatap = ((PDL_Indx *)((__privtrans->pdls[6])->data));

	PDL_Indx * betaq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Indx * betaq_physdatap = ((PDL_Indx *)((__privtrans->pdls[7])->data));

	PDL_Indx * ea_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Indx * ea_physdatap = ((PDL_Indx *)((__privtrans->pdls[8])->data));

	PDL_Indx * eb_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Indx * eb_physdatap = ((PDL_Indx *)((__privtrans->pdls[9])->data));

	PDL_Indx * epi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Indx * epi_physdatap = ((PDL_Indx *)((__privtrans->pdls[10])->data));

	PDL_Indx * eomega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Indx * eomega_physdatap = ((PDL_Indx *)((__privtrans->pdls[11])->data));

{register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * omega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * omega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_LongLong * oq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_LongLong * oq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[5])->data));

	PDL_LongLong * alphaq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_LongLong * alphaq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[6])->data));

	PDL_LongLong * betaq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_LongLong * betaq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[7])->data));

	PDL_LongLong * ea_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_LongLong * ea_physdatap = ((PDL_LongLong *)((__privtrans->pdls[8])->data));

	PDL_LongLong * eb_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_LongLong * eb_physdatap = ((PDL_LongLong *)((__privtrans->pdls[9])->data));

	PDL_LongLong * epi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_LongLong * epi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[10])->data));

	PDL_LongLong * eomega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_LongLong * eomega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[11])->data));

{register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * omega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * omega_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Float * oq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Float * oq_physdatap = ((PDL_Float *)((__privtrans->pdls[5])->data));

	PDL_Float * alphaq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Float * alphaq_physdatap = ((PDL_Float *)((__privtrans->pdls[6])->data));

	PDL_Float * betaq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Float * betaq_physdatap = ((PDL_Float *)((__privtrans->pdls[7])->data));

	PDL_Float * ea_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Float * ea_physdatap = ((PDL_Float *)((__privtrans->pdls[8])->data));

	PDL_Float * eb_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Float * eb_physdatap = ((PDL_Float *)((__privtrans->pdls[9])->data));

	PDL_Float * epi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Float * epi_physdatap = ((PDL_Float *)((__privtrans->pdls[10])->data));

	PDL_Float * eomega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Float * eomega_physdatap = ((PDL_Float *)((__privtrans->pdls[11])->data));

{register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * omega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * omega_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Double * oq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Double * oq_physdatap = ((PDL_Double *)((__privtrans->pdls[5])->data));

	PDL_Double * alphaq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Double * alphaq_physdatap = ((PDL_Double *)((__privtrans->pdls[6])->data));

	PDL_Double * betaq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Double * betaq_physdatap = ((PDL_Double *)((__privtrans->pdls[7])->data));

	PDL_Double * ea_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Double * ea_physdatap = ((PDL_Double *)((__privtrans->pdls[8])->data));

	PDL_Double * eb_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Double * eb_physdatap = ((PDL_Double *)((__privtrans->pdls[9])->data));

	PDL_Double * epi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Double * epi_physdatap = ((PDL_Double *)((__privtrans->pdls[10])->data));

	PDL_Double * eomega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Double * eomega_physdatap = ((PDL_Double *)((__privtrans->pdls[11])->data));

{register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b","pi","omega","o","oq","alphaq","betaq","ea","eb","epi","eomega"};
		static PDL_Indx __realdims[] = {2,2,1,1,1,2,2,2,2,2,1,1};
		static char __funcname[] = "PDL::HMM::hmmexpectq";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 12
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,12,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 2) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[0]))->ndims < 2 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[1];
   } else if(((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[1]) {
      if(((__privtrans->pdls[0]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[1]))->ndims < 2) {
      if (((__privtrans->pdls[1]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[1]))->ndims < 2 && __privtrans->__M_size <= 1) __privtrans->__M_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[1]))->dims[0];
   } else if(((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[1]))->dims[0]) {
      if(((__privtrans->pdls[1]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__M_size == -1 || (((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size == 1)) {
      __privtrans->__M_size = ((__privtrans->pdls[1]))->dims[1];
   } else if(((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size != ((__privtrans->pdls[1]))->dims[1]) {
      if(((__privtrans->pdls[1]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[2]))->ndims < 1) {
      if (((__privtrans->pdls[2]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[2]))->dims[0];
   } else if(((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[2]))->dims[0]) {
      if(((__privtrans->pdls[2]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[3]))->ndims < 1) {
      if (((__privtrans->pdls[3]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[3]))->dims[0];
   } else if(((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[3]))->dims[0]) {
      if(((__privtrans->pdls[3]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[4]))->ndims < 1) {
      if (((__privtrans->pdls[4]))->ndims < 1 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[4]))->dims[0];
   } else if(((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__T_size != ((__privtrans->pdls[4]))->dims[0]) {
      if(((__privtrans->pdls[4]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[5]))->ndims < 2) {
      if (((__privtrans->pdls[5]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[5]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[5]))->dims[0];
   } else if(((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[5]))->dims[0]) {
      if(((__privtrans->pdls[5]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[5]))->dims[1];
   } else if(((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[5]))->dims[1]) {
      if(((__privtrans->pdls[5]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[6]))->ndims < 2) {
      if (((__privtrans->pdls[6]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[6]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[6]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[6]))->dims[0];
   } else if(((__privtrans->pdls[6]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[6]))->dims[0]) {
      if(((__privtrans->pdls[6]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[6]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[6]))->dims[1];
   } else if(((__privtrans->pdls[6]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[6]))->dims[1]) {
      if(((__privtrans->pdls[6]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[7]))->ndims < 2) {
      if (((__privtrans->pdls[7]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[7]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[7]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[7]))->dims[0];
   } else if(((__privtrans->pdls[7]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[7]))->dims[0]) {
      if(((__privtrans->pdls[7]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[7]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[7]))->dims[1];
   } else if(((__privtrans->pdls[7]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[7]))->dims[1]) {
      if(((__privtrans->pdls[7]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
if(!__creating[8]) {
   if(((__privtrans->pdls[8]))->ndims < 2) {
      if (((__privtrans->pdls[8]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[8]))->ndims < 2 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[8]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[8]))->dims[0];
   } else if(((__privtrans->pdls[8]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[8]))->dims[0]) {
      if(((__privtrans->pdls[8]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[8]))->ndims > 1 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[8]))->dims[1];
   } else if(((__privtrans->pdls[8]))->ndims > 1 && __privtrans->__N_size != ((__privtrans->pdls[8]))->dims[1]) {
      if(((__privtrans->pdls[8]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;dims[1] = __privtrans->__N_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,8,dims,0);
}if(!__creating[9]) {
   if(((__privtrans->pdls[9]))->ndims < 2) {
      if (((__privtrans->pdls[9]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[9]))->ndims < 2 && __privtrans->__M_size <= 1) __privtrans->__M_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[9]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[9]))->dims[0];
   } else if(((__privtrans->pdls[9]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[9]))->dims[0]) {
      if(((__privtrans->pdls[9]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__M_size == -1 || (((__privtrans->pdls[9]))->ndims > 1 && __privtrans->__M_size == 1)) {
      __privtrans->__M_size = ((__privtrans->pdls[9]))->dims[1];
   } else if(((__privtrans->pdls[9]))->ndims > 1 && __privtrans->__M_size != ((__privtrans->pdls[9]))->dims[1]) {
      if(((__privtrans->pdls[9]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;dims[1] = __privtrans->__M_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,9,dims,0);
}if(!__creating[10]) {
   if(((__privtrans->pdls[10]))->ndims < 1) {
      if (((__privtrans->pdls[10]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[10]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[10]))->dims[0];
   } else if(((__privtrans->pdls[10]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[10]))->dims[0]) {
      if(((__privtrans->pdls[10]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[2]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,10,dims,0);
}if(!__creating[11]) {
   if(((__privtrans->pdls[11]))->ndims < 1) {
      if (((__privtrans->pdls[11]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[11]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[11]))->dims[0];
   } else if(((__privtrans->pdls[11]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[11]))->dims[0]) {
      if(((__privtrans->pdls[11]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmexpectq:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[2]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,11,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[3]->hdrsv &&
	 (__privtrans->pdls[3]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[3]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[3]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[4]->hdrsv &&
	 (__privtrans->pdls[4]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[4]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[4]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[5]->hdrsv &&
	 (__privtrans->pdls[5]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[5]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[5]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[6]->hdrsv &&
	 (__privtrans->pdls[6]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[6]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[6]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[7]->hdrsv &&
	 (__privtrans->pdls[7]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[7]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[7]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[8] && 
     __privtrans->pdls[8]->hdrsv &&
	 (__privtrans->pdls[8]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[8]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[8]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[9] && 
     __privtrans->pdls[9]->hdrsv &&
	 (__privtrans->pdls[9]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[9]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[9]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[10] && 
     __privtrans->pdls[10]->hdrsv &&
	 (__privtrans->pdls[10]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[10]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[10]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[11] && 
     __privtrans->pdls[11]->hdrsv &&
	 (__privtrans->pdls[11]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[11]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[11]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[8]->hdrsv != hdrp ){
	 if( __privtrans->pdls[8]->hdrsv && __privtrans->pdls[8]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[8]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[8]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[8]->state |= PDL_HDRCPY;
       if ( __privtrans->pdls[9]->hdrsv != hdrp ){
	 if( __privtrans->pdls[9]->hdrsv && __privtrans->pdls[9]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[9]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[9]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[9]->state |= PDL_HDRCPY;
       if ( __privtrans->pdls[10]->hdrsv != hdrp ){
	 if( __privtrans->pdls[10]->hdrsv && __privtrans->pdls[10]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[10]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[10]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[10]->state |= PDL_HDRCPY;
       if ( __privtrans->pdls[11]->hdrsv != hdrp ){
	 if( __privtrans->pdls[11]->hdrsv && __privtrans->pdls[11]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[11]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[11]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[11]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_a_N0 = 0; else
		 __privtrans->__inc_a_N0 = PDL_REPRINC(__privtrans->pdls[0],0);if(__privtrans->pdls[0]->ndims <= 1 || __privtrans->pdls[0]->dims[1] <= 1)
		  __privtrans->__inc_a_N1 = 0; else
		 __privtrans->__inc_a_N1 = PDL_REPRINC(__privtrans->pdls[0],1);if(__privtrans->pdls[1]->ndims <= 0 || __privtrans->pdls[1]->dims[0] <= 1)
		  __privtrans->__inc_b_N = 0; else
		 __privtrans->__inc_b_N = PDL_REPRINC(__privtrans->pdls[1],0);if(__privtrans->pdls[1]->ndims <= 1 || __privtrans->pdls[1]->dims[1] <= 1)
		  __privtrans->__inc_b_M = 0; else
		 __privtrans->__inc_b_M = PDL_REPRINC(__privtrans->pdls[1],1);if(__privtrans->pdls[2]->ndims <= 0 || __privtrans->pdls[2]->dims[0] <= 1)
		  __privtrans->__inc_pi_N = 0; else
		 __privtrans->__inc_pi_N = PDL_REPRINC(__privtrans->pdls[2],0);if(__privtrans->pdls[3]->ndims <= 0 || __privtrans->pdls[3]->dims[0] <= 1)
		  __privtrans->__inc_omega_N = 0; else
		 __privtrans->__inc_omega_N = PDL_REPRINC(__privtrans->pdls[3],0);if(__privtrans->pdls[4]->ndims <= 0 || __privtrans->pdls[4]->dims[0] <= 1)
		  __privtrans->__inc_o_T = 0; else
		 __privtrans->__inc_o_T = PDL_REPRINC(__privtrans->pdls[4],0);if(__privtrans->pdls[5]->ndims <= 0 || __privtrans->pdls[5]->dims[0] <= 1)
		  __privtrans->__inc_oq_Q = 0; else
		 __privtrans->__inc_oq_Q = PDL_REPRINC(__privtrans->pdls[5],0);if(__privtrans->pdls[5]->ndims <= 1 || __privtrans->pdls[5]->dims[1] <= 1)
		  __privtrans->__inc_oq_T = 0; else
		 __privtrans->__inc_oq_T = PDL_REPRINC(__privtrans->pdls[5],1);if(__privtrans->pdls[6]->ndims <= 0 || __privtrans->pdls[6]->dims[0] <= 1)
		  __privtrans->__inc_alphaq_Q = 0; else
		 __privtrans->__inc_alphaq_Q = PDL_REPRINC(__privtrans->pdls[6],0);if(__privtrans->pdls[6]->ndims <= 1 || __privtrans->pdls[6]->dims[1] <= 1)
		  __privtrans->__inc_alphaq_T = 0; else
		 __privtrans->__inc_alphaq_T = PDL_REPRINC(__privtrans->pdls[6],1);if(__privtrans->pdls[7]->ndims <= 0 || __privtrans->pdls[7]->dims[0] <= 1)
		  __privtrans->__inc_betaq_Q = 0; else
		 __privtrans->__inc_betaq_Q = PDL_REPRINC(__privtrans->pdls[7],0);if(__privtrans->pdls[7]->ndims <= 1 || __privtrans->pdls[7]->dims[1] <= 1)
		  __privtrans->__inc_betaq_T = 0; else
		 __privtrans->__inc_betaq_T = PDL_REPRINC(__privtrans->pdls[7],1);if(__privtrans->pdls[8]->ndims <= 0 || __privtrans->pdls[8]->dims[0] <= 1)
		  __privtrans->__inc_ea_N0 = 0; else
		 __privtrans->__inc_ea_N0 = PDL_REPRINC(__privtrans->pdls[8],0);if(__privtrans->pdls[8]->ndims <= 1 || __privtrans->pdls[8]->dims[1] <= 1)
		  __privtrans->__inc_ea_N1 = 0; else
		 __privtrans->__inc_ea_N1 = PDL_REPRINC(__privtrans->pdls[8],1);if(__privtrans->pdls[9]->ndims <= 0 || __privtrans->pdls[9]->dims[0] <= 1)
		  __privtrans->__inc_eb_N = 0; else
		 __privtrans->__inc_eb_N = PDL_REPRINC(__privtrans->pdls[9],0);if(__privtrans->pdls[9]->ndims <= 1 || __privtrans->pdls[9]->dims[1] <= 1)
		  __privtrans->__inc_eb_M = 0; else
		 __privtrans->__inc_eb_M = PDL_REPRINC(__privtrans->pdls[9],1);if(__privtrans->pdls[10]->ndims <= 0 || __privtrans->pdls[10]->dims[0] <= 1)
		  __privtrans->__inc_epi_N = 0; else
		 __privtrans->__inc_epi_N = PDL_REPRINC(__privtrans->pdls[10],0);if(__privtrans->pdls[11]->ndims <= 0 || __privtrans->pdls[11]->dims[0] <= 1)
		  __privtrans->__inc_eomega_N = 0; else
		 __privtrans->__inc_eomega_N = PDL_REPRINC(__privtrans->pdls[11],0); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_hmmexpectq_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmexpectq_struct *__privtrans = (pdl_hmmexpectq_struct *) __tr;
	
	{
	    pdl_hmmexpectq_struct *__copy = malloc(sizeof(pdl_hmmexpectq_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_a_N0=__copy->__inc_a_N0;__privtrans->__inc_a_N1=__copy->__inc_a_N1;__privtrans->__inc_b_N=__copy->__inc_b_N;__privtrans->__inc_b_M=__copy->__inc_b_M;__privtrans->__inc_pi_N=__copy->__inc_pi_N;__privtrans->__inc_omega_N=__copy->__inc_omega_N;__privtrans->__inc_o_T=__copy->__inc_o_T;__privtrans->__inc_oq_Q=__copy->__inc_oq_Q;__privtrans->__inc_oq_T=__copy->__inc_oq_T;__privtrans->__inc_alphaq_Q=__copy->__inc_alphaq_Q;__privtrans->__inc_alphaq_T=__copy->__inc_alphaq_T;__privtrans->__inc_betaq_Q=__copy->__inc_betaq_Q;__privtrans->__inc_betaq_T=__copy->__inc_betaq_T;__privtrans->__inc_ea_N0=__copy->__inc_ea_N0;__privtrans->__inc_ea_N1=__copy->__inc_ea_N1;__privtrans->__inc_eb_N=__copy->__inc_eb_N;__privtrans->__inc_eb_M=__copy->__inc_eb_M;__privtrans->__inc_epi_N=__copy->__inc_epi_N;__privtrans->__inc_eomega_N=__copy->__inc_eomega_N;__copy->__N_size=__privtrans->__N_size;__copy->__T_size=__privtrans->__T_size;__copy->__Q_size=__privtrans->__Q_size;__copy->__M_size=__privtrans->__M_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_hmmexpectq_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmexpectq_struct *__privtrans = (pdl_hmmexpectq_struct *) __tr;
	
	{
	    {PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * omega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * omega_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Byte * oq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Byte * oq_physdatap = ((PDL_Byte *)((__privtrans->pdls[5])->data));

	PDL_Byte * alphaq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Byte * alphaq_physdatap = ((PDL_Byte *)((__privtrans->pdls[6])->data));

	PDL_Byte * betaq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Byte * betaq_physdatap = ((PDL_Byte *)((__privtrans->pdls[7])->data));

	PDL_Byte * ea_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Byte * ea_physdatap = ((PDL_Byte *)((__privtrans->pdls[8])->data));

	PDL_Byte * eb_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Byte * eb_physdatap = ((PDL_Byte *)((__privtrans->pdls[9])->data));

	PDL_Byte * epi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Byte * epi_physdatap = ((PDL_Byte *)((__privtrans->pdls[10])->data));

	PDL_Byte * eomega_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Byte * eomega_physdatap = ((PDL_Byte *)((__privtrans->pdls[11])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc0_11 = __privtrans->__pdlthread.incs[11];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	register PDL_Indx __tinc1_11 = __privtrans->__pdlthread.incs[__tnpdls+11];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	oq_datap += __offsp[5];
	alphaq_datap += __offsp[6];
	betaq_datap += __offsp[7];
	ea_datap += __offsp[8];
	eb_datap += __offsp[9];
	epi_datap += __offsp[10];
	eomega_datap += __offsp[11];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,oq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,alphaq_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,betaq_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,ea_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,eb_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,epi_datap += __tinc1_10 - __tinc0_10 * __tdims0
			,eomega_datap += __tinc1_11 - __tinc0_11 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,oq_datap += __tinc0_5
			,alphaq_datap += __tinc0_6
			,betaq_datap += __tinc0_7
			,ea_datap += __tinc0_8
			,eb_datap += __tinc0_9
			,epi_datap += __tinc0_10
			,eomega_datap += __tinc0_11
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 int i,j,t, qi,qj;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;

   p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  + (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
 }

 /*-- Initialize: t==(T-1): Iterate: q_(t)=qi: state_t=oq(qi,t)=i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i                = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;
   gamma_it         = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Loop: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     i        = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     if (i < 0) break;
     gamma_it = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Loop: q_(t+1)=qj: state_(t+1)=oq(qj,t+1)=j --*/
     for (qj=0; qj<__privtrans->__Q_size; qj++) {
       j      = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       xi_ijt = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
   /*-- End Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
 }
 /*-- End Loop: T-1 > t >= 0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	oq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	alphaq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	betaq_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	ea_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	eb_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	epi_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	eomega_datap -= __tinc1_11 * __tdims1 + __offsp[11];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * omega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * omega_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Short * oq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Short * oq_physdatap = ((PDL_Short *)((__privtrans->pdls[5])->data));

	PDL_Short * alphaq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Short * alphaq_physdatap = ((PDL_Short *)((__privtrans->pdls[6])->data));

	PDL_Short * betaq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Short * betaq_physdatap = ((PDL_Short *)((__privtrans->pdls[7])->data));

	PDL_Short * ea_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Short * ea_physdatap = ((PDL_Short *)((__privtrans->pdls[8])->data));

	PDL_Short * eb_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Short * eb_physdatap = ((PDL_Short *)((__privtrans->pdls[9])->data));

	PDL_Short * epi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Short * epi_physdatap = ((PDL_Short *)((__privtrans->pdls[10])->data));

	PDL_Short * eomega_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Short * eomega_physdatap = ((PDL_Short *)((__privtrans->pdls[11])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc0_11 = __privtrans->__pdlthread.incs[11];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	register PDL_Indx __tinc1_11 = __privtrans->__pdlthread.incs[__tnpdls+11];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	oq_datap += __offsp[5];
	alphaq_datap += __offsp[6];
	betaq_datap += __offsp[7];
	ea_datap += __offsp[8];
	eb_datap += __offsp[9];
	epi_datap += __offsp[10];
	eomega_datap += __offsp[11];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,oq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,alphaq_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,betaq_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,ea_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,eb_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,epi_datap += __tinc1_10 - __tinc0_10 * __tdims0
			,eomega_datap += __tinc1_11 - __tinc0_11 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,oq_datap += __tinc0_5
			,alphaq_datap += __tinc0_6
			,betaq_datap += __tinc0_7
			,ea_datap += __tinc0_8
			,eb_datap += __tinc0_9
			,epi_datap += __tinc0_10
			,eomega_datap += __tinc0_11
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 int i,j,t, qi,qj;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;

   p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  + (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
 }

 /*-- Initialize: t==(T-1): Iterate: q_(t)=qi: state_t=oq(qi,t)=i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i                = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;
   gamma_it         = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Loop: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     i        = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     if (i < 0) break;
     gamma_it = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Loop: q_(t+1)=qj: state_(t+1)=oq(qj,t+1)=j --*/
     for (qj=0; qj<__privtrans->__Q_size; qj++) {
       j      = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       xi_ijt = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
   /*-- End Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
 }
 /*-- End Loop: T-1 > t >= 0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	oq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	alphaq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	betaq_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	ea_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	eb_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	epi_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	eomega_datap -= __tinc1_11 * __tdims1 + __offsp[11];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * omega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * omega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Ushort * oq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Ushort * oq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[5])->data));

	PDL_Ushort * alphaq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Ushort * alphaq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[6])->data));

	PDL_Ushort * betaq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Ushort * betaq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[7])->data));

	PDL_Ushort * ea_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Ushort * ea_physdatap = ((PDL_Ushort *)((__privtrans->pdls[8])->data));

	PDL_Ushort * eb_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Ushort * eb_physdatap = ((PDL_Ushort *)((__privtrans->pdls[9])->data));

	PDL_Ushort * epi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Ushort * epi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[10])->data));

	PDL_Ushort * eomega_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Ushort * eomega_physdatap = ((PDL_Ushort *)((__privtrans->pdls[11])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc0_11 = __privtrans->__pdlthread.incs[11];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	register PDL_Indx __tinc1_11 = __privtrans->__pdlthread.incs[__tnpdls+11];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	oq_datap += __offsp[5];
	alphaq_datap += __offsp[6];
	betaq_datap += __offsp[7];
	ea_datap += __offsp[8];
	eb_datap += __offsp[9];
	epi_datap += __offsp[10];
	eomega_datap += __offsp[11];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,oq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,alphaq_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,betaq_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,ea_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,eb_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,epi_datap += __tinc1_10 - __tinc0_10 * __tdims0
			,eomega_datap += __tinc1_11 - __tinc0_11 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,oq_datap += __tinc0_5
			,alphaq_datap += __tinc0_6
			,betaq_datap += __tinc0_7
			,ea_datap += __tinc0_8
			,eb_datap += __tinc0_9
			,epi_datap += __tinc0_10
			,eomega_datap += __tinc0_11
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 int i,j,t, qi,qj;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;

   p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  + (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
 }

 /*-- Initialize: t==(T-1): Iterate: q_(t)=qi: state_t=oq(qi,t)=i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i                = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;
   gamma_it         = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Loop: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     i        = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     if (i < 0) break;
     gamma_it = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Loop: q_(t+1)=qj: state_(t+1)=oq(qj,t+1)=j --*/
     for (qj=0; qj<__privtrans->__Q_size; qj++) {
       j      = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       xi_ijt = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
   /*-- End Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
 }
 /*-- End Loop: T-1 > t >= 0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	oq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	alphaq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	betaq_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	ea_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	eb_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	epi_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	eomega_datap -= __tinc1_11 * __tdims1 + __offsp[11];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * omega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * omega_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * oq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * oq_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

	PDL_Long * alphaq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * alphaq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

	PDL_Long * betaq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Long * betaq_physdatap = ((PDL_Long *)((__privtrans->pdls[7])->data));

	PDL_Long * ea_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Long * ea_physdatap = ((PDL_Long *)((__privtrans->pdls[8])->data));

	PDL_Long * eb_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Long * eb_physdatap = ((PDL_Long *)((__privtrans->pdls[9])->data));

	PDL_Long * epi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Long * epi_physdatap = ((PDL_Long *)((__privtrans->pdls[10])->data));

	PDL_Long * eomega_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Long * eomega_physdatap = ((PDL_Long *)((__privtrans->pdls[11])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc0_11 = __privtrans->__pdlthread.incs[11];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	register PDL_Indx __tinc1_11 = __privtrans->__pdlthread.incs[__tnpdls+11];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	oq_datap += __offsp[5];
	alphaq_datap += __offsp[6];
	betaq_datap += __offsp[7];
	ea_datap += __offsp[8];
	eb_datap += __offsp[9];
	epi_datap += __offsp[10];
	eomega_datap += __offsp[11];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,oq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,alphaq_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,betaq_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,ea_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,eb_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,epi_datap += __tinc1_10 - __tinc0_10 * __tdims0
			,eomega_datap += __tinc1_11 - __tinc0_11 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,oq_datap += __tinc0_5
			,alphaq_datap += __tinc0_6
			,betaq_datap += __tinc0_7
			,ea_datap += __tinc0_8
			,eb_datap += __tinc0_9
			,epi_datap += __tinc0_10
			,eomega_datap += __tinc0_11
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 int i,j,t, qi,qj;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;

   p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  + (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
 }

 /*-- Initialize: t==(T-1): Iterate: q_(t)=qi: state_t=oq(qi,t)=i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i                = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;
   gamma_it         = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Loop: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     i        = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     if (i < 0) break;
     gamma_it = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Loop: q_(t+1)=qj: state_(t+1)=oq(qj,t+1)=j --*/
     for (qj=0; qj<__privtrans->__Q_size; qj++) {
       j      = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       xi_ijt = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
   /*-- End Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
 }
 /*-- End Loop: T-1 > t >= 0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	oq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	alphaq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	betaq_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	ea_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	eb_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	epi_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	eomega_datap -= __tinc1_11 * __tdims1 + __offsp[11];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * omega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * omega_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Indx * oq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Indx * oq_physdatap = ((PDL_Indx *)((__privtrans->pdls[5])->data));

	PDL_Indx * alphaq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Indx * alphaq_physdatap = ((PDL_Indx *)((__privtrans->pdls[6])->data));

	PDL_Indx * betaq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Indx * betaq_physdatap = ((PDL_Indx *)((__privtrans->pdls[7])->data));

	PDL_Indx * ea_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Indx * ea_physdatap = ((PDL_Indx *)((__privtrans->pdls[8])->data));

	PDL_Indx * eb_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Indx * eb_physdatap = ((PDL_Indx *)((__privtrans->pdls[9])->data));

	PDL_Indx * epi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Indx * epi_physdatap = ((PDL_Indx *)((__privtrans->pdls[10])->data));

	PDL_Indx * eomega_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Indx * eomega_physdatap = ((PDL_Indx *)((__privtrans->pdls[11])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc0_11 = __privtrans->__pdlthread.incs[11];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	register PDL_Indx __tinc1_11 = __privtrans->__pdlthread.incs[__tnpdls+11];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	oq_datap += __offsp[5];
	alphaq_datap += __offsp[6];
	betaq_datap += __offsp[7];
	ea_datap += __offsp[8];
	eb_datap += __offsp[9];
	epi_datap += __offsp[10];
	eomega_datap += __offsp[11];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,oq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,alphaq_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,betaq_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,ea_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,eb_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,epi_datap += __tinc1_10 - __tinc0_10 * __tdims0
			,eomega_datap += __tinc1_11 - __tinc0_11 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,oq_datap += __tinc0_5
			,alphaq_datap += __tinc0_6
			,betaq_datap += __tinc0_7
			,ea_datap += __tinc0_8
			,eb_datap += __tinc0_9
			,epi_datap += __tinc0_10
			,eomega_datap += __tinc0_11
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 int i,j,t, qi,qj;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;

   p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  + (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
 }

 /*-- Initialize: t==(T-1): Iterate: q_(t)=qi: state_t=oq(qi,t)=i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i                = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;
   gamma_it         = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Loop: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     i        = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     if (i < 0) break;
     gamma_it = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Loop: q_(t+1)=qj: state_(t+1)=oq(qj,t+1)=j --*/
     for (qj=0; qj<__privtrans->__Q_size; qj++) {
       j      = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       xi_ijt = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
   /*-- End Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
 }
 /*-- End Loop: T-1 > t >= 0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	oq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	alphaq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	betaq_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	ea_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	eb_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	epi_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	eomega_datap -= __tinc1_11 * __tdims1 + __offsp[11];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * omega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * omega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_LongLong * oq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_LongLong * oq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[5])->data));

	PDL_LongLong * alphaq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_LongLong * alphaq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[6])->data));

	PDL_LongLong * betaq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_LongLong * betaq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[7])->data));

	PDL_LongLong * ea_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_LongLong * ea_physdatap = ((PDL_LongLong *)((__privtrans->pdls[8])->data));

	PDL_LongLong * eb_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_LongLong * eb_physdatap = ((PDL_LongLong *)((__privtrans->pdls[9])->data));

	PDL_LongLong * epi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_LongLong * epi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[10])->data));

	PDL_LongLong * eomega_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_LongLong * eomega_physdatap = ((PDL_LongLong *)((__privtrans->pdls[11])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc0_11 = __privtrans->__pdlthread.incs[11];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	register PDL_Indx __tinc1_11 = __privtrans->__pdlthread.incs[__tnpdls+11];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	oq_datap += __offsp[5];
	alphaq_datap += __offsp[6];
	betaq_datap += __offsp[7];
	ea_datap += __offsp[8];
	eb_datap += __offsp[9];
	epi_datap += __offsp[10];
	eomega_datap += __offsp[11];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,oq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,alphaq_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,betaq_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,ea_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,eb_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,epi_datap += __tinc1_10 - __tinc0_10 * __tdims0
			,eomega_datap += __tinc1_11 - __tinc0_11 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,oq_datap += __tinc0_5
			,alphaq_datap += __tinc0_6
			,betaq_datap += __tinc0_7
			,ea_datap += __tinc0_8
			,eb_datap += __tinc0_9
			,epi_datap += __tinc0_10
			,eomega_datap += __tinc0_11
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 int i,j,t, qi,qj;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;

   p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  + (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
 }

 /*-- Initialize: t==(T-1): Iterate: q_(t)=qi: state_t=oq(qi,t)=i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i                = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;
   gamma_it         = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Loop: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     i        = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     if (i < 0) break;
     gamma_it = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Loop: q_(t+1)=qj: state_(t+1)=oq(qj,t+1)=j --*/
     for (qj=0; qj<__privtrans->__Q_size; qj++) {
       j      = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       xi_ijt = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
   /*-- End Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
 }
 /*-- End Loop: T-1 > t >= 0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	oq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	alphaq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	betaq_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	ea_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	eb_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	epi_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	eomega_datap -= __tinc1_11 * __tdims1 + __offsp[11];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * omega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * omega_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Float * oq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Float * oq_physdatap = ((PDL_Float *)((__privtrans->pdls[5])->data));

	PDL_Float * alphaq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Float * alphaq_physdatap = ((PDL_Float *)((__privtrans->pdls[6])->data));

	PDL_Float * betaq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Float * betaq_physdatap = ((PDL_Float *)((__privtrans->pdls[7])->data));

	PDL_Float * ea_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Float * ea_physdatap = ((PDL_Float *)((__privtrans->pdls[8])->data));

	PDL_Float * eb_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Float * eb_physdatap = ((PDL_Float *)((__privtrans->pdls[9])->data));

	PDL_Float * epi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Float * epi_physdatap = ((PDL_Float *)((__privtrans->pdls[10])->data));

	PDL_Float * eomega_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Float * eomega_physdatap = ((PDL_Float *)((__privtrans->pdls[11])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc0_11 = __privtrans->__pdlthread.incs[11];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	register PDL_Indx __tinc1_11 = __privtrans->__pdlthread.incs[__tnpdls+11];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	oq_datap += __offsp[5];
	alphaq_datap += __offsp[6];
	betaq_datap += __offsp[7];
	ea_datap += __offsp[8];
	eb_datap += __offsp[9];
	epi_datap += __offsp[10];
	eomega_datap += __offsp[11];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,oq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,alphaq_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,betaq_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,ea_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,eb_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,epi_datap += __tinc1_10 - __tinc0_10 * __tdims0
			,eomega_datap += __tinc1_11 - __tinc0_11 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,oq_datap += __tinc0_5
			,alphaq_datap += __tinc0_6
			,betaq_datap += __tinc0_7
			,ea_datap += __tinc0_8
			,eb_datap += __tinc0_9
			,epi_datap += __tinc0_10
			,eomega_datap += __tinc0_11
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 int i,j,t, qi,qj;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;

   p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  + (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
 }

 /*-- Initialize: t==(T-1): Iterate: q_(t)=qi: state_t=oq(qi,t)=i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i                = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;
   gamma_it         = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Loop: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     i        = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     if (i < 0) break;
     gamma_it = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Loop: q_(t+1)=qj: state_(t+1)=oq(qj,t+1)=j --*/
     for (qj=0; qj<__privtrans->__Q_size; qj++) {
       j      = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       xi_ijt = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
   /*-- End Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
 }
 /*-- End Loop: T-1 > t >= 0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	oq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	alphaq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	betaq_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	ea_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	eb_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	epi_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	eomega_datap -= __tinc1_11 * __tdims1 + __offsp[11];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * omega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * omega_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Double * oq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Double * oq_physdatap = ((PDL_Double *)((__privtrans->pdls[5])->data));

	PDL_Double * alphaq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Double * alphaq_physdatap = ((PDL_Double *)((__privtrans->pdls[6])->data));

	PDL_Double * betaq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[7]),(__privtrans->vtable->per_pdl_flags[7]))));
	PDL_Double * betaq_physdatap = ((PDL_Double *)((__privtrans->pdls[7])->data));

	PDL_Double * ea_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[8]),(__privtrans->vtable->per_pdl_flags[8]))));
	PDL_Double * ea_physdatap = ((PDL_Double *)((__privtrans->pdls[8])->data));

	PDL_Double * eb_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[9]),(__privtrans->vtable->per_pdl_flags[9]))));
	PDL_Double * eb_physdatap = ((PDL_Double *)((__privtrans->pdls[9])->data));

	PDL_Double * epi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[10]),(__privtrans->vtable->per_pdl_flags[10]))));
	PDL_Double * epi_physdatap = ((PDL_Double *)((__privtrans->pdls[10])->data));

	PDL_Double * eomega_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[11]),(__privtrans->vtable->per_pdl_flags[11]))));
	PDL_Double * eomega_physdatap = ((PDL_Double *)((__privtrans->pdls[11])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc0_7 = __privtrans->__pdlthread.incs[7];
	register PDL_Indx __tinc0_8 = __privtrans->__pdlthread.incs[8];
	register PDL_Indx __tinc0_9 = __privtrans->__pdlthread.incs[9];
	register PDL_Indx __tinc0_10 = __privtrans->__pdlthread.incs[10];
	register PDL_Indx __tinc0_11 = __privtrans->__pdlthread.incs[11];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	register PDL_Indx __tinc1_7 = __privtrans->__pdlthread.incs[__tnpdls+7];
	register PDL_Indx __tinc1_8 = __privtrans->__pdlthread.incs[__tnpdls+8];
	register PDL_Indx __tinc1_9 = __privtrans->__pdlthread.incs[__tnpdls+9];
	register PDL_Indx __tinc1_10 = __privtrans->__pdlthread.incs[__tnpdls+10];
	register PDL_Indx __tinc1_11 = __privtrans->__pdlthread.incs[__tnpdls+11];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	omega_datap += __offsp[3];
	o_datap += __offsp[4];
	oq_datap += __offsp[5];
	alphaq_datap += __offsp[6];
	betaq_datap += __offsp[7];
	ea_datap += __offsp[8];
	eb_datap += __offsp[9];
	epi_datap += __offsp[10];
	eomega_datap += __offsp[11];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,omega_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,o_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,oq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,alphaq_datap += __tinc1_6 - __tinc0_6 * __tdims0
			,betaq_datap += __tinc1_7 - __tinc0_7 * __tdims0
			,ea_datap += __tinc1_8 - __tinc0_8 * __tdims0
			,eb_datap += __tinc1_9 - __tinc0_9 * __tdims0
			,epi_datap += __tinc1_10 - __tinc0_10 * __tdims0
			,eomega_datap += __tinc1_11 - __tinc0_11 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,omega_datap += __tinc0_3
			,o_datap += __tinc0_4
			,oq_datap += __tinc0_5
			,alphaq_datap += __tinc0_6
			,betaq_datap += __tinc0_7
			,ea_datap += __tinc0_8
			,eb_datap += __tinc0_9
			,epi_datap += __tinc0_10
			,eomega_datap += __tinc0_11
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_alphaq_Q = __privtrans->__inc_alphaq_Q;
register PDL_Indx __inc_alphaq_T = __privtrans->__inc_alphaq_T;
register PDL_Indx __inc_ea_N0 = __privtrans->__inc_ea_N0;
register PDL_Indx __inc_ea_N1 = __privtrans->__inc_ea_N1;
register PDL_Indx __inc_epi_N = __privtrans->__inc_epi_N;
register PDL_Indx __inc_omega_N = __privtrans->__inc_omega_N;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_eb_N = __privtrans->__inc_eb_N;
register PDL_Indx __inc_eb_M = __privtrans->__inc_eb_M;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_eomega_N = __privtrans->__inc_eomega_N;
register PDL_Indx __inc_betaq_Q = __privtrans->__inc_betaq_Q;
register PDL_Indx __inc_betaq_T = __privtrans->__inc_betaq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 int i,j,t, qi,qj;
 int o_tp1, o_t;
 double p_o = LOG_ZERO;
 double gamma_it;
 double xi_ijt;

 /*-- Initialize: t==(T-1): P(o|@theta) --*/
 t = __privtrans->__T_size-1;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;

   p_o = logadd(p_o, (omega_datap)[0+(__inc_omega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  + (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
 }

 /*-- Initialize: t==(T-1): Iterate: q_(t)=qi: state_t=oq(qi,t)=i: get gamma(i,t) --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi < __privtrans->__Q_size; qi++) {
   i                = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
   if (i < 0) break;
   gamma_it         = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;
   (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  = logadd((eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") , gamma_it);
   (eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")     = logadd((eomega_datap)[0+(__inc_eomega_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")    , gamma_it);
 }

 /*-- Loop: T-1 > t >= 0 --*/
 for (t--; t>=0; t--) {
   o_tp1 = o_t;
   o_t   = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
   for (qi=0; qi<__privtrans->__Q_size; qi++) {
     i        = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     if (i < 0) break;
     gamma_it = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  - p_o;

     /*-- Loop: q_(t+1)=qj: state_(t+1)=oq(qj,t+1)=j --*/
     for (qj=0; qj<__privtrans->__Q_size; qj++) {
       j      = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0) break;

       xi_ijt = (alphaq_datap)[0+(__inc_alphaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_alphaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_tp1))] PDL_COMMENT("ACCESS()")  + (betaq_datap)[0+(__inc_betaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_betaq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()")  - p_o;

       (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()")  = logadd(xi_ijt, (ea_datap)[0+(__inc_ea_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_ea_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") );
     }

     /*-- Update: pi --*/
     if (t==0) (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()")  = logadd(gamma_it, (epi_datap)[0+(__inc_epi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") );

     /*-- Update: b --*/
     (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")      = logadd(gamma_it, (eb_datap)[0+(__inc_eb_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_eb_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") );
   }
   /*-- End Loop: q_(t)=qi: state_(t)=oq(qi,t)=i --*/
 }
 /*-- End Loop: T-1 > t >= 0 --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	omega_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	o_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	oq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	alphaq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	betaq_datap -= __tinc1_7 * __tdims1 + __offsp[7];
	ea_datap -= __tinc1_8 * __tdims1 + __offsp[8];
	eb_datap -= __tinc1_9 * __tdims1 + __offsp[9];
	epi_datap -= __tinc1_10 * __tdims1 + __offsp[10];
	eomega_datap -= __tinc1_11 * __tdims1 + __offsp[11];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_hmmexpectq_free(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmexpectq_struct *__privtrans = (pdl_hmmexpectq_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;;;;;;;;;;;;;;;;;;;;;;
			}
			
	}
    }
    



static char pdl_hmmexpectq_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_hmmexpectq_vtable = {
		0,0, 8, 12, pdl_hmmexpectq_vtable_flags,
		pdl_hmmexpectq_redodims, pdl_hmmexpectq_readdata, NULL,
		pdl_hmmexpectq_free,NULL,NULL,pdl_hmmexpectq_copy,
		sizeof(pdl_hmmexpectq_struct),"pdl_hmmexpectq_vtable"
	 };

typedef struct pdl_hmmviterbi_struct {
		PDL_TRANS_START(6);
		pdl_thread  __pdlthread;PDL_Indx  __inc_a_N0;PDL_Indx  __inc_a_N1;PDL_Indx  __inc_b_N;PDL_Indx  __inc_b_M;PDL_Indx  __inc_pi_N;PDL_Indx  __inc_o_T;PDL_Indx  __inc_delta_N;PDL_Indx  __inc_delta_T;PDL_Indx  __inc_psi_N;PDL_Indx  __inc_psi_T;PDL_Indx  __T_size;PDL_Indx  __N_size;PDL_Indx  __M_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_hmmviterbi_struct;

void pdl_hmmviterbi_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmviterbi_struct *__privtrans = (pdl_hmmviterbi_struct *) __tr;
	
	{
	    PDL_Indx __creating[6];
__privtrans->__T_size = -1;
__privtrans->__N_size = -1;
__privtrans->__M_size = -1;
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = 0;
__creating[3] = 0;
__creating[4] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[4]);
__creating[5] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[5]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * delta_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * delta_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * delta_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * delta_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * delta_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * delta_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * delta_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * delta_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * delta_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * delta_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * delta_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * delta_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * delta_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * delta_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * delta_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * delta_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

{register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b","pi","o","delta","psi"};
		static PDL_Indx __realdims[] = {2,2,1,1,2,2};
		static char __funcname[] = "PDL::HMM::hmmviterbi";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 6
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,6,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 2) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[0]))->ndims < 2 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbi:" "Wrong dims\n");
      }
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[1];
   } else if(((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[1]) {
      if(((__privtrans->pdls[0]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmviterbi:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[1]))->ndims < 2) {
      if (((__privtrans->pdls[1]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[1]))->ndims < 2 && __privtrans->__M_size <= 1) __privtrans->__M_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[1]))->dims[0];
   } else if(((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[1]))->dims[0]) {
      if(((__privtrans->pdls[1]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbi:" "Wrong dims\n");
      }
   }
   if(__privtrans->__M_size == -1 || (((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size == 1)) {
      __privtrans->__M_size = ((__privtrans->pdls[1]))->dims[1];
   } else if(((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size != ((__privtrans->pdls[1]))->dims[1]) {
      if(((__privtrans->pdls[1]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmviterbi:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[2]))->ndims < 1) {
      if (((__privtrans->pdls[2]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[2]))->dims[0];
   } else if(((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[2]))->dims[0]) {
      if(((__privtrans->pdls[2]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbi:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[3]))->ndims < 1) {
      if (((__privtrans->pdls[3]))->ndims < 1 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[3]))->dims[0];
   } else if(((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size != ((__privtrans->pdls[3]))->dims[0]) {
      if(((__privtrans->pdls[3]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbi:" "Wrong dims\n");
      }
   }
if(!__creating[4]) {
   if(((__privtrans->pdls[4]))->ndims < 2) {
      if (((__privtrans->pdls[4]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[4]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[4]))->dims[0];
   } else if(((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[4]))->dims[0]) {
      if(((__privtrans->pdls[4]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbi:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[4]))->dims[1];
   } else if(((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[4]))->dims[1]) {
      if(((__privtrans->pdls[4]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmviterbi:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;dims[1] = __privtrans->__T_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,4,dims,0);
}if(!__creating[5]) {
   if(((__privtrans->pdls[5]))->ndims < 2) {
      if (((__privtrans->pdls[5]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[5]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[5]))->dims[0];
   } else if(((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[5]))->dims[0]) {
      if(((__privtrans->pdls[5]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbi:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[5]))->dims[1];
   } else if(((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[5]))->dims[1]) {
      if(((__privtrans->pdls[5]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmviterbi:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__N_size;dims[1] = __privtrans->__T_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,5,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[3]->hdrsv &&
	 (__privtrans->pdls[3]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[3]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[3]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[4] && 
     __privtrans->pdls[4]->hdrsv &&
	 (__privtrans->pdls[4]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[4]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[4]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[5] && 
     __privtrans->pdls[5]->hdrsv &&
	 (__privtrans->pdls[5]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[5]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[5]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[4]->hdrsv != hdrp ){
	 if( __privtrans->pdls[4]->hdrsv && __privtrans->pdls[4]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[4]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[4]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[4]->state |= PDL_HDRCPY;
       if ( __privtrans->pdls[5]->hdrsv != hdrp ){
	 if( __privtrans->pdls[5]->hdrsv && __privtrans->pdls[5]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[5]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[5]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[5]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_a_N0 = 0; else
		 __privtrans->__inc_a_N0 = PDL_REPRINC(__privtrans->pdls[0],0);if(__privtrans->pdls[0]->ndims <= 1 || __privtrans->pdls[0]->dims[1] <= 1)
		  __privtrans->__inc_a_N1 = 0; else
		 __privtrans->__inc_a_N1 = PDL_REPRINC(__privtrans->pdls[0],1);if(__privtrans->pdls[1]->ndims <= 0 || __privtrans->pdls[1]->dims[0] <= 1)
		  __privtrans->__inc_b_N = 0; else
		 __privtrans->__inc_b_N = PDL_REPRINC(__privtrans->pdls[1],0);if(__privtrans->pdls[1]->ndims <= 1 || __privtrans->pdls[1]->dims[1] <= 1)
		  __privtrans->__inc_b_M = 0; else
		 __privtrans->__inc_b_M = PDL_REPRINC(__privtrans->pdls[1],1);if(__privtrans->pdls[2]->ndims <= 0 || __privtrans->pdls[2]->dims[0] <= 1)
		  __privtrans->__inc_pi_N = 0; else
		 __privtrans->__inc_pi_N = PDL_REPRINC(__privtrans->pdls[2],0);if(__privtrans->pdls[3]->ndims <= 0 || __privtrans->pdls[3]->dims[0] <= 1)
		  __privtrans->__inc_o_T = 0; else
		 __privtrans->__inc_o_T = PDL_REPRINC(__privtrans->pdls[3],0);if(__privtrans->pdls[4]->ndims <= 0 || __privtrans->pdls[4]->dims[0] <= 1)
		  __privtrans->__inc_delta_N = 0; else
		 __privtrans->__inc_delta_N = PDL_REPRINC(__privtrans->pdls[4],0);if(__privtrans->pdls[4]->ndims <= 1 || __privtrans->pdls[4]->dims[1] <= 1)
		  __privtrans->__inc_delta_T = 0; else
		 __privtrans->__inc_delta_T = PDL_REPRINC(__privtrans->pdls[4],1);if(__privtrans->pdls[5]->ndims <= 0 || __privtrans->pdls[5]->dims[0] <= 1)
		  __privtrans->__inc_psi_N = 0; else
		 __privtrans->__inc_psi_N = PDL_REPRINC(__privtrans->pdls[5],0);if(__privtrans->pdls[5]->ndims <= 1 || __privtrans->pdls[5]->dims[1] <= 1)
		  __privtrans->__inc_psi_T = 0; else
		 __privtrans->__inc_psi_T = PDL_REPRINC(__privtrans->pdls[5],1); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_hmmviterbi_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmviterbi_struct *__privtrans = (pdl_hmmviterbi_struct *) __tr;
	
	{
	    pdl_hmmviterbi_struct *__copy = malloc(sizeof(pdl_hmmviterbi_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_a_N0=__copy->__inc_a_N0;__privtrans->__inc_a_N1=__copy->__inc_a_N1;__privtrans->__inc_b_N=__copy->__inc_b_N;__privtrans->__inc_b_M=__copy->__inc_b_M;__privtrans->__inc_pi_N=__copy->__inc_pi_N;__privtrans->__inc_o_T=__copy->__inc_o_T;__privtrans->__inc_delta_N=__copy->__inc_delta_N;__privtrans->__inc_delta_T=__copy->__inc_delta_T;__privtrans->__inc_psi_N=__copy->__inc_psi_N;__privtrans->__inc_psi_T=__copy->__inc_psi_T;__copy->__T_size=__privtrans->__T_size;__copy->__N_size=__privtrans->__N_size;__copy->__M_size=__privtrans->__M_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_hmmviterbi_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmviterbi_struct *__privtrans = (pdl_hmmviterbi_struct *) __tr;
	
	{
	    {register PDL_Indx __N_size = __privtrans->__N_size;
PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * delta_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * delta_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	delta_datap += __offsp[4];
	psi_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,delta_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,psi_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,delta_datap += __tinc0_4
			,psi_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;


 int i,j, t, o_t;
 double delta_jt, delta_tmp;
 int psi_jt;

 /*-- Initialize: t==0: Loop: state_0==N --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
   (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
#ifdef DEBUG_VITERBI
   printf("t=0,j=%d,o_t=%d: delta(t=0,j=%d)=%.2e  psi(t=0,j=%d)=%.0g  b(j=%d,o=%d)=%.2e\n",
           N,o_t,
           N, exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ),
           N, (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ,
           N,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ));
#endif
 }} PDL_COMMENT("Close N")

#ifdef DEBUG_VITERBI
   printf("\n");
#endif

 /*-- Main: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: t>0: Loop: state_t==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     psi_jt   = 0;
     delta_jt = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

     /*-- Main: t>0: Loop: state_(t-1)==i --*/
     for (i=1; i<__privtrans->__N_size; i++) {
       delta_tmp = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (delta_tmp > delta_jt) {
	 delta_jt = delta_tmp;
	 psi_jt   = i;
#ifdef DEBUG_VITERBI
         printf("+");
#endif
       }

#ifdef DEBUG_VITERBI
       printf("t=%d,i=%d,j=%d,o_t=%d:  deltaX(i=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g  delta(j=%d,t=%d)=%.2e\n",
              t,i,j,o_t,
              i,t,  exp(delta_tmp),
              j,t,  psi_jt,
              j,t,  exp(delta_jt));
#endif
     }

     /*-- Main: t>0: Store data for state,time=(j,t) --*/
     (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = delta_jt + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
     (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psi_jt;

#ifdef DEBUG_VITERBI
     printf("\n---> t=%d: b(j=%d,o=%d)=%.2e  delta(j=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g\n\n",
            t, j,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
            j,t,      exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
            j,t,      (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
#endif
   }
#ifdef DEBUG_VITERBI
   printf("\n");
#endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	delta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	psi_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * delta_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * delta_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	delta_datap += __offsp[4];
	psi_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,delta_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,psi_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,delta_datap += __tinc0_4
			,psi_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;


 int i,j, t, o_t;
 double delta_jt, delta_tmp;
 int psi_jt;

 /*-- Initialize: t==0: Loop: state_0==N --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
   (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
#ifdef DEBUG_VITERBI
   printf("t=0,j=%d,o_t=%d: delta(t=0,j=%d)=%.2e  psi(t=0,j=%d)=%.0g  b(j=%d,o=%d)=%.2e\n",
           N,o_t,
           N, exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ),
           N, (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ,
           N,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ));
#endif
 }} PDL_COMMENT("Close N")

#ifdef DEBUG_VITERBI
   printf("\n");
#endif

 /*-- Main: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: t>0: Loop: state_t==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     psi_jt   = 0;
     delta_jt = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

     /*-- Main: t>0: Loop: state_(t-1)==i --*/
     for (i=1; i<__privtrans->__N_size; i++) {
       delta_tmp = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (delta_tmp > delta_jt) {
	 delta_jt = delta_tmp;
	 psi_jt   = i;
#ifdef DEBUG_VITERBI
         printf("+");
#endif
       }

#ifdef DEBUG_VITERBI
       printf("t=%d,i=%d,j=%d,o_t=%d:  deltaX(i=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g  delta(j=%d,t=%d)=%.2e\n",
              t,i,j,o_t,
              i,t,  exp(delta_tmp),
              j,t,  psi_jt,
              j,t,  exp(delta_jt));
#endif
     }

     /*-- Main: t>0: Store data for state,time=(j,t) --*/
     (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = delta_jt + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
     (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psi_jt;

#ifdef DEBUG_VITERBI
     printf("\n---> t=%d: b(j=%d,o=%d)=%.2e  delta(j=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g\n\n",
            t, j,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
            j,t,      exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
            j,t,      (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
#endif
   }
#ifdef DEBUG_VITERBI
   printf("\n");
#endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	delta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	psi_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * delta_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * delta_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	delta_datap += __offsp[4];
	psi_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,delta_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,psi_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,delta_datap += __tinc0_4
			,psi_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;


 int i,j, t, o_t;
 double delta_jt, delta_tmp;
 int psi_jt;

 /*-- Initialize: t==0: Loop: state_0==N --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
   (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
#ifdef DEBUG_VITERBI
   printf("t=0,j=%d,o_t=%d: delta(t=0,j=%d)=%.2e  psi(t=0,j=%d)=%.0g  b(j=%d,o=%d)=%.2e\n",
           N,o_t,
           N, exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ),
           N, (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ,
           N,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ));
#endif
 }} PDL_COMMENT("Close N")

#ifdef DEBUG_VITERBI
   printf("\n");
#endif

 /*-- Main: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: t>0: Loop: state_t==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     psi_jt   = 0;
     delta_jt = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

     /*-- Main: t>0: Loop: state_(t-1)==i --*/
     for (i=1; i<__privtrans->__N_size; i++) {
       delta_tmp = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (delta_tmp > delta_jt) {
	 delta_jt = delta_tmp;
	 psi_jt   = i;
#ifdef DEBUG_VITERBI
         printf("+");
#endif
       }

#ifdef DEBUG_VITERBI
       printf("t=%d,i=%d,j=%d,o_t=%d:  deltaX(i=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g  delta(j=%d,t=%d)=%.2e\n",
              t,i,j,o_t,
              i,t,  exp(delta_tmp),
              j,t,  psi_jt,
              j,t,  exp(delta_jt));
#endif
     }

     /*-- Main: t>0: Store data for state,time=(j,t) --*/
     (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = delta_jt + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
     (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psi_jt;

#ifdef DEBUG_VITERBI
     printf("\n---> t=%d: b(j=%d,o=%d)=%.2e  delta(j=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g\n\n",
            t, j,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
            j,t,      exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
            j,t,      (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
#endif
   }
#ifdef DEBUG_VITERBI
   printf("\n");
#endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	delta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	psi_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * delta_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * delta_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	delta_datap += __offsp[4];
	psi_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,delta_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,psi_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,delta_datap += __tinc0_4
			,psi_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;


 int i,j, t, o_t;
 double delta_jt, delta_tmp;
 int psi_jt;

 /*-- Initialize: t==0: Loop: state_0==N --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
   (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
#ifdef DEBUG_VITERBI
   printf("t=0,j=%d,o_t=%d: delta(t=0,j=%d)=%.2e  psi(t=0,j=%d)=%.0g  b(j=%d,o=%d)=%.2e\n",
           N,o_t,
           N, exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ),
           N, (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ,
           N,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ));
#endif
 }} PDL_COMMENT("Close N")

#ifdef DEBUG_VITERBI
   printf("\n");
#endif

 /*-- Main: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: t>0: Loop: state_t==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     psi_jt   = 0;
     delta_jt = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

     /*-- Main: t>0: Loop: state_(t-1)==i --*/
     for (i=1; i<__privtrans->__N_size; i++) {
       delta_tmp = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (delta_tmp > delta_jt) {
	 delta_jt = delta_tmp;
	 psi_jt   = i;
#ifdef DEBUG_VITERBI
         printf("+");
#endif
       }

#ifdef DEBUG_VITERBI
       printf("t=%d,i=%d,j=%d,o_t=%d:  deltaX(i=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g  delta(j=%d,t=%d)=%.2e\n",
              t,i,j,o_t,
              i,t,  exp(delta_tmp),
              j,t,  psi_jt,
              j,t,  exp(delta_jt));
#endif
     }

     /*-- Main: t>0: Store data for state,time=(j,t) --*/
     (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = delta_jt + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
     (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psi_jt;

#ifdef DEBUG_VITERBI
     printf("\n---> t=%d: b(j=%d,o=%d)=%.2e  delta(j=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g\n\n",
            t, j,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
            j,t,      exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
            j,t,      (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
#endif
   }
#ifdef DEBUG_VITERBI
   printf("\n");
#endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	delta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	psi_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * delta_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * delta_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	delta_datap += __offsp[4];
	psi_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,delta_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,psi_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,delta_datap += __tinc0_4
			,psi_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;


 int i,j, t, o_t;
 double delta_jt, delta_tmp;
 int psi_jt;

 /*-- Initialize: t==0: Loop: state_0==N --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
   (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
#ifdef DEBUG_VITERBI
   printf("t=0,j=%d,o_t=%d: delta(t=0,j=%d)=%.2e  psi(t=0,j=%d)=%.0g  b(j=%d,o=%d)=%.2e\n",
           N,o_t,
           N, exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ),
           N, (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ,
           N,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ));
#endif
 }} PDL_COMMENT("Close N")

#ifdef DEBUG_VITERBI
   printf("\n");
#endif

 /*-- Main: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: t>0: Loop: state_t==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     psi_jt   = 0;
     delta_jt = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

     /*-- Main: t>0: Loop: state_(t-1)==i --*/
     for (i=1; i<__privtrans->__N_size; i++) {
       delta_tmp = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (delta_tmp > delta_jt) {
	 delta_jt = delta_tmp;
	 psi_jt   = i;
#ifdef DEBUG_VITERBI
         printf("+");
#endif
       }

#ifdef DEBUG_VITERBI
       printf("t=%d,i=%d,j=%d,o_t=%d:  deltaX(i=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g  delta(j=%d,t=%d)=%.2e\n",
              t,i,j,o_t,
              i,t,  exp(delta_tmp),
              j,t,  psi_jt,
              j,t,  exp(delta_jt));
#endif
     }

     /*-- Main: t>0: Store data for state,time=(j,t) --*/
     (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = delta_jt + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
     (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psi_jt;

#ifdef DEBUG_VITERBI
     printf("\n---> t=%d: b(j=%d,o=%d)=%.2e  delta(j=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g\n\n",
            t, j,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
            j,t,      exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
            j,t,      (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
#endif
   }
#ifdef DEBUG_VITERBI
   printf("\n");
#endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	delta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	psi_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * delta_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * delta_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	delta_datap += __offsp[4];
	psi_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,delta_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,psi_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,delta_datap += __tinc0_4
			,psi_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;


 int i,j, t, o_t;
 double delta_jt, delta_tmp;
 int psi_jt;

 /*-- Initialize: t==0: Loop: state_0==N --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
   (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
#ifdef DEBUG_VITERBI
   printf("t=0,j=%d,o_t=%d: delta(t=0,j=%d)=%.2e  psi(t=0,j=%d)=%.0g  b(j=%d,o=%d)=%.2e\n",
           N,o_t,
           N, exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ),
           N, (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ,
           N,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ));
#endif
 }} PDL_COMMENT("Close N")

#ifdef DEBUG_VITERBI
   printf("\n");
#endif

 /*-- Main: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: t>0: Loop: state_t==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     psi_jt   = 0;
     delta_jt = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

     /*-- Main: t>0: Loop: state_(t-1)==i --*/
     for (i=1; i<__privtrans->__N_size; i++) {
       delta_tmp = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (delta_tmp > delta_jt) {
	 delta_jt = delta_tmp;
	 psi_jt   = i;
#ifdef DEBUG_VITERBI
         printf("+");
#endif
       }

#ifdef DEBUG_VITERBI
       printf("t=%d,i=%d,j=%d,o_t=%d:  deltaX(i=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g  delta(j=%d,t=%d)=%.2e\n",
              t,i,j,o_t,
              i,t,  exp(delta_tmp),
              j,t,  psi_jt,
              j,t,  exp(delta_jt));
#endif
     }

     /*-- Main: t>0: Store data for state,time=(j,t) --*/
     (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = delta_jt + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
     (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psi_jt;

#ifdef DEBUG_VITERBI
     printf("\n---> t=%d: b(j=%d,o=%d)=%.2e  delta(j=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g\n\n",
            t, j,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
            j,t,      exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
            j,t,      (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
#endif
   }
#ifdef DEBUG_VITERBI
   printf("\n");
#endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	delta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	psi_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * delta_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * delta_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	delta_datap += __offsp[4];
	psi_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,delta_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,psi_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,delta_datap += __tinc0_4
			,psi_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;


 int i,j, t, o_t;
 double delta_jt, delta_tmp;
 int psi_jt;

 /*-- Initialize: t==0: Loop: state_0==N --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
   (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
#ifdef DEBUG_VITERBI
   printf("t=0,j=%d,o_t=%d: delta(t=0,j=%d)=%.2e  psi(t=0,j=%d)=%.0g  b(j=%d,o=%d)=%.2e\n",
           N,o_t,
           N, exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ),
           N, (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ,
           N,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ));
#endif
 }} PDL_COMMENT("Close N")

#ifdef DEBUG_VITERBI
   printf("\n");
#endif

 /*-- Main: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: t>0: Loop: state_t==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     psi_jt   = 0;
     delta_jt = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

     /*-- Main: t>0: Loop: state_(t-1)==i --*/
     for (i=1; i<__privtrans->__N_size; i++) {
       delta_tmp = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (delta_tmp > delta_jt) {
	 delta_jt = delta_tmp;
	 psi_jt   = i;
#ifdef DEBUG_VITERBI
         printf("+");
#endif
       }

#ifdef DEBUG_VITERBI
       printf("t=%d,i=%d,j=%d,o_t=%d:  deltaX(i=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g  delta(j=%d,t=%d)=%.2e\n",
              t,i,j,o_t,
              i,t,  exp(delta_tmp),
              j,t,  psi_jt,
              j,t,  exp(delta_jt));
#endif
     }

     /*-- Main: t>0: Store data for state,time=(j,t) --*/
     (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = delta_jt + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
     (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psi_jt;

#ifdef DEBUG_VITERBI
     printf("\n---> t=%d: b(j=%d,o=%d)=%.2e  delta(j=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g\n\n",
            t, j,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
            j,t,      exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
            j,t,      (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
#endif
   }
#ifdef DEBUG_VITERBI
   printf("\n");
#endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	delta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	psi_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * delta_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * delta_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	delta_datap += __offsp[4];
	psi_datap += __offsp[5];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,delta_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,psi_datap += __tinc1_5 - __tinc0_5 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,delta_datap += __tinc0_4
			,psi_datap += __tinc0_5
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_delta_N = __privtrans->__inc_delta_N;
register PDL_Indx __inc_delta_T = __privtrans->__inc_delta_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;


 int i,j, t, o_t;
 double delta_jt, delta_tmp;
 int psi_jt;

 /*-- Initialize: t==0: Loop: state_0==N --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 {PDL_COMMENT("Open N") register PDL_Indx N;
			for(N=0; N<(__N_size); N++) {
   (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, N))] PDL_COMMENT("ACCESS()")  + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
   (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
#ifdef DEBUG_VITERBI
   printf("t=0,j=%d,o_t=%d: delta(t=0,j=%d)=%.2e  psi(t=0,j=%d)=%.0g  b(j=%d,o=%d)=%.2e\n",
           N,o_t,
           N, exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ),
           N, (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ,
           N,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, N))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ));
#endif
 }} PDL_COMMENT("Close N")

#ifdef DEBUG_VITERBI
   printf("\n");
#endif

 /*-- Main: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Main: t>0: Loop: state_t==j --*/
   for (j=0; j<__privtrans->__N_size; j++) {
     psi_jt   = 0;
     delta_jt = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, 0))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

     /*-- Main: t>0: Loop: state_(t-1)==i --*/
     for (i=1; i<__privtrans->__N_size; i++) {
       delta_tmp = (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (delta_tmp > delta_jt) {
	 delta_jt = delta_tmp;
	 psi_jt   = i;
#ifdef DEBUG_VITERBI
         printf("+");
#endif
       }

#ifdef DEBUG_VITERBI
       printf("t=%d,i=%d,j=%d,o_t=%d:  deltaX(i=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g  delta(j=%d,t=%d)=%.2e\n",
              t,i,j,o_t,
              i,t,  exp(delta_tmp),
              j,t,  psi_jt,
              j,t,  exp(delta_jt));
#endif
     }

     /*-- Main: t>0: Store data for state,time=(j,t) --*/
     (delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = delta_jt + (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ;
     (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psi_jt;

#ifdef DEBUG_VITERBI
     printf("\n---> t=%d: b(j=%d,o=%d)=%.2e  delta(j=%d,t=%d)=%.2e  psi(j=%d,t=%d)=%.0g\n\n",
            t, j,o_t, exp((b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ),
            j,t,      exp((delta_datap)[0+(__inc_delta_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_delta_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ),
            j,t,      (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") );
#endif
   }
#ifdef DEBUG_VITERBI
   printf("\n");
#endif
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	delta_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	psi_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_hmmviterbi_free(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmviterbi_struct *__privtrans = (pdl_hmmviterbi_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;;;;;;;;;;;;
			}
			
	}
    }
    



static char pdl_hmmviterbi_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_hmmviterbi_vtable = {
		0,0, 4, 6, pdl_hmmviterbi_vtable_flags,
		pdl_hmmviterbi_redodims, pdl_hmmviterbi_readdata, NULL,
		pdl_hmmviterbi_free,NULL,NULL,pdl_hmmviterbi_copy,
		sizeof(pdl_hmmviterbi_struct),"pdl_hmmviterbi_vtable"
	 };

typedef struct pdl_hmmviterbiq_struct {
		PDL_TRANS_START(7);
		pdl_thread  __pdlthread;PDL_Indx  __inc_a_N0;PDL_Indx  __inc_a_N1;PDL_Indx  __inc_b_N;PDL_Indx  __inc_b_M;PDL_Indx  __inc_pi_N;PDL_Indx  __inc_o_T;PDL_Indx  __inc_oq_Q;PDL_Indx  __inc_oq_T;PDL_Indx  __inc_deltaq_Q;PDL_Indx  __inc_deltaq_T;PDL_Indx  __inc_psiq_Q;PDL_Indx  __inc_psiq_T;PDL_Indx  __T_size;PDL_Indx  __N_size;PDL_Indx  __M_size;PDL_Indx  __Q_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_hmmviterbiq_struct;

void pdl_hmmviterbiq_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmviterbiq_struct *__privtrans = (pdl_hmmviterbiq_struct *) __tr;
	
	{
	    PDL_Indx __creating[7];
__privtrans->__T_size = -1;
__privtrans->__N_size = -1;
__privtrans->__M_size = -1;
__privtrans->__Q_size = -1;
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = 0;
__creating[3] = 0;
__creating[4] = 0;
__creating[5] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[5]);
__creating[6] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[6]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * oq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * oq_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Byte * deltaq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Byte * deltaq_physdatap = ((PDL_Byte *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

{register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * oq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * oq_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Short * deltaq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Short * deltaq_physdatap = ((PDL_Short *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

{register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * oq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * oq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Ushort * deltaq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Ushort * deltaq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

{register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * oq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * oq_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * deltaq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * deltaq_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

{register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * oq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * oq_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Indx * deltaq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Indx * deltaq_physdatap = ((PDL_Indx *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

{register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * oq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * oq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_LongLong * deltaq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_LongLong * deltaq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

{register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * oq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * oq_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Float * deltaq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Float * deltaq_physdatap = ((PDL_Float *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

{register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * oq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * oq_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Double * deltaq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Double * deltaq_physdatap = ((PDL_Double *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));

{register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"a","b","pi","o","oq","deltaq","psiq"};
		static PDL_Indx __realdims[] = {2,2,1,1,2,2,2};
		static char __funcname[] = "PDL::HMM::hmmviterbiq";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 7
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,7,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 2) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[0]))->ndims < 2 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[1];
   } else if(((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[1]) {
      if(((__privtrans->pdls[0]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[1]))->ndims < 2) {
      if (((__privtrans->pdls[1]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[1]))->ndims < 2 && __privtrans->__M_size <= 1) __privtrans->__M_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[1]))->dims[0];
   } else if(((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[1]))->dims[0]) {
      if(((__privtrans->pdls[1]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__M_size == -1 || (((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size == 1)) {
      __privtrans->__M_size = ((__privtrans->pdls[1]))->dims[1];
   } else if(((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__M_size != ((__privtrans->pdls[1]))->dims[1]) {
      if(((__privtrans->pdls[1]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[2]))->ndims < 1) {
      if (((__privtrans->pdls[2]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[2]))->dims[0];
   } else if(((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[2]))->dims[0]) {
      if(((__privtrans->pdls[2]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[3]))->ndims < 1) {
      if (((__privtrans->pdls[3]))->ndims < 1 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[3]))->dims[0];
   } else if(((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size != ((__privtrans->pdls[3]))->dims[0]) {
      if(((__privtrans->pdls[3]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[4]))->ndims < 2) {
      if (((__privtrans->pdls[4]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[4]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[4]))->dims[0];
   } else if(((__privtrans->pdls[4]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[4]))->dims[0]) {
      if(((__privtrans->pdls[4]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[4]))->dims[1];
   } else if(((__privtrans->pdls[4]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[4]))->dims[1]) {
      if(((__privtrans->pdls[4]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
if(!__creating[5]) {
   if(((__privtrans->pdls[5]))->ndims < 2) {
      if (((__privtrans->pdls[5]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[5]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[5]))->dims[0];
   } else if(((__privtrans->pdls[5]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[5]))->dims[0]) {
      if(((__privtrans->pdls[5]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[5]))->dims[1];
   } else if(((__privtrans->pdls[5]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[5]))->dims[1]) {
      if(((__privtrans->pdls[5]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__Q_size;dims[1] = __privtrans->__T_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,5,dims,0);
}if(!__creating[6]) {
   if(((__privtrans->pdls[6]))->ndims < 2) {
      if (((__privtrans->pdls[6]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[6]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[6]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[6]))->dims[0];
   } else if(((__privtrans->pdls[6]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[6]))->dims[0]) {
      if(((__privtrans->pdls[6]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[6]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[6]))->dims[1];
   } else if(((__privtrans->pdls[6]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[6]))->dims[1]) {
      if(((__privtrans->pdls[6]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmviterbiq:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[3]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__Q_size;dims[1] = __privtrans->__T_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,6,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[3]->hdrsv &&
	 (__privtrans->pdls[3]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[3]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[3]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[4]->hdrsv &&
	 (__privtrans->pdls[4]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[4]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[4]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[5] && 
     __privtrans->pdls[5]->hdrsv &&
	 (__privtrans->pdls[5]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[5]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[5]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[6] && 
     __privtrans->pdls[6]->hdrsv &&
	 (__privtrans->pdls[6]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[6]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[6]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[5]->hdrsv != hdrp ){
	 if( __privtrans->pdls[5]->hdrsv && __privtrans->pdls[5]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[5]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[5]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[5]->state |= PDL_HDRCPY;
       if ( __privtrans->pdls[6]->hdrsv != hdrp ){
	 if( __privtrans->pdls[6]->hdrsv && __privtrans->pdls[6]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[6]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[6]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[6]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_a_N0 = 0; else
		 __privtrans->__inc_a_N0 = PDL_REPRINC(__privtrans->pdls[0],0);if(__privtrans->pdls[0]->ndims <= 1 || __privtrans->pdls[0]->dims[1] <= 1)
		  __privtrans->__inc_a_N1 = 0; else
		 __privtrans->__inc_a_N1 = PDL_REPRINC(__privtrans->pdls[0],1);if(__privtrans->pdls[1]->ndims <= 0 || __privtrans->pdls[1]->dims[0] <= 1)
		  __privtrans->__inc_b_N = 0; else
		 __privtrans->__inc_b_N = PDL_REPRINC(__privtrans->pdls[1],0);if(__privtrans->pdls[1]->ndims <= 1 || __privtrans->pdls[1]->dims[1] <= 1)
		  __privtrans->__inc_b_M = 0; else
		 __privtrans->__inc_b_M = PDL_REPRINC(__privtrans->pdls[1],1);if(__privtrans->pdls[2]->ndims <= 0 || __privtrans->pdls[2]->dims[0] <= 1)
		  __privtrans->__inc_pi_N = 0; else
		 __privtrans->__inc_pi_N = PDL_REPRINC(__privtrans->pdls[2],0);if(__privtrans->pdls[3]->ndims <= 0 || __privtrans->pdls[3]->dims[0] <= 1)
		  __privtrans->__inc_o_T = 0; else
		 __privtrans->__inc_o_T = PDL_REPRINC(__privtrans->pdls[3],0);if(__privtrans->pdls[4]->ndims <= 0 || __privtrans->pdls[4]->dims[0] <= 1)
		  __privtrans->__inc_oq_Q = 0; else
		 __privtrans->__inc_oq_Q = PDL_REPRINC(__privtrans->pdls[4],0);if(__privtrans->pdls[4]->ndims <= 1 || __privtrans->pdls[4]->dims[1] <= 1)
		  __privtrans->__inc_oq_T = 0; else
		 __privtrans->__inc_oq_T = PDL_REPRINC(__privtrans->pdls[4],1);if(__privtrans->pdls[5]->ndims <= 0 || __privtrans->pdls[5]->dims[0] <= 1)
		  __privtrans->__inc_deltaq_Q = 0; else
		 __privtrans->__inc_deltaq_Q = PDL_REPRINC(__privtrans->pdls[5],0);if(__privtrans->pdls[5]->ndims <= 1 || __privtrans->pdls[5]->dims[1] <= 1)
		  __privtrans->__inc_deltaq_T = 0; else
		 __privtrans->__inc_deltaq_T = PDL_REPRINC(__privtrans->pdls[5],1);if(__privtrans->pdls[6]->ndims <= 0 || __privtrans->pdls[6]->dims[0] <= 1)
		  __privtrans->__inc_psiq_Q = 0; else
		 __privtrans->__inc_psiq_Q = PDL_REPRINC(__privtrans->pdls[6],0);if(__privtrans->pdls[6]->ndims <= 1 || __privtrans->pdls[6]->dims[1] <= 1)
		  __privtrans->__inc_psiq_T = 0; else
		 __privtrans->__inc_psiq_T = PDL_REPRINC(__privtrans->pdls[6],1); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_hmmviterbiq_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmviterbiq_struct *__privtrans = (pdl_hmmviterbiq_struct *) __tr;
	
	{
	    pdl_hmmviterbiq_struct *__copy = malloc(sizeof(pdl_hmmviterbiq_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_a_N0=__copy->__inc_a_N0;__privtrans->__inc_a_N1=__copy->__inc_a_N1;__privtrans->__inc_b_N=__copy->__inc_b_N;__privtrans->__inc_b_M=__copy->__inc_b_M;__privtrans->__inc_pi_N=__copy->__inc_pi_N;__privtrans->__inc_o_T=__copy->__inc_o_T;__privtrans->__inc_oq_Q=__copy->__inc_oq_Q;__privtrans->__inc_oq_T=__copy->__inc_oq_T;__privtrans->__inc_deltaq_Q=__copy->__inc_deltaq_Q;__privtrans->__inc_deltaq_T=__copy->__inc_deltaq_T;__privtrans->__inc_psiq_Q=__copy->__inc_psiq_Q;__privtrans->__inc_psiq_T=__copy->__inc_psiq_T;__copy->__T_size=__privtrans->__T_size;__copy->__N_size=__privtrans->__N_size;__copy->__M_size=__privtrans->__M_size;__copy->__Q_size=__privtrans->__Q_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_hmmviterbiq_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmviterbiq_struct *__privtrans = (pdl_hmmviterbiq_struct *) __tr;
	
	{
	    {PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * a_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * a_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * b_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * b_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Byte * pi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Byte * pi_physdatap = ((PDL_Byte *)((__privtrans->pdls[2])->data));

	PDL_Byte * o_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Byte * o_physdatap = ((PDL_Byte *)((__privtrans->pdls[3])->data));

	PDL_Byte * oq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Byte * oq_physdatap = ((PDL_Byte *)((__privtrans->pdls[4])->data));

	PDL_Byte * deltaq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Byte * deltaq_physdatap = ((PDL_Byte *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	deltaq_datap += __offsp[5];
	psiq_datap += __offsp[6];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,deltaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,psiq_datap += __tinc1_6 - __tinc0_6 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,deltaq_datap += __tinc0_5
			,psiq_datap += __tinc0_6
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int qi,qj, i,j, t, o_t;
 double deltaq_jt, deltaq_tmp;
 int psiq_jt;

 /*-- Initialize: t=0: Loop: q_(0)=qi: state_(0)=oq(qi,0)=i --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi<__privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
   (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (i>=0 ? ((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ) : (PDL_Byte)LOG_ZERO);
 }

 /*-- Loop: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/
   for (qj=0; qj<__privtrans->__Q_size; qj++) {
     j         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
     psiq_jt   = 0;

     if (j >= 0 && i >=0) {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;
     } else {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + LOG_ZERO;
     }

     /*-- Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/
     for (qi=1; qi<__privtrans->__Q_size; qi++) {
       i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0 || i < 0) break;

       deltaq_tmp = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (deltaq_tmp > deltaq_jt) {
	 deltaq_jt = deltaq_tmp;
	 psiq_jt   = qi;
       }

     }
     /*-- End Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/

     /*-- Main: t>0: Store data for stateIndex,time=(qj,t) --*/
     (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = deltaq_jt + (j>=0 ? (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  : LOG_ZERO);
     (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psiq_jt;

   }
   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/

 }
 /*-- End Loop: t>0: Loop: time==t --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	deltaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	psiq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * a_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * a_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * b_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * b_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Short * pi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Short * pi_physdatap = ((PDL_Short *)((__privtrans->pdls[2])->data));

	PDL_Short * o_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Short * o_physdatap = ((PDL_Short *)((__privtrans->pdls[3])->data));

	PDL_Short * oq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Short * oq_physdatap = ((PDL_Short *)((__privtrans->pdls[4])->data));

	PDL_Short * deltaq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Short * deltaq_physdatap = ((PDL_Short *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	deltaq_datap += __offsp[5];
	psiq_datap += __offsp[6];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,deltaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,psiq_datap += __tinc1_6 - __tinc0_6 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,deltaq_datap += __tinc0_5
			,psiq_datap += __tinc0_6
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int qi,qj, i,j, t, o_t;
 double deltaq_jt, deltaq_tmp;
 int psiq_jt;

 /*-- Initialize: t=0: Loop: q_(0)=qi: state_(0)=oq(qi,0)=i --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi<__privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
   (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (i>=0 ? ((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ) : (PDL_Short)LOG_ZERO);
 }

 /*-- Loop: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/
   for (qj=0; qj<__privtrans->__Q_size; qj++) {
     j         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
     psiq_jt   = 0;

     if (j >= 0 && i >=0) {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;
     } else {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + LOG_ZERO;
     }

     /*-- Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/
     for (qi=1; qi<__privtrans->__Q_size; qi++) {
       i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0 || i < 0) break;

       deltaq_tmp = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (deltaq_tmp > deltaq_jt) {
	 deltaq_jt = deltaq_tmp;
	 psiq_jt   = qi;
       }

     }
     /*-- End Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/

     /*-- Main: t>0: Store data for stateIndex,time=(qj,t) --*/
     (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = deltaq_jt + (j>=0 ? (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  : LOG_ZERO);
     (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psiq_jt;

   }
   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/

 }
 /*-- End Loop: t>0: Loop: time==t --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	deltaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	psiq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * a_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * a_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * b_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * b_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Ushort * pi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Ushort * pi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[2])->data));

	PDL_Ushort * o_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Ushort * o_physdatap = ((PDL_Ushort *)((__privtrans->pdls[3])->data));

	PDL_Ushort * oq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Ushort * oq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[4])->data));

	PDL_Ushort * deltaq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Ushort * deltaq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	deltaq_datap += __offsp[5];
	psiq_datap += __offsp[6];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,deltaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,psiq_datap += __tinc1_6 - __tinc0_6 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,deltaq_datap += __tinc0_5
			,psiq_datap += __tinc0_6
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int qi,qj, i,j, t, o_t;
 double deltaq_jt, deltaq_tmp;
 int psiq_jt;

 /*-- Initialize: t=0: Loop: q_(0)=qi: state_(0)=oq(qi,0)=i --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi<__privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
   (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (i>=0 ? ((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ) : (PDL_Ushort)LOG_ZERO);
 }

 /*-- Loop: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/
   for (qj=0; qj<__privtrans->__Q_size; qj++) {
     j         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
     psiq_jt   = 0;

     if (j >= 0 && i >=0) {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;
     } else {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + LOG_ZERO;
     }

     /*-- Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/
     for (qi=1; qi<__privtrans->__Q_size; qi++) {
       i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0 || i < 0) break;

       deltaq_tmp = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (deltaq_tmp > deltaq_jt) {
	 deltaq_jt = deltaq_tmp;
	 psiq_jt   = qi;
       }

     }
     /*-- End Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/

     /*-- Main: t>0: Store data for stateIndex,time=(qj,t) --*/
     (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = deltaq_jt + (j>=0 ? (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  : LOG_ZERO);
     (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psiq_jt;

   }
   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/

 }
 /*-- End Loop: t>0: Loop: time==t --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	deltaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	psiq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * a_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * a_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * b_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * b_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * pi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * pi_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * o_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * o_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

	PDL_Long * oq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Long * oq_physdatap = ((PDL_Long *)((__privtrans->pdls[4])->data));

	PDL_Long * deltaq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Long * deltaq_physdatap = ((PDL_Long *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	deltaq_datap += __offsp[5];
	psiq_datap += __offsp[6];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,deltaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,psiq_datap += __tinc1_6 - __tinc0_6 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,deltaq_datap += __tinc0_5
			,psiq_datap += __tinc0_6
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int qi,qj, i,j, t, o_t;
 double deltaq_jt, deltaq_tmp;
 int psiq_jt;

 /*-- Initialize: t=0: Loop: q_(0)=qi: state_(0)=oq(qi,0)=i --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi<__privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
   (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (i>=0 ? ((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ) : (PDL_Long)LOG_ZERO);
 }

 /*-- Loop: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/
   for (qj=0; qj<__privtrans->__Q_size; qj++) {
     j         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
     psiq_jt   = 0;

     if (j >= 0 && i >=0) {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;
     } else {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + LOG_ZERO;
     }

     /*-- Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/
     for (qi=1; qi<__privtrans->__Q_size; qi++) {
       i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0 || i < 0) break;

       deltaq_tmp = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (deltaq_tmp > deltaq_jt) {
	 deltaq_jt = deltaq_tmp;
	 psiq_jt   = qi;
       }

     }
     /*-- End Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/

     /*-- Main: t>0: Store data for stateIndex,time=(qj,t) --*/
     (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = deltaq_jt + (j>=0 ? (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  : LOG_ZERO);
     (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psiq_jt;

   }
   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/

 }
 /*-- End Loop: t>0: Loop: time==t --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	deltaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	psiq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * a_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * a_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * b_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * b_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Indx * pi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Indx * pi_physdatap = ((PDL_Indx *)((__privtrans->pdls[2])->data));

	PDL_Indx * o_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Indx * o_physdatap = ((PDL_Indx *)((__privtrans->pdls[3])->data));

	PDL_Indx * oq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Indx * oq_physdatap = ((PDL_Indx *)((__privtrans->pdls[4])->data));

	PDL_Indx * deltaq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Indx * deltaq_physdatap = ((PDL_Indx *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	deltaq_datap += __offsp[5];
	psiq_datap += __offsp[6];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,deltaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,psiq_datap += __tinc1_6 - __tinc0_6 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,deltaq_datap += __tinc0_5
			,psiq_datap += __tinc0_6
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int qi,qj, i,j, t, o_t;
 double deltaq_jt, deltaq_tmp;
 int psiq_jt;

 /*-- Initialize: t=0: Loop: q_(0)=qi: state_(0)=oq(qi,0)=i --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi<__privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
   (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (i>=0 ? ((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ) : (PDL_Indx)LOG_ZERO);
 }

 /*-- Loop: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/
   for (qj=0; qj<__privtrans->__Q_size; qj++) {
     j         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
     psiq_jt   = 0;

     if (j >= 0 && i >=0) {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;
     } else {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + LOG_ZERO;
     }

     /*-- Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/
     for (qi=1; qi<__privtrans->__Q_size; qi++) {
       i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0 || i < 0) break;

       deltaq_tmp = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (deltaq_tmp > deltaq_jt) {
	 deltaq_jt = deltaq_tmp;
	 psiq_jt   = qi;
       }

     }
     /*-- End Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/

     /*-- Main: t>0: Store data for stateIndex,time=(qj,t) --*/
     (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = deltaq_jt + (j>=0 ? (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  : LOG_ZERO);
     (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psiq_jt;

   }
   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/

 }
 /*-- End Loop: t>0: Loop: time==t --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	deltaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	psiq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * a_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * a_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * b_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * b_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_LongLong * pi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_LongLong * pi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[2])->data));

	PDL_LongLong * o_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_LongLong * o_physdatap = ((PDL_LongLong *)((__privtrans->pdls[3])->data));

	PDL_LongLong * oq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_LongLong * oq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[4])->data));

	PDL_LongLong * deltaq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_LongLong * deltaq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	deltaq_datap += __offsp[5];
	psiq_datap += __offsp[6];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,deltaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,psiq_datap += __tinc1_6 - __tinc0_6 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,deltaq_datap += __tinc0_5
			,psiq_datap += __tinc0_6
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int qi,qj, i,j, t, o_t;
 double deltaq_jt, deltaq_tmp;
 int psiq_jt;

 /*-- Initialize: t=0: Loop: q_(0)=qi: state_(0)=oq(qi,0)=i --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi<__privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
   (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (i>=0 ? ((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ) : (PDL_LongLong)LOG_ZERO);
 }

 /*-- Loop: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/
   for (qj=0; qj<__privtrans->__Q_size; qj++) {
     j         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
     psiq_jt   = 0;

     if (j >= 0 && i >=0) {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;
     } else {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + LOG_ZERO;
     }

     /*-- Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/
     for (qi=1; qi<__privtrans->__Q_size; qi++) {
       i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0 || i < 0) break;

       deltaq_tmp = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (deltaq_tmp > deltaq_jt) {
	 deltaq_jt = deltaq_tmp;
	 psiq_jt   = qi;
       }

     }
     /*-- End Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/

     /*-- Main: t>0: Store data for stateIndex,time=(qj,t) --*/
     (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = deltaq_jt + (j>=0 ? (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  : LOG_ZERO);
     (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psiq_jt;

   }
   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/

 }
 /*-- End Loop: t>0: Loop: time==t --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	deltaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	psiq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * a_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * a_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * b_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * b_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Float * pi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Float * pi_physdatap = ((PDL_Float *)((__privtrans->pdls[2])->data));

	PDL_Float * o_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Float * o_physdatap = ((PDL_Float *)((__privtrans->pdls[3])->data));

	PDL_Float * oq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Float * oq_physdatap = ((PDL_Float *)((__privtrans->pdls[4])->data));

	PDL_Float * deltaq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Float * deltaq_physdatap = ((PDL_Float *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	deltaq_datap += __offsp[5];
	psiq_datap += __offsp[6];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,deltaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,psiq_datap += __tinc1_6 - __tinc0_6 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,deltaq_datap += __tinc0_5
			,psiq_datap += __tinc0_6
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int qi,qj, i,j, t, o_t;
 double deltaq_jt, deltaq_tmp;
 int psiq_jt;

 /*-- Initialize: t=0: Loop: q_(0)=qi: state_(0)=oq(qi,0)=i --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi<__privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
   (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (i>=0 ? ((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ) : (PDL_Float)LOG_ZERO);
 }

 /*-- Loop: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/
   for (qj=0; qj<__privtrans->__Q_size; qj++) {
     j         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
     psiq_jt   = 0;

     if (j >= 0 && i >=0) {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;
     } else {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + LOG_ZERO;
     }

     /*-- Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/
     for (qi=1; qi<__privtrans->__Q_size; qi++) {
       i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0 || i < 0) break;

       deltaq_tmp = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (deltaq_tmp > deltaq_jt) {
	 deltaq_jt = deltaq_tmp;
	 psiq_jt   = qi;
       }

     }
     /*-- End Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/

     /*-- Main: t>0: Store data for stateIndex,time=(qj,t) --*/
     (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = deltaq_jt + (j>=0 ? (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  : LOG_ZERO);
     (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psiq_jt;

   }
   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/

 }
 /*-- End Loop: t>0: Loop: time==t --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	deltaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	psiq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * a_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * a_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * b_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * b_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Double * pi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Double * pi_physdatap = ((PDL_Double *)((__privtrans->pdls[2])->data));

	PDL_Double * o_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Double * o_physdatap = ((PDL_Double *)((__privtrans->pdls[3])->data));

	PDL_Double * oq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[4]),(__privtrans->vtable->per_pdl_flags[4]))));
	PDL_Double * oq_physdatap = ((PDL_Double *)((__privtrans->pdls[4])->data));

	PDL_Double * deltaq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[5]),(__privtrans->vtable->per_pdl_flags[5]))));
	PDL_Double * deltaq_physdatap = ((PDL_Double *)((__privtrans->pdls[5])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[6]),(__privtrans->vtable->per_pdl_flags[6]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[6])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc0_4 = __privtrans->__pdlthread.incs[4];
	register PDL_Indx __tinc0_5 = __privtrans->__pdlthread.incs[5];
	register PDL_Indx __tinc0_6 = __privtrans->__pdlthread.incs[6];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	register PDL_Indx __tinc1_4 = __privtrans->__pdlthread.incs[__tnpdls+4];
	register PDL_Indx __tinc1_5 = __privtrans->__pdlthread.incs[__tnpdls+5];
	register PDL_Indx __tinc1_6 = __privtrans->__pdlthread.incs[__tnpdls+6];
	a_datap += __offsp[0];
	b_datap += __offsp[1];
	pi_datap += __offsp[2];
	o_datap += __offsp[3];
	oq_datap += __offsp[4];
	deltaq_datap += __offsp[5];
	psiq_datap += __offsp[6];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,a_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,b_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,pi_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,o_datap += __tinc1_3 - __tinc0_3 * __tdims0
			,oq_datap += __tinc1_4 - __tinc0_4 * __tdims0
			,deltaq_datap += __tinc1_5 - __tinc0_5 * __tdims0
			,psiq_datap += __tinc1_6 - __tinc0_6 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,a_datap += __tinc0_0
			,b_datap += __tinc0_1
			,pi_datap += __tinc0_2
			,o_datap += __tinc0_3
			,oq_datap += __tinc0_4
			,deltaq_datap += __tinc0_5
			,psiq_datap += __tinc0_6
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_pi_N = __privtrans->__inc_pi_N;
register PDL_Indx __inc_b_N = __privtrans->__inc_b_N;
register PDL_Indx __inc_b_M = __privtrans->__inc_b_M;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;
register PDL_Indx __inc_a_N0 = __privtrans->__inc_a_N0;
register PDL_Indx __inc_a_N1 = __privtrans->__inc_a_N1;
register PDL_Indx __inc_deltaq_Q = __privtrans->__inc_deltaq_Q;
register PDL_Indx __inc_deltaq_T = __privtrans->__inc_deltaq_T;
register PDL_Indx __inc_o_T = __privtrans->__inc_o_T;


 int qi,qj, i,j, t, o_t;
 double deltaq_jt, deltaq_tmp;
 int psiq_jt;

 /*-- Initialize: t=0: Loop: q_(0)=qi: state_(0)=oq(qi,0)=i --*/
 o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
 for (qi=0; qi<__privtrans->__Q_size; qi++) {
   i = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()") ;
   (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = 0;
   (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, 0))] PDL_COMMENT("ACCESS()")  = (i>=0 ? ((pi_datap)[0+(__inc_pi_N*PP_INDTERM(__privtrans->__N_size, i))] PDL_COMMENT("ACCESS()") +(b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, i))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()") ) : (PDL_Double)LOG_ZERO);
 }

 /*-- Loop: t>0: Loop: time==t --*/
 for (t=1; t<__privtrans->__T_size; t++) {
   o_t = (o_datap)[0+(__inc_o_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;

   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/
   for (qj=0; qj<__privtrans->__Q_size; qj++) {
     j         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()") ;
     i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
     psiq_jt   = 0;

     if (j >= 0 && i >=0) {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;
     } else {
       deltaq_jt = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, 0))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + LOG_ZERO;
     }

     /*-- Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/
     for (qi=1; qi<__privtrans->__Q_size; qi++) {
       i         = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()") ;
       if (j < 0 || i < 0) break;

       deltaq_tmp = (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t-1))] PDL_COMMENT("ACCESS()")  + (a_datap)[0+(__inc_a_N0*PP_INDTERM(__privtrans->__N_size, i))+(__inc_a_N1*PP_INDTERM(__privtrans->__N_size, j))] PDL_COMMENT("ACCESS()") ;

       if (deltaq_tmp > deltaq_jt) {
	 deltaq_jt = deltaq_tmp;
	 psiq_jt   = qi;
       }

     }
     /*-- End Loop: t>0: q_(t-1)=qi : state_(t-1)=oq(qi,t)=i --*/

     /*-- Main: t>0: Store data for stateIndex,time=(qj,t) --*/
     (deltaq_datap)[0+(__inc_deltaq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_deltaq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = deltaq_jt + (j>=0 ? (b_datap)[0+(__inc_b_N*PP_INDTERM(__privtrans->__N_size, j))+(__inc_b_M*PP_INDTERM(__privtrans->__M_size, o_t))] PDL_COMMENT("ACCESS()")  : LOG_ZERO);
     (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qj))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = psiq_jt;

   }
   /*-- Loop: t>0: q_(t)=qj : state_(t)=oq(qj,t)=j --*/

 }
 /*-- End Loop: t>0: Loop: time==t --*/

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	a_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	b_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	pi_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	o_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	oq_datap -= __tinc1_4 * __tdims1 + __offsp[4];
	deltaq_datap -= __tinc1_5 * __tdims1 + __offsp[5];
	psiq_datap -= __tinc1_6 * __tdims1 + __offsp[6];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_hmmviterbiq_free(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmviterbiq_struct *__privtrans = (pdl_hmmviterbiq_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;;;;;;;;;;;;;;;
			}
			
	}
    }
    



static char pdl_hmmviterbiq_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_hmmviterbiq_vtable = {
		0,0, 5, 7, pdl_hmmviterbiq_vtable_flags,
		pdl_hmmviterbiq_redodims, pdl_hmmviterbiq_readdata, NULL,
		pdl_hmmviterbiq_free,NULL,NULL,pdl_hmmviterbiq_copy,
		sizeof(pdl_hmmviterbiq_struct),"pdl_hmmviterbiq_vtable"
	 };

typedef struct pdl_hmmpath_struct {
		PDL_TRANS_START(3);
		pdl_thread  __pdlthread;PDL_Indx  __inc_psi_N;PDL_Indx  __inc_psi_T;PDL_Indx  __inc_path_T;PDL_Indx  __T_size;PDL_Indx  __N_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_hmmpath_struct;

void pdl_hmmpath_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmpath_struct *__privtrans = (pdl_hmmpath_struct *) __tr;
	
	{
	    PDL_Indx __creating[3];
__privtrans->__T_size = -1;
__privtrans->__N_size = -1;
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[2]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * psi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * psi_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

{register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * psi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * psi_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

{register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * psi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * psi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

{register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

{register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * psi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * psi_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

{register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * psi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * psi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

{register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * psi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * psi_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

{register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * psi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * psi_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

{register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"psi","qfinal","path"};
		static PDL_Indx __realdims[] = {2,0,1};
		static char __funcname[] = "PDL::HMM::hmmpath";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 3
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,3,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 2) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__N_size <= 1) __privtrans->__N_size = 1;
      if (((__privtrans->pdls[0]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__N_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size == 1)) {
      __privtrans->__N_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__N_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmpath:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[0]))->dims[1];
   } else if(((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[0]))->dims[1]) {
      if(((__privtrans->pdls[0]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmpath:" "Wrong dims\n");
      }
   }
if(!__creating[2]) {
   if(((__privtrans->pdls[2]))->ndims < 1) {
      if (((__privtrans->pdls[2]))->ndims < 1 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[2]))->dims[0];
   } else if(((__privtrans->pdls[2]))->ndims > 0 && __privtrans->__T_size != ((__privtrans->pdls[2]))->dims[0]) {
      if(((__privtrans->pdls[2]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmpath:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[2]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__T_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,2,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[2] && 
     __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[2]->hdrsv != hdrp ){
	 if( __privtrans->pdls[2]->hdrsv && __privtrans->pdls[2]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[2]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[2]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[2]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_psi_N = 0; else
		 __privtrans->__inc_psi_N = PDL_REPRINC(__privtrans->pdls[0],0);if(__privtrans->pdls[0]->ndims <= 1 || __privtrans->pdls[0]->dims[1] <= 1)
		  __privtrans->__inc_psi_T = 0; else
		 __privtrans->__inc_psi_T = PDL_REPRINC(__privtrans->pdls[0],1);if(__privtrans->pdls[2]->ndims <= 0 || __privtrans->pdls[2]->dims[0] <= 1)
		  __privtrans->__inc_path_T = 0; else
		 __privtrans->__inc_path_T = PDL_REPRINC(__privtrans->pdls[2],0); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_hmmpath_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmpath_struct *__privtrans = (pdl_hmmpath_struct *) __tr;
	
	{
	    pdl_hmmpath_struct *__copy = malloc(sizeof(pdl_hmmpath_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_psi_N=__copy->__inc_psi_N;__privtrans->__inc_psi_T=__copy->__inc_psi_T;__privtrans->__inc_path_T=__copy->__inc_path_T;__copy->__T_size=__privtrans->__T_size;__copy->__N_size=__privtrans->__N_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_hmmpath_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmpath_struct *__privtrans = (pdl_hmmpath_struct *) __tr;
	
	{
	    {PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * psi_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * psi_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	psi_datap += __offsp[0];
	qfinal_datap += __offsp[1];
	path_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,psi_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,qfinal_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,path_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,psi_datap += __tinc0_0
			,qfinal_datap += __tinc0_1
			,path_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinal_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Main: T-1 > t >= 0: Loop: time==t --*/
 for (t--; t>=0; t--) {
   int q_tp1   = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, q_tp1))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	psi_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	qfinal_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	path_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * psi_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * psi_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	psi_datap += __offsp[0];
	qfinal_datap += __offsp[1];
	path_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,psi_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,qfinal_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,path_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,psi_datap += __tinc0_0
			,qfinal_datap += __tinc0_1
			,path_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinal_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Main: T-1 > t >= 0: Loop: time==t --*/
 for (t--; t>=0; t--) {
   int q_tp1   = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, q_tp1))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	psi_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	qfinal_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	path_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * psi_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * psi_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	psi_datap += __offsp[0];
	qfinal_datap += __offsp[1];
	path_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,psi_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,qfinal_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,path_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,psi_datap += __tinc0_0
			,qfinal_datap += __tinc0_1
			,path_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinal_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Main: T-1 > t >= 0: Loop: time==t --*/
 for (t--; t>=0; t--) {
   int q_tp1   = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, q_tp1))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	psi_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	qfinal_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	path_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * psi_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * psi_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	psi_datap += __offsp[0];
	qfinal_datap += __offsp[1];
	path_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,psi_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,qfinal_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,path_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,psi_datap += __tinc0_0
			,qfinal_datap += __tinc0_1
			,path_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinal_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Main: T-1 > t >= 0: Loop: time==t --*/
 for (t--; t>=0; t--) {
   int q_tp1   = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, q_tp1))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	psi_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	qfinal_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	path_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * psi_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * psi_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	psi_datap += __offsp[0];
	qfinal_datap += __offsp[1];
	path_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,psi_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,qfinal_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,path_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,psi_datap += __tinc0_0
			,qfinal_datap += __tinc0_1
			,path_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinal_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Main: T-1 > t >= 0: Loop: time==t --*/
 for (t--; t>=0; t--) {
   int q_tp1   = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, q_tp1))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	psi_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	qfinal_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	path_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * psi_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * psi_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	psi_datap += __offsp[0];
	qfinal_datap += __offsp[1];
	path_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,psi_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,qfinal_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,path_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,psi_datap += __tinc0_0
			,qfinal_datap += __tinc0_1
			,path_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinal_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Main: T-1 > t >= 0: Loop: time==t --*/
 for (t--; t>=0; t--) {
   int q_tp1   = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, q_tp1))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	psi_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	qfinal_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	path_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * psi_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * psi_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	psi_datap += __offsp[0];
	qfinal_datap += __offsp[1];
	path_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,psi_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,qfinal_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,path_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,psi_datap += __tinc0_0
			,qfinal_datap += __tinc0_1
			,path_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinal_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Main: T-1 > t >= 0: Loop: time==t --*/
 for (t--; t>=0; t--) {
   int q_tp1   = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, q_tp1))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	psi_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	qfinal_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	path_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * psi_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * psi_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Long * qfinal_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * qfinal_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	psi_datap += __offsp[0];
	qfinal_datap += __offsp[1];
	path_datap += __offsp[2];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,psi_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,qfinal_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,path_datap += __tinc1_2 - __tinc0_2 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,psi_datap += __tinc0_0
			,qfinal_datap += __tinc0_1
			,path_datap += __tinc0_2
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_psi_N = __privtrans->__inc_psi_N;
register PDL_Indx __inc_psi_T = __privtrans->__inc_psi_T;
register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinal_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Main: T-1 > t >= 0: Loop: time==t --*/
 for (t--; t>=0; t--) {
   int q_tp1   = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psi_datap)[0+(__inc_psi_N*PP_INDTERM(__privtrans->__N_size, q_tp1))+(__inc_psi_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	psi_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	qfinal_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	path_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_hmmpath_free(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmpath_struct *__privtrans = (pdl_hmmpath_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;;;;
			}
			
	}
    }
    



static char pdl_hmmpath_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_hmmpath_vtable = {
		0,0, 2, 3, pdl_hmmpath_vtable_flags,
		pdl_hmmpath_redodims, pdl_hmmpath_readdata, NULL,
		pdl_hmmpath_free,NULL,NULL,pdl_hmmpath_copy,
		sizeof(pdl_hmmpath_struct),"pdl_hmmpath_vtable"
	 };

typedef struct pdl_hmmpathq_struct {
		PDL_TRANS_START(4);
		pdl_thread  __pdlthread;PDL_Indx  __inc_oq_Q;PDL_Indx  __inc_oq_T;PDL_Indx  __inc_psiq_Q;PDL_Indx  __inc_psiq_T;PDL_Indx  __inc_path_T;PDL_Indx  __T_size;PDL_Indx  __Q_size;
		
		char __ddone; PDL_COMMENT("Dims done")
		} pdl_hmmpathq_struct;

void pdl_hmmpathq_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmpathq_struct *__privtrans = (pdl_hmmpathq_struct *) __tr;
	
	{
	    PDL_Indx __creating[4];
__privtrans->__T_size = -1;
__privtrans->__Q_size = -1;
__creating[0] = 0;
__creating[1] = 0;
__creating[2] = 0;
__creating[3] = PDL_CR_SETDIMSCOND(__privtrans,__privtrans->pdls[3]);
 {
{PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * oq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * oq_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * psiq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * psiq_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

{register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_S: {
	PDL_Short * oq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * oq_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * psiq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * psiq_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

{register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_US: {
	PDL_Ushort * oq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * oq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * psiq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * psiq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

{register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_L: {
	PDL_Long * oq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * oq_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

{register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_IND: {
	PDL_Indx * oq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * oq_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * psiq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * psiq_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

{register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_LL: {
	PDL_LongLong * oq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * oq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * psiq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * psiq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

{register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_F: {
	PDL_Float * oq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * oq_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * psiq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * psiq_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

{register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	} break; case PDL_D: {
	PDL_Double * oq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * oq_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * psiq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * psiq_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));

{register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;

PDL_COMMENT("none")
}	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
}
 {
 static char *__parnames[] = {"oq","psiq","qfinalq","path"};
		static PDL_Indx __realdims[] = {2,2,0,1};
		static char __funcname[] = "PDL::HMM::hmmpathq";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 4
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,4,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags,
			0 );
		}
   if(((__privtrans->pdls[0]))->ndims < 2) {
      if (((__privtrans->pdls[0]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[0]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[0]))->dims[0];
   } else if(((__privtrans->pdls[0]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[0]))->dims[0]) {
      if(((__privtrans->pdls[0]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmpathq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[0]))->dims[1];
   } else if(((__privtrans->pdls[0]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[0]))->dims[1]) {
      if(((__privtrans->pdls[0]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmpathq:" "Wrong dims\n");
      }
   }
   if(((__privtrans->pdls[1]))->ndims < 2) {
      if (((__privtrans->pdls[1]))->ndims < 1 && __privtrans->__Q_size <= 1) __privtrans->__Q_size = 1;
      if (((__privtrans->pdls[1]))->ndims < 2 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__Q_size == -1 || (((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__Q_size == 1)) {
      __privtrans->__Q_size = ((__privtrans->pdls[1]))->dims[0];
   } else if(((__privtrans->pdls[1]))->ndims > 0 && __privtrans->__Q_size != ((__privtrans->pdls[1]))->dims[0]) {
      if(((__privtrans->pdls[1]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmpathq:" "Wrong dims\n");
      }
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[1]))->dims[1];
   } else if(((__privtrans->pdls[1]))->ndims > 1 && __privtrans->__T_size != ((__privtrans->pdls[1]))->dims[1]) {
      if(((__privtrans->pdls[1]))->dims[1] != 1) {
         PDL->pdl_barf("Error in hmmpathq:" "Wrong dims\n");
      }
   }
if(!__creating[3]) {
   if(((__privtrans->pdls[3]))->ndims < 1) {
      if (((__privtrans->pdls[3]))->ndims < 1 && __privtrans->__T_size <= 1) __privtrans->__T_size = 1;
   }
   if(__privtrans->__T_size == -1 || (((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size == 1)) {
      __privtrans->__T_size = ((__privtrans->pdls[3]))->dims[0];
   } else if(((__privtrans->pdls[3]))->ndims > 0 && __privtrans->__T_size != ((__privtrans->pdls[3]))->dims[0]) {
      if(((__privtrans->pdls[3]))->dims[0] != 1) {
         PDL->pdl_barf("Error in hmmpathq:" "Wrong dims\n");
      }
   }
} else {
 PDL_Indx dims[2]; PDL_COMMENT("Use ninds+1 to avoid smart (stupid) compilers")dims[0] = __privtrans->__T_size;
 PDL->thread_create_parameter(&__privtrans->__pdlthread,3,dims,0);
}
{ PDL_COMMENT("convenience block")
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp &&
	      __privtrans->pdls[0]->hdrsv &&
	 (__privtrans->pdls[0]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[1]->hdrsv &&
	 (__privtrans->pdls[1]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[1]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[1]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	      __privtrans->pdls[2]->hdrsv &&
	 (__privtrans->pdls[2]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[2]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[2]->state & PDL_HDRCPY) != 0);
      }
      if(!hdrp &&
	 !__creating[3] && 
     __privtrans->pdls[3]->hdrsv &&
	 (__privtrans->pdls[3]->state & PDL_HDRCPY)
	 ) {
	hdrp = __privtrans->pdls[3]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[3]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef)
    hdr_copy = &PL_sv_undef;
  else  {  PDL_COMMENT("Call the perl routine _hdr_copy...")
    int count;
    PDL_COMMENT("Call the perl routine PDL::_hdr_copy(hdrp)")
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1)
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");

    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef) {
       (void)SvREFCNT_inc(hdr_copy); PDL_COMMENT("Keep hdr_copy from vanishing during FREETMPS")
    }

    FREETMPS ;
    LEAVE ;


  } PDL_COMMENT("end of callback  block")

       if ( __privtrans->pdls[3]->hdrsv != hdrp ){
	 if( __privtrans->pdls[3]->hdrsv && __privtrans->pdls[3]->hdrsv != &PL_sv_undef)
             (void)SvREFCNT_dec( __privtrans->pdls[3]->hdrsv );
	 if( hdr_copy != &PL_sv_undef )
             (void)SvREFCNT_inc(hdr_copy);
	 __privtrans->pdls[3]->hdrsv = hdr_copy;
       }
     if(propagate_hdrcpy)
       __privtrans->pdls[3]->state |= PDL_HDRCPY;

         if(hdr_copy != &PL_sv_undef)
            SvREFCNT_dec(hdr_copy); PDL_COMMENT("make hdr_copy mortal again")
      } PDL_COMMENT("end of if(hdrp) block")
   } PDL_COMMENT("end of conv. block")
if(__privtrans->pdls[0]->ndims <= 0 || __privtrans->pdls[0]->dims[0] <= 1)
		  __privtrans->__inc_oq_Q = 0; else
		 __privtrans->__inc_oq_Q = PDL_REPRINC(__privtrans->pdls[0],0);if(__privtrans->pdls[0]->ndims <= 1 || __privtrans->pdls[0]->dims[1] <= 1)
		  __privtrans->__inc_oq_T = 0; else
		 __privtrans->__inc_oq_T = PDL_REPRINC(__privtrans->pdls[0],1);if(__privtrans->pdls[1]->ndims <= 0 || __privtrans->pdls[1]->dims[0] <= 1)
		  __privtrans->__inc_psiq_Q = 0; else
		 __privtrans->__inc_psiq_Q = PDL_REPRINC(__privtrans->pdls[1],0);if(__privtrans->pdls[1]->ndims <= 1 || __privtrans->pdls[1]->dims[1] <= 1)
		  __privtrans->__inc_psiq_T = 0; else
		 __privtrans->__inc_psiq_T = PDL_REPRINC(__privtrans->pdls[1],1);if(__privtrans->pdls[3]->ndims <= 0 || __privtrans->pdls[3]->dims[0] <= 1)
		  __privtrans->__inc_path_T = 0; else
		 __privtrans->__inc_path_T = PDL_REPRINC(__privtrans->pdls[3],0); __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_hmmpathq_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmpathq_struct *__privtrans = (pdl_hmmpathq_struct *) __tr;
	
	{
	    pdl_hmmpathq_struct *__copy = malloc(sizeof(pdl_hmmpathq_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));__privtrans->__inc_oq_Q=__copy->__inc_oq_Q;__privtrans->__inc_oq_T=__copy->__inc_oq_T;__privtrans->__inc_psiq_Q=__copy->__inc_psiq_Q;__privtrans->__inc_psiq_T=__copy->__inc_psiq_T;__privtrans->__inc_path_T=__copy->__inc_path_T;__copy->__T_size=__privtrans->__T_size;__copy->__Q_size=__privtrans->__Q_size;
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_hmmpathq_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmpathq_struct *__privtrans = (pdl_hmmpathq_struct *) __tr;
	
	{
	    {register PDL_Indx __T_size = __privtrans->__T_size;
PDL_COMMENT("Start generic loop")

	switch(__privtrans->__datatype) { case -42: PDL_COMMENT("Warning eater") {(void)1;
	} break; case PDL_B: {
	PDL_Byte * oq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * oq_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	PDL_Byte * psiq_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Byte * psiq_physdatap = ((PDL_Byte *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	oq_datap += __offsp[0];
	psiq_datap += __offsp[1];
	qfinalq_datap += __offsp[2];
	path_datap += __offsp[3];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,oq_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,psiq_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,qfinalq_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,path_datap += __tinc1_3 - __tinc0_3 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,oq_datap += __tinc0_0
			,psiq_datap += __tinc0_1
			,qfinalq_datap += __tinc0_2
			,path_datap += __tinc0_3
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinalq_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Get index backtrace --*/
 for (t--; t>=0; t--) {
   int qi_tp1  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi_tp1))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

 /*-- Convert indices to state ids --*/
 {PDL_COMMENT("Open T") register PDL_Indx T;
			for(T=0; T<(__T_size); T++) {
   int qi  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()")  = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
 }} PDL_COMMENT("Close T")

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	oq_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	psiq_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	qfinalq_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	path_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_S: {
	PDL_Short * oq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * oq_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	PDL_Short * psiq_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Short * psiq_physdatap = ((PDL_Short *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	oq_datap += __offsp[0];
	psiq_datap += __offsp[1];
	qfinalq_datap += __offsp[2];
	path_datap += __offsp[3];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,oq_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,psiq_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,qfinalq_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,path_datap += __tinc1_3 - __tinc0_3 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,oq_datap += __tinc0_0
			,psiq_datap += __tinc0_1
			,qfinalq_datap += __tinc0_2
			,path_datap += __tinc0_3
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinalq_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Get index backtrace --*/
 for (t--; t>=0; t--) {
   int qi_tp1  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi_tp1))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

 /*-- Convert indices to state ids --*/
 {PDL_COMMENT("Open T") register PDL_Indx T;
			for(T=0; T<(__T_size); T++) {
   int qi  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()")  = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
 }} PDL_COMMENT("Close T")

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	oq_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	psiq_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	qfinalq_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	path_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_US: {
	PDL_Ushort * oq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * oq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	PDL_Ushort * psiq_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Ushort * psiq_physdatap = ((PDL_Ushort *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	oq_datap += __offsp[0];
	psiq_datap += __offsp[1];
	qfinalq_datap += __offsp[2];
	path_datap += __offsp[3];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,oq_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,psiq_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,qfinalq_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,path_datap += __tinc1_3 - __tinc0_3 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,oq_datap += __tinc0_0
			,psiq_datap += __tinc0_1
			,qfinalq_datap += __tinc0_2
			,path_datap += __tinc0_3
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinalq_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Get index backtrace --*/
 for (t--; t>=0; t--) {
   int qi_tp1  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi_tp1))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

 /*-- Convert indices to state ids --*/
 {PDL_COMMENT("Open T") register PDL_Indx T;
			for(T=0; T<(__T_size); T++) {
   int qi  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()")  = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
 }} PDL_COMMENT("Close T")

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	oq_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	psiq_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	qfinalq_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	path_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_L: {
	PDL_Long * oq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * oq_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	PDL_Long * psiq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Long * psiq_physdatap = ((PDL_Long *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	oq_datap += __offsp[0];
	psiq_datap += __offsp[1];
	qfinalq_datap += __offsp[2];
	path_datap += __offsp[3];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,oq_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,psiq_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,qfinalq_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,path_datap += __tinc1_3 - __tinc0_3 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,oq_datap += __tinc0_0
			,psiq_datap += __tinc0_1
			,qfinalq_datap += __tinc0_2
			,path_datap += __tinc0_3
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinalq_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Get index backtrace --*/
 for (t--; t>=0; t--) {
   int qi_tp1  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi_tp1))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

 /*-- Convert indices to state ids --*/
 {PDL_COMMENT("Open T") register PDL_Indx T;
			for(T=0; T<(__T_size); T++) {
   int qi  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()")  = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
 }} PDL_COMMENT("Close T")

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	oq_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	psiq_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	qfinalq_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	path_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_IND: {
	PDL_Indx * oq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Indx * oq_physdatap = ((PDL_Indx *)((__privtrans->pdls[0])->data));

	PDL_Indx * psiq_datap = ((PDL_Indx *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Indx * psiq_physdatap = ((PDL_Indx *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	oq_datap += __offsp[0];
	psiq_datap += __offsp[1];
	qfinalq_datap += __offsp[2];
	path_datap += __offsp[3];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,oq_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,psiq_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,qfinalq_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,path_datap += __tinc1_3 - __tinc0_3 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,oq_datap += __tinc0_0
			,psiq_datap += __tinc0_1
			,qfinalq_datap += __tinc0_2
			,path_datap += __tinc0_3
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinalq_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Get index backtrace --*/
 for (t--; t>=0; t--) {
   int qi_tp1  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi_tp1))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

 /*-- Convert indices to state ids --*/
 {PDL_COMMENT("Open T") register PDL_Indx T;
			for(T=0; T<(__T_size); T++) {
   int qi  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()")  = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
 }} PDL_COMMENT("Close T")

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	oq_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	psiq_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	qfinalq_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	path_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_LL: {
	PDL_LongLong * oq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * oq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	PDL_LongLong * psiq_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_LongLong * psiq_physdatap = ((PDL_LongLong *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	oq_datap += __offsp[0];
	psiq_datap += __offsp[1];
	qfinalq_datap += __offsp[2];
	path_datap += __offsp[3];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,oq_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,psiq_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,qfinalq_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,path_datap += __tinc1_3 - __tinc0_3 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,oq_datap += __tinc0_0
			,psiq_datap += __tinc0_1
			,qfinalq_datap += __tinc0_2
			,path_datap += __tinc0_3
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinalq_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Get index backtrace --*/
 for (t--; t>=0; t--) {
   int qi_tp1  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi_tp1))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

 /*-- Convert indices to state ids --*/
 {PDL_COMMENT("Open T") register PDL_Indx T;
			for(T=0; T<(__T_size); T++) {
   int qi  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()")  = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
 }} PDL_COMMENT("Close T")

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	oq_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	psiq_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	qfinalq_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	path_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_F: {
	PDL_Float * oq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * oq_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	PDL_Float * psiq_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Float * psiq_physdatap = ((PDL_Float *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	oq_datap += __offsp[0];
	psiq_datap += __offsp[1];
	qfinalq_datap += __offsp[2];
	path_datap += __offsp[3];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,oq_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,psiq_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,qfinalq_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,path_datap += __tinc1_3 - __tinc0_3 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,oq_datap += __tinc0_0
			,psiq_datap += __tinc0_1
			,qfinalq_datap += __tinc0_2
			,path_datap += __tinc0_3
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinalq_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Get index backtrace --*/
 for (t--; t>=0; t--) {
   int qi_tp1  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi_tp1))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

 /*-- Convert indices to state ids --*/
 {PDL_COMMENT("Open T") register PDL_Indx T;
			for(T=0; T<(__T_size); T++) {
   int qi  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()")  = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
 }} PDL_COMMENT("Close T")

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	oq_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	psiq_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	qfinalq_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	path_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	} break; case PDL_D: {
	PDL_Double * oq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * oq_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	PDL_Double * psiq_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[1]),(__privtrans->vtable->per_pdl_flags[1]))));
	PDL_Double * psiq_physdatap = ((PDL_Double *)((__privtrans->pdls[1])->data));

	PDL_Long * qfinalq_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[2]),(__privtrans->vtable->per_pdl_flags[2]))));
	PDL_Long * qfinalq_physdatap = ((PDL_Long *)((__privtrans->pdls[2])->data));

	PDL_Long * path_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[3]),(__privtrans->vtable->per_pdl_flags[3]))));
	PDL_Long * path_physdatap = ((PDL_Long *)((__privtrans->pdls[3])->data));


	PDL_COMMENT("THREADLOOPBEGIN")
	if ( PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata, __tr) ) return;
           do { register PDL_Indx __tind1=0,__tind2=0;
                register PDL_Indx __tnpdls = __privtrans->__pdlthread.npdls;
                register PDL_Indx __tdims1 = __privtrans->__pdlthread.dims[1];
                register PDL_Indx __tdims0 = __privtrans->__pdlthread.dims[0];
                register PDL_Indx *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
	register PDL_Indx __tinc0_0 = __privtrans->__pdlthread.incs[0];
	register PDL_Indx __tinc0_1 = __privtrans->__pdlthread.incs[1];
	register PDL_Indx __tinc0_2 = __privtrans->__pdlthread.incs[2];
	register PDL_Indx __tinc0_3 = __privtrans->__pdlthread.incs[3];
	register PDL_Indx __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];
	register PDL_Indx __tinc1_1 = __privtrans->__pdlthread.incs[__tnpdls+1];
	register PDL_Indx __tinc1_2 = __privtrans->__pdlthread.incs[__tnpdls+2];
	register PDL_Indx __tinc1_3 = __privtrans->__pdlthread.incs[__tnpdls+3];
	oq_datap += __offsp[0];
	psiq_datap += __offsp[1];
	qfinalq_datap += __offsp[2];
	path_datap += __offsp[3];
	for( __tind2 = 0 ;
                __tind2 < __tdims1 ;
                __tind2++
			,oq_datap += __tinc1_0 - __tinc0_0 * __tdims0
			,psiq_datap += __tinc1_1 - __tinc0_1 * __tdims0
			,qfinalq_datap += __tinc1_2 - __tinc0_2 * __tdims0
			,path_datap += __tinc1_3 - __tinc0_3 * __tdims0
	)
	{
	     for( __tind1 = 0 ;
                  __tind1 < __tdims0 ;
                  __tind1++
			,oq_datap += __tinc0_0
			,psiq_datap += __tinc0_1
			,qfinalq_datap += __tinc0_2
			,path_datap += __tinc0_3
	)
	{  PDL_COMMENT("This is the tightest threadloop. Make sure inside is optimal."){register PDL_Indx __inc_path_T = __privtrans->__inc_path_T;
register PDL_Indx __inc_psiq_Q = __privtrans->__inc_psiq_Q;
register PDL_Indx __inc_psiq_T = __privtrans->__inc_psiq_T;
register PDL_Indx __inc_oq_Q = __privtrans->__inc_oq_Q;
register PDL_Indx __inc_oq_T = __privtrans->__inc_oq_T;


 /*-- Initialize: t==T-1: state_(t)==final() --*/
 int t = __privtrans->__T_size-1;
 (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (qfinalq_datap)[0] PDL_COMMENT("ACCESS()") ;

 /*-- Get index backtrace --*/
 for (t--; t>=0; t--) {
   int qi_tp1  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, t))] PDL_COMMENT("ACCESS()")  = (psiq_datap)[0+(__inc_psiq_Q*PP_INDTERM(__privtrans->__Q_size, qi_tp1))+(__inc_psiq_T*PP_INDTERM(__privtrans->__T_size, t+1))] PDL_COMMENT("ACCESS()") ;
 }

 /*-- Convert indices to state ids --*/
 {PDL_COMMENT("Open T") register PDL_Indx T;
			for(T=0; T<(__T_size); T++) {
   int qi  = (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
   (path_datap)[0+(__inc_path_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()")  = (oq_datap)[0+(__inc_oq_Q*PP_INDTERM(__privtrans->__Q_size, qi))+(__inc_oq_T*PP_INDTERM(__privtrans->__T_size, T))] PDL_COMMENT("ACCESS()") ;
 }} PDL_COMMENT("Close T")

}
	PDL_COMMENT("THREADLOOPEND")
	}
	}
	oq_datap -= __tinc1_0 * __tdims1 + __offsp[0];
	psiq_datap -= __tinc1_1 * __tdims1 + __offsp[1];
	qfinalq_datap -= __tinc1_2 * __tdims1 + __offsp[2];
	path_datap -= __tinc1_3 * __tdims1 + __offsp[3];
	} while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_hmmpathq_free(pdl_trans *__tr ) {
	int __dim;
	pdl_hmmpathq_struct *__privtrans = (pdl_hmmpathq_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;;;;;;;;
			}
			
	}
    }
    



static char pdl_hmmpathq_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK,PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_hmmpathq_vtable = {
		0,0, 3, 4, pdl_hmmpathq_vtable_flags,
		pdl_hmmpathq_redodims, pdl_hmmpathq_readdata, NULL,
		pdl_hmmpathq_free,NULL,NULL,pdl_hmmpathq_copy,
		sizeof(pdl_hmmpathq_struct),"pdl_hmmpathq_vtable"
	 };



MODULE = PDL::HMM PACKAGE = PDL::HMM

PROTOTYPES: ENABLE

int
set_debugging(i)
	int i;
	CODE:
	RETVAL = __pdl_debugging;
	__pdl_debugging = i;
	OUTPUT:
	RETVAL

int
set_boundscheck(i)
       int i;
       CODE:
       if (! 1)
         warn("Bounds checking is disabled for PDL::HMM");
       RETVAL = __pdl_boundscheck;
       __pdl_boundscheck = i;
       OUTPUT:
       RETVAL


MODULE = PDL::HMM PACKAGE = PDL


void
logzero(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *a_SV;
  pdl  *a;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 1) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
  }
  else if (items == 0) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 1;
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       a_SV = sv_newmortal();
       a = PDL->null();
       PDL->SetSV_PDL(a_SV,a);
       if (bless_stash) a_SV = sv_bless(a_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       a_SV = POPs;
       PUTBACK;
       a = PDL->SvPDLV(a_SV);
    }
  }
  else {
    croak ("Usage:  PDL::logzero(a) (you may leave temporaries or output variables out of list)");
  }
}
{
	if ( a->state & PDL_INPLACE && (a != a)) {
              a->state &= ~PDL_INPLACE; PDL_COMMENT("unset")
              a = a;             PDL_COMMENT("discard output value, leak ?")
              PDL->SetSV_PDL(a_SV,a);
          }
}
 { pdl_logzero_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_logzero_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
__privtrans->__datatype = 0;if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if( (a->state & PDL_NOMYDIMS) && a->trans == NULL ) {
	     a->datatype = PDLMAX(PDL_F,__privtrans->__datatype);
	  } else if(PDLMAX(PDL_F,__privtrans->__datatype) != a->datatype) {
	     a = PDL->get_convertedpdl(a,PDLMAX(PDL_F,__privtrans->__datatype));
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
 if ( ((a->state & PDL_BADVAL) > 0) ) PDL->propagate_badflag(a,0);  a->state &= ~PDL_BADVAL;if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = a_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
logadd(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *c_SV;
  pdl  *a;
  pdl  *b;
  pdl  *c;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 3) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    c = PDL->SvPDLV(ST(2));
  }
  else if (items == 2) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 1;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       c_SV = sv_newmortal();
       c = PDL->null();
       PDL->SetSV_PDL(c_SV,c);
       if (bless_stash) c_SV = sv_bless(c_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       c_SV = POPs;
       PUTBACK;
       c = PDL->SvPDLV(c_SV);
    }
  }
  else {
    croak ("Usage:  PDL::logadd(a,b,c) (you may leave temporaries or output variables out of list)");
  }
}
{
	if ( a->state & PDL_INPLACE && (c != a)) {
              a->state &= ~PDL_INPLACE; PDL_COMMENT("unset")
              c = a;             PDL_COMMENT("discard output value, leak ?")
              PDL->SetSV_PDL(c_SV,c);
          }
}
 { pdl_logadd_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_logadd_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0) || ((b->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(__privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(!((c->state & PDL_NOMYDIMS) &&
		       c->trans == NULL) && __privtrans->__datatype < c->datatype) {
		 	__privtrans->__datatype = c->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }if( (c->state & PDL_NOMYDIMS) && c->trans == NULL ) {
	     c->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != c->datatype) {
	     c = PDL->get_convertedpdl(c,__privtrans->__datatype);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
__privtrans->pdls[2] = c;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  c->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = c_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
logdiff(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *c_SV;
  pdl  *a;
  pdl  *b;
  pdl  *c;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 3) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    c = PDL->SvPDLV(ST(2));
  }
  else if (items == 2) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 1;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       c_SV = sv_newmortal();
       c = PDL->null();
       PDL->SetSV_PDL(c_SV,c);
       if (bless_stash) c_SV = sv_bless(c_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       c_SV = POPs;
       PUTBACK;
       c = PDL->SvPDLV(c_SV);
    }
  }
  else {
    croak ("Usage:  PDL::logdiff(a,b,c) (you may leave temporaries or output variables out of list)");
  }
}
{
	if ( a->state & PDL_INPLACE && (c != a)) {
              a->state &= ~PDL_INPLACE; PDL_COMMENT("unset")
              c = a;             PDL_COMMENT("discard output value, leak ?")
              PDL->SetSV_PDL(c_SV,c);
          }
}
 { pdl_logdiff_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_logdiff_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0) || ((b->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(__privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(!((c->state & PDL_NOMYDIMS) &&
		       c->trans == NULL) && __privtrans->__datatype < c->datatype) {
		 	__privtrans->__datatype = c->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }if( (c->state & PDL_NOMYDIMS) && c->trans == NULL ) {
	     c->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != c->datatype) {
	     c = PDL->get_convertedpdl(c,__privtrans->__datatype);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
__privtrans->pdls[2] = c;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  c->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = c_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
logsumover(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *b_SV;
  pdl  *a;
  pdl  *b;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 2) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
  }
  else if (items == 1) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 1;
    a = PDL->SvPDLV(ST(0));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       b_SV = sv_newmortal();
       b = PDL->null();
       PDL->SetSV_PDL(b_SV,b);
       if (bless_stash) b_SV = sv_bless(b_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       b_SV = POPs;
       PUTBACK;
       b = PDL->SvPDLV(b_SV);
    }
  }
  else {
    croak ("Usage:  PDL::logsumover(a,b) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_logsumover_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_logsumover_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(!((b->state & PDL_NOMYDIMS) &&
		       b->trans == NULL) && __privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if( (b->state & PDL_NOMYDIMS) && b->trans == NULL ) {
	     b->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  b->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = b_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
hmmfw(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *alpha_SV;
  pdl  *a;
  pdl  *b;
  pdl  *pi;
  pdl  *o;
  pdl  *alpha;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 5) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    alpha = PDL->SvPDLV(ST(4));
  }
  else if (items == 4) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 1;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       alpha_SV = sv_newmortal();
       alpha = PDL->null();
       PDL->SetSV_PDL(alpha_SV,alpha);
       if (bless_stash) alpha_SV = sv_bless(alpha_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       alpha_SV = POPs;
       PUTBACK;
       alpha = PDL->SvPDLV(alpha_SV);
    }
  }
  else {
    croak ("Usage:  PDL::hmmfw(a,b,pi,o,alpha) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_hmmfw_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_hmmfw_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0) || ((b->state & PDL_BADVAL) > 0) || ((pi->state & PDL_BADVAL) > 0) || ((o->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(__privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(__privtrans->__datatype < pi->datatype) {
		 	__privtrans->__datatype = pi->datatype;
		    }
if(__privtrans->__datatype < o->datatype) {
		 	__privtrans->__datatype = o->datatype;
		    }
if(!((alpha->state & PDL_NOMYDIMS) &&
		       alpha->trans == NULL) && __privtrans->__datatype < alpha->datatype) {
		 	__privtrans->__datatype = alpha->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }if(__privtrans->__datatype != pi->datatype) {
	     pi = PDL->get_convertedpdl(pi,__privtrans->__datatype);
	  }if(__privtrans->__datatype != o->datatype) {
	     o = PDL->get_convertedpdl(o,__privtrans->__datatype);
	  }if( (alpha->state & PDL_NOMYDIMS) && alpha->trans == NULL ) {
	     alpha->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != alpha->datatype) {
	     alpha = PDL->get_convertedpdl(alpha,__privtrans->__datatype);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
__privtrans->pdls[2] = pi;
__privtrans->pdls[3] = o;
__privtrans->pdls[4] = alpha;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  alpha->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = alpha_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
hmmfwq(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *alphaq_SV;
  pdl  *a;
  pdl  *b;
  pdl  *pi;
  pdl  *o;
  pdl  *oq;
  pdl  *alphaq;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 6) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    oq = PDL->SvPDLV(ST(4));
    alphaq = PDL->SvPDLV(ST(5));
  }
  else if (items == 5) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 1;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    oq = PDL->SvPDLV(ST(4));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       alphaq_SV = sv_newmortal();
       alphaq = PDL->null();
       PDL->SetSV_PDL(alphaq_SV,alphaq);
       if (bless_stash) alphaq_SV = sv_bless(alphaq_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       alphaq_SV = POPs;
       PUTBACK;
       alphaq = PDL->SvPDLV(alphaq_SV);
    }
  }
  else {
    croak ("Usage:  PDL::hmmfwq(a,b,pi,o,oq,alphaq) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_hmmfwq_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_hmmfwq_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0) || ((b->state & PDL_BADVAL) > 0) || ((pi->state & PDL_BADVAL) > 0) || ((o->state & PDL_BADVAL) > 0) || ((oq->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(__privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(__privtrans->__datatype < pi->datatype) {
		 	__privtrans->__datatype = pi->datatype;
		    }
if(__privtrans->__datatype < o->datatype) {
		 	__privtrans->__datatype = o->datatype;
		    }
if(__privtrans->__datatype < oq->datatype) {
		 	__privtrans->__datatype = oq->datatype;
		    }
if(!((alphaq->state & PDL_NOMYDIMS) &&
		       alphaq->trans == NULL) && __privtrans->__datatype < alphaq->datatype) {
		 	__privtrans->__datatype = alphaq->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }if(__privtrans->__datatype != pi->datatype) {
	     pi = PDL->get_convertedpdl(pi,__privtrans->__datatype);
	  }if(__privtrans->__datatype != o->datatype) {
	     o = PDL->get_convertedpdl(o,__privtrans->__datatype);
	  }if(__privtrans->__datatype != oq->datatype) {
	     oq = PDL->get_convertedpdl(oq,__privtrans->__datatype);
	  }if( (alphaq->state & PDL_NOMYDIMS) && alphaq->trans == NULL ) {
	     alphaq->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != alphaq->datatype) {
	     alphaq = PDL->get_convertedpdl(alphaq,__privtrans->__datatype);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
__privtrans->pdls[2] = pi;
__privtrans->pdls[3] = o;
__privtrans->pdls[4] = oq;
__privtrans->pdls[5] = alphaq;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  alphaq->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = alphaq_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
hmmbw(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *beta_SV;
  pdl  *a;
  pdl  *b;
  pdl  *omega;
  pdl  *o;
  pdl  *beta;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 5) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    omega = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    beta = PDL->SvPDLV(ST(4));
  }
  else if (items == 4) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 1;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    omega = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       beta_SV = sv_newmortal();
       beta = PDL->null();
       PDL->SetSV_PDL(beta_SV,beta);
       if (bless_stash) beta_SV = sv_bless(beta_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       beta_SV = POPs;
       PUTBACK;
       beta = PDL->SvPDLV(beta_SV);
    }
  }
  else {
    croak ("Usage:  PDL::hmmbw(a,b,omega,o,beta) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_hmmbw_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_hmmbw_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0) || ((b->state & PDL_BADVAL) > 0) || ((omega->state & PDL_BADVAL) > 0) || ((o->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(__privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(__privtrans->__datatype < omega->datatype) {
		 	__privtrans->__datatype = omega->datatype;
		    }
if(__privtrans->__datatype < o->datatype) {
		 	__privtrans->__datatype = o->datatype;
		    }
if(!((beta->state & PDL_NOMYDIMS) &&
		       beta->trans == NULL) && __privtrans->__datatype < beta->datatype) {
		 	__privtrans->__datatype = beta->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }if(__privtrans->__datatype != omega->datatype) {
	     omega = PDL->get_convertedpdl(omega,__privtrans->__datatype);
	  }if(__privtrans->__datatype != o->datatype) {
	     o = PDL->get_convertedpdl(o,__privtrans->__datatype);
	  }if( (beta->state & PDL_NOMYDIMS) && beta->trans == NULL ) {
	     beta->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != beta->datatype) {
	     beta = PDL->get_convertedpdl(beta,__privtrans->__datatype);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
__privtrans->pdls[2] = omega;
__privtrans->pdls[3] = o;
__privtrans->pdls[4] = beta;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  beta->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = beta_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
hmmbwq(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *betaq_SV;
  pdl  *a;
  pdl  *b;
  pdl  *omega;
  pdl  *o;
  pdl  *oq;
  pdl  *betaq;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 6) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    omega = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    oq = PDL->SvPDLV(ST(4));
    betaq = PDL->SvPDLV(ST(5));
  }
  else if (items == 5) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 1;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    omega = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    oq = PDL->SvPDLV(ST(4));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       betaq_SV = sv_newmortal();
       betaq = PDL->null();
       PDL->SetSV_PDL(betaq_SV,betaq);
       if (bless_stash) betaq_SV = sv_bless(betaq_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       betaq_SV = POPs;
       PUTBACK;
       betaq = PDL->SvPDLV(betaq_SV);
    }
  }
  else {
    croak ("Usage:  PDL::hmmbwq(a,b,omega,o,oq,betaq) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_hmmbwq_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_hmmbwq_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0) || ((b->state & PDL_BADVAL) > 0) || ((omega->state & PDL_BADVAL) > 0) || ((o->state & PDL_BADVAL) > 0) || ((oq->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(__privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(__privtrans->__datatype < omega->datatype) {
		 	__privtrans->__datatype = omega->datatype;
		    }
if(__privtrans->__datatype < o->datatype) {
		 	__privtrans->__datatype = o->datatype;
		    }
if(__privtrans->__datatype < oq->datatype) {
		 	__privtrans->__datatype = oq->datatype;
		    }
if(!((betaq->state & PDL_NOMYDIMS) &&
		       betaq->trans == NULL) && __privtrans->__datatype < betaq->datatype) {
		 	__privtrans->__datatype = betaq->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }if(__privtrans->__datatype != omega->datatype) {
	     omega = PDL->get_convertedpdl(omega,__privtrans->__datatype);
	  }if(__privtrans->__datatype != o->datatype) {
	     o = PDL->get_convertedpdl(o,__privtrans->__datatype);
	  }if(__privtrans->__datatype != oq->datatype) {
	     oq = PDL->get_convertedpdl(oq,__privtrans->__datatype);
	  }if( (betaq->state & PDL_NOMYDIMS) && betaq->trans == NULL ) {
	     betaq->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != betaq->datatype) {
	     betaq = PDL->get_convertedpdl(betaq,__privtrans->__datatype);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
__privtrans->pdls[2] = omega;
__privtrans->pdls[3] = o;
__privtrans->pdls[4] = oq;
__privtrans->pdls[5] = betaq;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  betaq->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = betaq_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
hmmexpect(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *ea_SV;
  SV *eb_SV;
  SV *epi_SV;
  SV *eomega_SV;
  pdl  *a;
  pdl  *b;
  pdl  *pi;
  pdl  *omega;
  pdl  *o;
  pdl  *alpha;
  pdl  *beta;
  pdl  *ea;
  pdl  *eb;
  pdl  *epi;
  pdl  *eomega;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 11) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    omega = PDL->SvPDLV(ST(3));
    o = PDL->SvPDLV(ST(4));
    alpha = PDL->SvPDLV(ST(5));
    beta = PDL->SvPDLV(ST(6));
    ea = PDL->SvPDLV(ST(7));
    eb = PDL->SvPDLV(ST(8));
    epi = PDL->SvPDLV(ST(9));
    eomega = PDL->SvPDLV(ST(10));
  }
  else if (items == 7) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 4;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    omega = PDL->SvPDLV(ST(3));
    o = PDL->SvPDLV(ST(4));
    alpha = PDL->SvPDLV(ST(5));
    beta = PDL->SvPDLV(ST(6));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       ea_SV = sv_newmortal();
       ea = PDL->null();
       PDL->SetSV_PDL(ea_SV,ea);
       if (bless_stash) ea_SV = sv_bless(ea_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       ea_SV = POPs;
       PUTBACK;
       ea = PDL->SvPDLV(ea_SV);
    }
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       eb_SV = sv_newmortal();
       eb = PDL->null();
       PDL->SetSV_PDL(eb_SV,eb);
       if (bless_stash) eb_SV = sv_bless(eb_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       eb_SV = POPs;
       PUTBACK;
       eb = PDL->SvPDLV(eb_SV);
    }
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       epi_SV = sv_newmortal();
       epi = PDL->null();
       PDL->SetSV_PDL(epi_SV,epi);
       if (bless_stash) epi_SV = sv_bless(epi_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       epi_SV = POPs;
       PUTBACK;
       epi = PDL->SvPDLV(epi_SV);
    }
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       eomega_SV = sv_newmortal();
       eomega = PDL->null();
       PDL->SetSV_PDL(eomega_SV,eomega);
       if (bless_stash) eomega_SV = sv_bless(eomega_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       eomega_SV = POPs;
       PUTBACK;
       eomega = PDL->SvPDLV(eomega_SV);
    }
  }
  else {
    croak ("Usage:  PDL::hmmexpect(a,b,pi,omega,o,alpha,beta,ea,eb,epi,eomega) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_hmmexpect_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_hmmexpect_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0) || ((b->state & PDL_BADVAL) > 0) || ((pi->state & PDL_BADVAL) > 0) || ((omega->state & PDL_BADVAL) > 0) || ((o->state & PDL_BADVAL) > 0) || ((alpha->state & PDL_BADVAL) > 0) || ((beta->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(__privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(__privtrans->__datatype < pi->datatype) {
		 	__privtrans->__datatype = pi->datatype;
		    }
if(__privtrans->__datatype < omega->datatype) {
		 	__privtrans->__datatype = omega->datatype;
		    }
if(__privtrans->__datatype < o->datatype) {
		 	__privtrans->__datatype = o->datatype;
		    }
if(__privtrans->__datatype < alpha->datatype) {
		 	__privtrans->__datatype = alpha->datatype;
		    }
if(__privtrans->__datatype < beta->datatype) {
		 	__privtrans->__datatype = beta->datatype;
		    }
if(!((ea->state & PDL_NOMYDIMS) &&
		       ea->trans == NULL) && __privtrans->__datatype < ea->datatype) {
		 	__privtrans->__datatype = ea->datatype;
		    }
if(!((eb->state & PDL_NOMYDIMS) &&
		       eb->trans == NULL) && __privtrans->__datatype < eb->datatype) {
		 	__privtrans->__datatype = eb->datatype;
		    }
if(!((epi->state & PDL_NOMYDIMS) &&
		       epi->trans == NULL) && __privtrans->__datatype < epi->datatype) {
		 	__privtrans->__datatype = epi->datatype;
		    }
if(!((eomega->state & PDL_NOMYDIMS) &&
		       eomega->trans == NULL) && __privtrans->__datatype < eomega->datatype) {
		 	__privtrans->__datatype = eomega->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }if(__privtrans->__datatype != pi->datatype) {
	     pi = PDL->get_convertedpdl(pi,__privtrans->__datatype);
	  }if(__privtrans->__datatype != omega->datatype) {
	     omega = PDL->get_convertedpdl(omega,__privtrans->__datatype);
	  }if(__privtrans->__datatype != o->datatype) {
	     o = PDL->get_convertedpdl(o,__privtrans->__datatype);
	  }if(__privtrans->__datatype != alpha->datatype) {
	     alpha = PDL->get_convertedpdl(alpha,__privtrans->__datatype);
	  }if(__privtrans->__datatype != beta->datatype) {
	     beta = PDL->get_convertedpdl(beta,__privtrans->__datatype);
	  }if( (ea->state & PDL_NOMYDIMS) && ea->trans == NULL ) {
	     ea->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != ea->datatype) {
	     ea = PDL->get_convertedpdl(ea,__privtrans->__datatype);
	  }if( (eb->state & PDL_NOMYDIMS) && eb->trans == NULL ) {
	     eb->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != eb->datatype) {
	     eb = PDL->get_convertedpdl(eb,__privtrans->__datatype);
	  }if( (epi->state & PDL_NOMYDIMS) && epi->trans == NULL ) {
	     epi->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != epi->datatype) {
	     epi = PDL->get_convertedpdl(epi,__privtrans->__datatype);
	  }if( (eomega->state & PDL_NOMYDIMS) && eomega->trans == NULL ) {
	     eomega->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != eomega->datatype) {
	     eomega = PDL->get_convertedpdl(eomega,__privtrans->__datatype);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
__privtrans->pdls[2] = pi;
__privtrans->pdls[3] = omega;
__privtrans->pdls[4] = o;
__privtrans->pdls[5] = alpha;
__privtrans->pdls[6] = beta;
__privtrans->pdls[7] = ea;
__privtrans->pdls[8] = eb;
__privtrans->pdls[9] = epi;
__privtrans->pdls[10] = eomega;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  ea->state |= PDL_BADVAL;
  eb->state |= PDL_BADVAL;
  epi->state |= PDL_BADVAL;
  eomega->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = ea_SV;
  ST(1) = eb_SV;
  ST(2) = epi_SV;
  ST(3) = eomega_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
hmmexpectq(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *ea_SV;
  SV *eb_SV;
  SV *epi_SV;
  SV *eomega_SV;
  pdl  *a;
  pdl  *b;
  pdl  *pi;
  pdl  *omega;
  pdl  *o;
  pdl  *oq;
  pdl  *alphaq;
  pdl  *betaq;
  pdl  *ea;
  pdl  *eb;
  pdl  *epi;
  pdl  *eomega;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 12) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    omega = PDL->SvPDLV(ST(3));
    o = PDL->SvPDLV(ST(4));
    oq = PDL->SvPDLV(ST(5));
    alphaq = PDL->SvPDLV(ST(6));
    betaq = PDL->SvPDLV(ST(7));
    ea = PDL->SvPDLV(ST(8));
    eb = PDL->SvPDLV(ST(9));
    epi = PDL->SvPDLV(ST(10));
    eomega = PDL->SvPDLV(ST(11));
  }
  else if (items == 8) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 4;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    omega = PDL->SvPDLV(ST(3));
    o = PDL->SvPDLV(ST(4));
    oq = PDL->SvPDLV(ST(5));
    alphaq = PDL->SvPDLV(ST(6));
    betaq = PDL->SvPDLV(ST(7));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       ea_SV = sv_newmortal();
       ea = PDL->null();
       PDL->SetSV_PDL(ea_SV,ea);
       if (bless_stash) ea_SV = sv_bless(ea_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       ea_SV = POPs;
       PUTBACK;
       ea = PDL->SvPDLV(ea_SV);
    }
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       eb_SV = sv_newmortal();
       eb = PDL->null();
       PDL->SetSV_PDL(eb_SV,eb);
       if (bless_stash) eb_SV = sv_bless(eb_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       eb_SV = POPs;
       PUTBACK;
       eb = PDL->SvPDLV(eb_SV);
    }
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       epi_SV = sv_newmortal();
       epi = PDL->null();
       PDL->SetSV_PDL(epi_SV,epi);
       if (bless_stash) epi_SV = sv_bless(epi_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       epi_SV = POPs;
       PUTBACK;
       epi = PDL->SvPDLV(epi_SV);
    }
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       eomega_SV = sv_newmortal();
       eomega = PDL->null();
       PDL->SetSV_PDL(eomega_SV,eomega);
       if (bless_stash) eomega_SV = sv_bless(eomega_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       eomega_SV = POPs;
       PUTBACK;
       eomega = PDL->SvPDLV(eomega_SV);
    }
  }
  else {
    croak ("Usage:  PDL::hmmexpectq(a,b,pi,omega,o,oq,alphaq,betaq,ea,eb,epi,eomega) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_hmmexpectq_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_hmmexpectq_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0) || ((b->state & PDL_BADVAL) > 0) || ((pi->state & PDL_BADVAL) > 0) || ((omega->state & PDL_BADVAL) > 0) || ((o->state & PDL_BADVAL) > 0) || ((oq->state & PDL_BADVAL) > 0) || ((alphaq->state & PDL_BADVAL) > 0) || ((betaq->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(__privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(__privtrans->__datatype < pi->datatype) {
		 	__privtrans->__datatype = pi->datatype;
		    }
if(__privtrans->__datatype < omega->datatype) {
		 	__privtrans->__datatype = omega->datatype;
		    }
if(__privtrans->__datatype < o->datatype) {
		 	__privtrans->__datatype = o->datatype;
		    }
if(__privtrans->__datatype < oq->datatype) {
		 	__privtrans->__datatype = oq->datatype;
		    }
if(__privtrans->__datatype < alphaq->datatype) {
		 	__privtrans->__datatype = alphaq->datatype;
		    }
if(__privtrans->__datatype < betaq->datatype) {
		 	__privtrans->__datatype = betaq->datatype;
		    }
if(!((ea->state & PDL_NOMYDIMS) &&
		       ea->trans == NULL) && __privtrans->__datatype < ea->datatype) {
		 	__privtrans->__datatype = ea->datatype;
		    }
if(!((eb->state & PDL_NOMYDIMS) &&
		       eb->trans == NULL) && __privtrans->__datatype < eb->datatype) {
		 	__privtrans->__datatype = eb->datatype;
		    }
if(!((epi->state & PDL_NOMYDIMS) &&
		       epi->trans == NULL) && __privtrans->__datatype < epi->datatype) {
		 	__privtrans->__datatype = epi->datatype;
		    }
if(!((eomega->state & PDL_NOMYDIMS) &&
		       eomega->trans == NULL) && __privtrans->__datatype < eomega->datatype) {
		 	__privtrans->__datatype = eomega->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }if(__privtrans->__datatype != pi->datatype) {
	     pi = PDL->get_convertedpdl(pi,__privtrans->__datatype);
	  }if(__privtrans->__datatype != omega->datatype) {
	     omega = PDL->get_convertedpdl(omega,__privtrans->__datatype);
	  }if(__privtrans->__datatype != o->datatype) {
	     o = PDL->get_convertedpdl(o,__privtrans->__datatype);
	  }if(__privtrans->__datatype != oq->datatype) {
	     oq = PDL->get_convertedpdl(oq,__privtrans->__datatype);
	  }if(__privtrans->__datatype != alphaq->datatype) {
	     alphaq = PDL->get_convertedpdl(alphaq,__privtrans->__datatype);
	  }if(__privtrans->__datatype != betaq->datatype) {
	     betaq = PDL->get_convertedpdl(betaq,__privtrans->__datatype);
	  }if( (ea->state & PDL_NOMYDIMS) && ea->trans == NULL ) {
	     ea->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != ea->datatype) {
	     ea = PDL->get_convertedpdl(ea,__privtrans->__datatype);
	  }if( (eb->state & PDL_NOMYDIMS) && eb->trans == NULL ) {
	     eb->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != eb->datatype) {
	     eb = PDL->get_convertedpdl(eb,__privtrans->__datatype);
	  }if( (epi->state & PDL_NOMYDIMS) && epi->trans == NULL ) {
	     epi->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != epi->datatype) {
	     epi = PDL->get_convertedpdl(epi,__privtrans->__datatype);
	  }if( (eomega->state & PDL_NOMYDIMS) && eomega->trans == NULL ) {
	     eomega->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != eomega->datatype) {
	     eomega = PDL->get_convertedpdl(eomega,__privtrans->__datatype);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
__privtrans->pdls[2] = pi;
__privtrans->pdls[3] = omega;
__privtrans->pdls[4] = o;
__privtrans->pdls[5] = oq;
__privtrans->pdls[6] = alphaq;
__privtrans->pdls[7] = betaq;
__privtrans->pdls[8] = ea;
__privtrans->pdls[9] = eb;
__privtrans->pdls[10] = epi;
__privtrans->pdls[11] = eomega;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  ea->state |= PDL_BADVAL;
  eb->state |= PDL_BADVAL;
  epi->state |= PDL_BADVAL;
  eomega->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = ea_SV;
  ST(1) = eb_SV;
  ST(2) = epi_SV;
  ST(3) = eomega_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
hmmviterbi(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *delta_SV;
  SV *psi_SV;
  pdl  *a;
  pdl  *b;
  pdl  *pi;
  pdl  *o;
  pdl  *delta;
  pdl  *psi;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 6) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    delta = PDL->SvPDLV(ST(4));
    psi = PDL->SvPDLV(ST(5));
  }
  else if (items == 4) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 2;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       delta_SV = sv_newmortal();
       delta = PDL->null();
       PDL->SetSV_PDL(delta_SV,delta);
       if (bless_stash) delta_SV = sv_bless(delta_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       delta_SV = POPs;
       PUTBACK;
       delta = PDL->SvPDLV(delta_SV);
    }
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       psi_SV = sv_newmortal();
       psi = PDL->null();
       PDL->SetSV_PDL(psi_SV,psi);
       if (bless_stash) psi_SV = sv_bless(psi_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       psi_SV = POPs;
       PUTBACK;
       psi = PDL->SvPDLV(psi_SV);
    }
  }
  else {
    croak ("Usage:  PDL::hmmviterbi(a,b,pi,o,delta,psi) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_hmmviterbi_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_hmmviterbi_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0) || ((b->state & PDL_BADVAL) > 0) || ((pi->state & PDL_BADVAL) > 0) || ((o->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(__privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(__privtrans->__datatype < pi->datatype) {
		 	__privtrans->__datatype = pi->datatype;
		    }
if(__privtrans->__datatype < o->datatype) {
		 	__privtrans->__datatype = o->datatype;
		    }
if(!((delta->state & PDL_NOMYDIMS) &&
		       delta->trans == NULL) && __privtrans->__datatype < delta->datatype) {
		 	__privtrans->__datatype = delta->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }if(__privtrans->__datatype != pi->datatype) {
	     pi = PDL->get_convertedpdl(pi,__privtrans->__datatype);
	  }if(__privtrans->__datatype != o->datatype) {
	     o = PDL->get_convertedpdl(o,__privtrans->__datatype);
	  }if( (delta->state & PDL_NOMYDIMS) && delta->trans == NULL ) {
	     delta->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != delta->datatype) {
	     delta = PDL->get_convertedpdl(delta,__privtrans->__datatype);
	  }if( (psi->state & PDL_NOMYDIMS) && psi->trans == NULL ) {
	     psi->datatype = PDL_L;
	  } else if(PDL_L != psi->datatype) {
	     psi = PDL->get_convertedpdl(psi,PDL_L);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
__privtrans->pdls[2] = pi;
__privtrans->pdls[3] = o;
__privtrans->pdls[4] = delta;
__privtrans->pdls[5] = psi;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  delta->state |= PDL_BADVAL;
  psi->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = delta_SV;
  ST(1) = psi_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
hmmviterbiq(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *deltaq_SV;
  SV *psiq_SV;
  pdl  *a;
  pdl  *b;
  pdl  *pi;
  pdl  *o;
  pdl  *oq;
  pdl  *deltaq;
  pdl  *psiq;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 7) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    oq = PDL->SvPDLV(ST(4));
    deltaq = PDL->SvPDLV(ST(5));
    psiq = PDL->SvPDLV(ST(6));
  }
  else if (items == 5) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 2;
    a = PDL->SvPDLV(ST(0));
    b = PDL->SvPDLV(ST(1));
    pi = PDL->SvPDLV(ST(2));
    o = PDL->SvPDLV(ST(3));
    oq = PDL->SvPDLV(ST(4));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       deltaq_SV = sv_newmortal();
       deltaq = PDL->null();
       PDL->SetSV_PDL(deltaq_SV,deltaq);
       if (bless_stash) deltaq_SV = sv_bless(deltaq_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       deltaq_SV = POPs;
       PUTBACK;
       deltaq = PDL->SvPDLV(deltaq_SV);
    }
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       psiq_SV = sv_newmortal();
       psiq = PDL->null();
       PDL->SetSV_PDL(psiq_SV,psiq);
       if (bless_stash) psiq_SV = sv_bless(psiq_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       psiq_SV = POPs;
       PUTBACK;
       psiq = PDL->SvPDLV(psiq_SV);
    }
  }
  else {
    croak ("Usage:  PDL::hmmviterbiq(a,b,pi,o,oq,deltaq,psiq) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_hmmviterbiq_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_hmmviterbiq_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((a->state & PDL_BADVAL) > 0) || ((b->state & PDL_BADVAL) > 0) || ((pi->state & PDL_BADVAL) > 0) || ((o->state & PDL_BADVAL) > 0) || ((oq->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < a->datatype) {
		 	__privtrans->__datatype = a->datatype;
		    }
if(__privtrans->__datatype < b->datatype) {
		 	__privtrans->__datatype = b->datatype;
		    }
if(__privtrans->__datatype < pi->datatype) {
		 	__privtrans->__datatype = pi->datatype;
		    }
if(__privtrans->__datatype < o->datatype) {
		 	__privtrans->__datatype = o->datatype;
		    }
if(__privtrans->__datatype < oq->datatype) {
		 	__privtrans->__datatype = oq->datatype;
		    }
if(!((deltaq->state & PDL_NOMYDIMS) &&
		       deltaq->trans == NULL) && __privtrans->__datatype < deltaq->datatype) {
		 	__privtrans->__datatype = deltaq->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != a->datatype) {
	     a = PDL->get_convertedpdl(a,__privtrans->__datatype);
	  }if(__privtrans->__datatype != b->datatype) {
	     b = PDL->get_convertedpdl(b,__privtrans->__datatype);
	  }if(__privtrans->__datatype != pi->datatype) {
	     pi = PDL->get_convertedpdl(pi,__privtrans->__datatype);
	  }if(__privtrans->__datatype != o->datatype) {
	     o = PDL->get_convertedpdl(o,__privtrans->__datatype);
	  }if(__privtrans->__datatype != oq->datatype) {
	     oq = PDL->get_convertedpdl(oq,__privtrans->__datatype);
	  }if( (deltaq->state & PDL_NOMYDIMS) && deltaq->trans == NULL ) {
	     deltaq->datatype = __privtrans->__datatype;
	  } else if(__privtrans->__datatype != deltaq->datatype) {
	     deltaq = PDL->get_convertedpdl(deltaq,__privtrans->__datatype);
	  }if( (psiq->state & PDL_NOMYDIMS) && psiq->trans == NULL ) {
	     psiq->datatype = PDL_L;
	  } else if(PDL_L != psiq->datatype) {
	     psiq = PDL->get_convertedpdl(psiq,PDL_L);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = a;
__privtrans->pdls[1] = b;
__privtrans->pdls[2] = pi;
__privtrans->pdls[3] = o;
__privtrans->pdls[4] = oq;
__privtrans->pdls[5] = deltaq;
__privtrans->pdls[6] = psiq;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  deltaq->state |= PDL_BADVAL;
  psiq->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = deltaq_SV;
  ST(1) = psiq_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
hmmpath(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *path_SV;
  pdl  *psi;
  pdl  *qfinal;
  pdl  *path;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 3) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    psi = PDL->SvPDLV(ST(0));
    qfinal = PDL->SvPDLV(ST(1));
    path = PDL->SvPDLV(ST(2));
  }
  else if (items == 2) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 1;
    psi = PDL->SvPDLV(ST(0));
    qfinal = PDL->SvPDLV(ST(1));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       path_SV = sv_newmortal();
       path = PDL->null();
       PDL->SetSV_PDL(path_SV,path);
       if (bless_stash) path_SV = sv_bless(path_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       path_SV = POPs;
       PUTBACK;
       path = PDL->SvPDLV(path_SV);
    }
  }
  else {
    croak ("Usage:  PDL::hmmpath(psi,qfinal,path) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_hmmpath_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_hmmpath_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((psi->state & PDL_BADVAL) > 0) || ((qfinal->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < psi->datatype) {
		 	__privtrans->__datatype = psi->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != psi->datatype) {
	     psi = PDL->get_convertedpdl(psi,__privtrans->__datatype);
	  }if(PDL_L != qfinal->datatype) {
	     qfinal = PDL->get_convertedpdl(qfinal,PDL_L);
	  }if( (path->state & PDL_NOMYDIMS) && path->trans == NULL ) {
	     path->datatype = PDL_L;
	  } else if(PDL_L != path->datatype) {
	     path = PDL->get_convertedpdl(path,PDL_L);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = psi;
__privtrans->pdls[1] = qfinal;
__privtrans->pdls[2] = path;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  path->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = path_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}

void
hmmpathq(...)
 PREINIT:
  char *objname = "PDL"; /* XXX maybe that class should actually depend on the value set
                            by pp_bless ? (CS) */
  HV *bless_stash = 0;
  SV *parent = 0;
  int   nreturn;
  SV *path_SV;
  pdl  *oq;
  pdl  *psiq;
  pdl  *qfinalq;
  pdl  *path;
 PPCODE:
{
  PDL_COMMENT("Check if you can get a package name for this input value.  ")
  PDL_COMMENT("It can be either a PDL (SVt_PVMG) or a hash which is a     ")
  PDL_COMMENT("derived PDL subclass (SVt_PVHV)                            ")
  if (SvROK(ST(0)) && ((SvTYPE(SvRV(ST(0))) == SVt_PVMG) || (SvTYPE(SvRV(ST(0))) == SVt_PVHV))) {
    parent = ST(0);
    if (sv_isobject(parent)){
	bless_stash = SvSTASH(SvRV(ST(0)));
	objname = HvNAME((bless_stash));  PDL_COMMENT("The package to bless output vars into is taken from the first input var")
    }
  }
  if (items == 4) { PDL_COMMENT("all variables on stack, read in output and temp vars")
    nreturn = 0;
    oq = PDL->SvPDLV(ST(0));
    psiq = PDL->SvPDLV(ST(1));
    qfinalq = PDL->SvPDLV(ST(2));
    path = PDL->SvPDLV(ST(3));
  }
  else if (items == 3) { PDL_COMMENT("only input variables on stack, create outputs and temps")
    nreturn = 1;
    oq = PDL->SvPDLV(ST(0));
    psiq = PDL->SvPDLV(ST(1));
    qfinalq = PDL->SvPDLV(ST(2));
    if (strcmp(objname,"PDL") == 0) { PDL_COMMENT("shortcut if just PDL")
       path_SV = sv_newmortal();
       path = PDL->null();
       PDL->SetSV_PDL(path_SV,path);
       if (bless_stash) path_SV = sv_bless(path_SV, bless_stash);
    } else {
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(objname, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       path_SV = POPs;
       PUTBACK;
       path = PDL->SvPDLV(path_SV);
    }
  }
  else {
    croak ("Usage:  PDL::hmmpathq(oq,psiq,qfinalq,path) (you may leave temporaries or output variables out of list)");
  }
}
{
}
 { pdl_hmmpathq_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_hmmpathq_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((oq->state & PDL_BADVAL) > 0) || ((psiq->state & PDL_BADVAL) > 0) || ((qfinalq->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < oq->datatype) {
		 	__privtrans->__datatype = oq->datatype;
		    }
if(__privtrans->__datatype < psiq->datatype) {
		 	__privtrans->__datatype = psiq->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_N) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != oq->datatype) {
	     oq = PDL->get_convertedpdl(oq,__privtrans->__datatype);
	  }if(__privtrans->__datatype != psiq->datatype) {
	     psiq = PDL->get_convertedpdl(psiq,__privtrans->__datatype);
	  }if(PDL_L != qfinalq->datatype) {
	     qfinalq = PDL->get_convertedpdl(qfinalq,PDL_L);
	  }if( (path->state & PDL_NOMYDIMS) && path->trans == NULL ) {
	     path->datatype = PDL_L;
	  } else if(PDL_L != path->datatype) {
	     path = PDL->get_convertedpdl(path,PDL_L);
	  }{}PDL_COMMENT("No flow")__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = oq;
__privtrans->pdls[1] = psiq;
__privtrans->pdls[2] = qfinalq;
__privtrans->pdls[3] = path;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
  path->state |= PDL_BADVAL;
}
if (nreturn) {
  if (nreturn - items > 0) EXTEND (SP, nreturn - items);
  ST(0) = path_SV;
  XSRETURN(nreturn);
} else {
  XSRETURN(0);
}
}


BOOT:

   PDL_COMMENT("Get pointer to structure of core shared C routines")
   PDL_COMMENT("make sure PDL::Core is loaded")
   
   perl_require_pv ("PDL/Core.pm"); /* make sure PDL::Core is loaded */
#ifndef aTHX_
#define aTHX_
#endif
   if (SvTRUE (ERRSV)) Perl_croak(aTHX_ "%s",SvPV_nolen (ERRSV));
   CoreSV = perl_get_sv("PDL::SHARE",FALSE);  /* SV* value */
   if (CoreSV==NULL)
     Perl_croak(aTHX_ "We require the PDL::Core module, which was not found");
   PDL = INT2PTR(Core*,SvIV( CoreSV ));  /* Core* value */
   if (PDL->Version != PDL_CORE_VERSION)
     Perl_croak(aTHX_ "[PDL->Version: %d PDL_CORE_VERSION: %d XS_VERSION: %s] PDL::HMM needs to be recompiled against the newly installed PDL", PDL->Version, PDL_CORE_VERSION, XS_VERSION);


                 
